LIBRARY IEEE;
USE IEEE.std_logic_1164.all; 
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;
LIBRARY UNISIM;
USE UNISIM.vcomponents.all;
LIBRARY UNIMACRO;
USE UNIMACRO.vcomponents.all;
LIBRARY work;
USE work.Latches_Flipflops.all;

ENTITY DMB_V6 IS 
	PORT
	(

-- From/To VME connector To/From DAQMBV

		vme_data : INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);		-- OK		d(15 DOWNTO 0)
		vme_addr : IN STD_LOGIC_VECTOR(23 DOWNTO 1);			-- OK		a(23 DOWNTO 1)
		vme_am : IN STD_LOGIC_VECTOR(5 DOWNTO 0);				-- OK		am(6 DOWNTO 0)
		vme_gap : IN STD_LOGIC;										-- OK		gap = ga(5)
		vme_ga : IN STD_LOGIC_VECTOR(4 DOWNTO 0);				-- OK		ga(4 DOWNTO 0)
		vme_bg0 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg1 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg2 : IN STD_LOGIC;										-- OK		NEW!
		vme_bg3 : IN STD_LOGIC;										-- OK		NEW!
		vme_as_b : IN STD_LOGIC;									-- OK		as*
		vme_ds_b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);			-- OK		ds1*,ds0*
		vme_sysreset_b : IN STD_LOGIC;							-- OK		sysreset*
		vme_sysfail_b : IN STD_LOGIC;								-- OK		sysfail*
		vme_sysfail_out : OUT STD_LOGIC;							-- OK		NEW!
		vme_berr_b : IN STD_LOGIC;									-- OK		berr*
		vme_berr_out : OUT STD_LOGIC;								-- OK		NEW!
		vme_iack_b : IN STD_LOGIC;									-- OK		iack*
		vme_lword_b : IN STD_LOGIC;								-- OK		lword*
		vme_write_b : IN STD_LOGIC;								-- OK		write*
		vme_clk : IN STD_LOGIC;										-- OK		???
		vme_dtack_v6_b : INOUT STD_LOGIC;							-- OK		dtack*
-- bgb		vme_tovme_b : OUT STD_LOGIC;									-- OK		not (tovme)
		vme_tovme : OUT STD_LOGIC;									-- OK		not (tovme)
--Changed for 904 use		
		--vme_doe : OUT STD_LOGIC;									-- OK		not (doe*)
		vme_doe_b : OUT STD_LOGIC;									-- OK		not (doe*)

-- From/To J6 (J3) connector to DMB_CTRL

		ccb_cmd : IN STD_LOGIC_VECTOR(5 DOWNTO 0);			-- OK		ccbcmnd(5 DOWNTO 0)
		ccb_cmd_s : IN STD_LOGIC;									-- OK		ccbcmnd(6)
		ccb_data : IN STD_LOGIC_VECTOR(7 DOWNTO 0);			-- OK		ccbdata(7 DOWNTO 0)
		ccb_data_s : IN STD_LOGIC;									-- OK		ccbdata(8)
		ccb_cal : IN STD_LOGIC_VECTOR(2 DOWNTO 0);			-- OK		ccbcal(14 DOWNTO 12)
		ccb_crsv : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		nc (J3/B2), ccbrsv(3 DOWNTO 0) = crsv(3 DOWNTO 0)
		ccb_drsv : IN STD_LOGIC_VECTOR(1 DOWNTO 0);			-- OK		ccbrsv(5 DOWNTO 4) = drsv(1 DOWNTO 0)
		ccb_rsvo : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		nc (J3/A21), ccbsrv(10 DOWNTO 7) = rsvo(3 DOWNTO 0)
		ccb_rsvi : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);			-- OK		ccbsrv(14 DOWNTO 12)
		ccb_bx0 : IN STD_LOGIC;										-- OK		bx0
		ccb_bxrst : IN STD_LOGIC;									-- OK		bxrst
		ccb_l1arst : IN STD_LOGIC;									-- OK		l1arst
		ccb_l1acc : IN STD_LOGIC;									-- OK		l1acc
		ccb_l1rls : OUT STD_LOGIC;									-- OK		l1rls
		ccb_clken : IN STD_LOGIC;									-- OK		clkena

		ccb_hardrst : IN STD_LOGIC;								-- OK		
		ccb_softrst : IN STD_LOGIC;								-- OK		

-- From J6/J7 (J3/J4) to FIFOs

		tmb : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				-- OK		f6di(17 DOWNTO 0)
		alct : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				-- OK		f7di(17 DOWNTO 0)
		rawlct : IN STD_LOGIC_VECTOR(5 DOWNTO 0);				-- OK		???
		tmbffclk : IN STD_LOGIC;									-- OK		tmbffclk

-- From/To J3/J4 t/fromo DMB_CTRL

		lctdav1 : IN STD_LOGIC;										-- OK		lctdav1
		lctdav2 : IN STD_LOGIC;										-- OK		lctdav2
--		rsvtd : INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);			
		rsvtd_in : IN STD_LOGIC_VECTOR(4 DOWNTO 0);			-- OK		rstvd(7 DOWNTO 4)
		rsvtd_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);		-- OK		rstvd(2 DOWNTO 0)
		lctrqst : OUT STD_LOGIC_VECTOR(2 DOWNTO 1);			-- OK		lctrqst(2 DOWNTO 1)


-- From/To QPLL (From/To DAQMBV)

		qpll_autorestart : OUT STD_LOGIC;						-- OK		NEW!
		qpll_mode : OUT STD_LOGIC;									-- OK		NEW!
		qpll_extcontrol : OUT STD_LOGIC;							-- OK		NEW!
		qpll_reset : OUT STD_LOGIC;								-- OK		NEW!
		qpll_f0sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);		-- OK		NEW!
		qpll_locked : IN STD_LOGIC;								-- OK		NEW!
		qpll_error : IN STD_LOGIC;									-- OK		NEW!

		qpll_clk40MHz_p : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk40MHz_n : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk80MHz_p : IN STD_LOGIC;							-- OK		NEW!
		qpll_clk80MHz_n : IN STD_LOGIC;							-- OK		NEW!
--		qpll_clk160MHz_p : IN STD_LOGIC;							-- NEW!
--		qpll_clk160MHz_n : IN STD_LOGIC;							-- NEW!
		
-- From/To LVMB (From/To DAQMBV and DAQMBC)

		lvmb_pon : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);		-- OK		pwon(6 DOWNTO 1)
		pon_load : OUT STD_LOGIC;								-- OK		loadpwon
		pon_en : OUT STD_LOGIC;									-- OK		pwon_en*
		r_lvmb_pon : IN STD_LOGIC_VECTOR(7 DOWNTO 0);	-- OK		multi(6 DOWNTO 1) (r_pwon(6 DOWNTO 1))
		lvmb_csb : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);		-- OK		multi(13 DOWNTO 7)
		lvmb_sclk : OUT STD_LOGIC;								-- OK		multi(14)
		lvmb_sdin : OUT STD_LOGIC;								-- OK		multi(15)
		lvmb_sdout : OUT STD_LOGIC;							-- OK		multi(16)

-- From/To ADC (From/To DAQMBV)

		adc_sclk : OUT STD_LOGIC;						-- OK		NEW!
		adc_sdain : OUT STD_LOGIC;						-- OK		NEW!
		adc_sdaout : IN STD_LOGIC;						-- OK		NEW!
		adc_cs : OUT STD_LOGIC;							-- OK		NEW!

-- From/To DAC (From/To DAQMBV)

		dac_sclk : OUT STD_LOGIC;						-- OK		NEW!
		dac_sdain : OUT STD_LOGIC;						-- OK		NEW!
		dac_sdaout : IN STD_LOGIC;						-- OK		NEW!
		dac_cs : OUT STD_LOGIC;							-- OK		NEW!

-- To LEDs

		leds : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);	-- OK		NEW!	

-- To Frequency Divider FF

		fd_pre : OUT STD_LOGIC;							-- OK		NEW!	
		fd_clr : OUT STD_LOGIC;							-- OK		NEW!	

-- From Push Buttons

		pb : IN STD_LOGIC_VECTOR(3 DOWNTO 0);		-- OK

-- From/To Test Connector for Single-Ended signals

		d : INOUT STD_LOGIC_VECTOR(63 DOWNTO 0);	-- OK		

-- From/To Test Connector J3 for LVDS signals

		gtx_0_p : IN STD_LOGIC;					-- OK			
		gtx_0_n : IN STD_LOGIC;					-- OK			
		grx_0_p : OUT STD_LOGIC;				-- OK (out)			
		grx_0_n : OUT STD_LOGIC;				-- OK (out)			

		ck_0_p : IN STD_LOGIC;					-- OK			
		ck_0_n : IN STD_LOGIC;					-- OK			
		ck_1_p : IN STD_LOGIC;					-- OK			
		ck_1_n : IN STD_LOGIC;					-- OK			
		tclk_p : IN STD_LOGIC;					-- OK			
		tclk_n : IN STD_LOGIC;					-- OK			
		rxb_p : OUT STD_LOGIC;					-- OK			
		rxb_n : OUT STD_LOGIC;					-- OK			
		
		tx_0_p : OUT STD_LOGIC;					-- OK			
		tx_0_n : OUT STD_LOGIC;					-- OK			
		tx_1_p : OUT STD_LOGIC;					-- OK			
		tx_1_n : OUT STD_LOGIC;					-- OK			
		tx_2_p : OUT STD_LOGIC;					-- OK			
		tx_2_n : OUT STD_LOGIC;					-- OK			
		tx_3_p : OUT STD_LOGIC;					-- OK			
		tx_3_n : OUT STD_LOGIC;					-- OK			
		tx_4_p : OUT STD_LOGIC;					-- OK			
		tx_4_n : OUT STD_LOGIC;					-- OK			
		tx_5_p : OUT STD_LOGIC;					-- OK			
		tx_5_n : OUT STD_LOGIC;					-- OK			
		tx_6_p : OUT STD_LOGIC;					-- OK			
		tx_6_n : OUT STD_LOGIC;					-- OK			
		tx_7_p : OUT STD_LOGIC;					-- OK			
		tx_7_n : OUT STD_LOGIC;					-- OK			
		tx_8_p : OUT STD_LOGIC;					-- OK			
		tx_8_n : OUT STD_LOGIC;					-- OK			
		tx_9_p : OUT STD_LOGIC;					-- OK			
		tx_9_n : OUT STD_LOGIC;					-- OK			
		tx_10_p : OUT STD_LOGIC;				-- OK			
		tx_10_n : OUT STD_LOGIC;				-- OK			

		rx_0_p : IN STD_LOGIC;					-- OK		
		rx_0_n : IN STD_LOGIC;					-- OK			
		rx_1_p : IN STD_LOGIC;					-- OK				
		rx_1_n : IN STD_LOGIC;					-- OK				
		rx_2_p : IN STD_LOGIC;					-- OK				
		rx_2_n : IN STD_LOGIC;					-- OK				
		rx_3_p : IN STD_LOGIC;					-- OK				
		rx_3_n : IN STD_LOGIC;					-- OK				
		rx_4_p : IN STD_LOGIC;					-- OK			
		rx_4_n : IN STD_LOGIC;					-- OK			
		rx_5_p : IN STD_LOGIC;					-- OK				
		rx_5_n : IN STD_LOGIC;					-- OK				
		rx_6_p : IN STD_LOGIC;					-- OK				
		rx_6_n : IN STD_LOGIC;					-- OK				
		rx_7_p : IN STD_LOGIC;					-- OK				
		rx_7_n : IN STD_LOGIC;					-- OK				
		rx_8_p : IN STD_LOGIC;					-- OK			
		rx_8_n : IN STD_LOGIC;					-- OK			
		rx_9_p : IN STD_LOGIC;					-- OK				
		rx_9_n : IN STD_LOGIC;					-- OK				
		rx_10_p : IN STD_LOGIC;					-- OK				
		rx_10_n : IN STD_LOGIC;					-- OK				

-- To/From TX1 

		otx1_01_p : OUT  STD_LOGIC;			-- OK	
		otx1_01_n : OUT  STD_LOGIC;			-- OK	
		otx1_02_p : OUT  STD_LOGIC;			-- OK	
		otx1_02_n : OUT  STD_LOGIC;			-- OK	
		otx1_03_p : OUT  STD_LOGIC;			-- OK	
		otx1_03_n : OUT  STD_LOGIC;			-- OK	
		otx1_04_p : OUT  STD_LOGIC;			-- OK	
		otx1_04_n : OUT  STD_LOGIC;			-- OK	
		otx1_05_p : OUT  STD_LOGIC;			-- OK	
		otx1_05_n : OUT  STD_LOGIC;			-- OK	
		otx1_06_p : OUT  STD_LOGIC;			-- OK	
		otx1_06_n : OUT  STD_LOGIC;			-- OK	
		otx1_07_p : OUT  STD_LOGIC;			-- OK	
		otx1_07_n : OUT  STD_LOGIC;			-- OK	
		otx1_08_p : OUT  STD_LOGIC;			-- OK	
		otx1_08_n : OUT  STD_LOGIC;			-- OK
		otx1_09_p : OUT  STD_LOGIC;			-- OK	
		otx1_09_n : OUT  STD_LOGIC;			-- OK	
		otx1_10_p : OUT  STD_LOGIC;			-- OK	
		otx1_10_n : OUT  STD_LOGIC;			-- OK	
		otx1_11_p : OUT  STD_LOGIC;			-- OK	
		otx1_11_n : OUT  STD_LOGIC;			-- OK	
		otx1_12_p : OUT  STD_LOGIC;			-- OK	
		otx1_12_n : OUT  STD_LOGIC;			-- OK	

		otx1_tx_en : OUT  STD_LOGIC;			-- OK
		otx1_tx_dis : OUT  STD_LOGIC;			-- OK
		otx1_reset : OUT  STD_LOGIC;			-- OK
		otx1_fault : IN  STD_LOGIC;			-- OK
		
-- To/From TX2 

		otx2_01_p : OUT  STD_LOGIC;			-- OK	
		otx2_01_n : OUT  STD_LOGIC;			-- OK	
		otx2_02_p : OUT  STD_LOGIC;			-- OK	
		otx2_02_n : OUT  STD_LOGIC;			-- OK	
		otx2_03_p : OUT  STD_LOGIC;			-- OK	
		otx2_03_n : OUT  STD_LOGIC;			-- OK	
		otx2_04_p : OUT  STD_LOGIC;			-- OK	
		otx2_04_n : OUT  STD_LOGIC;			-- OK	
		otx2_05_p : OUT  STD_LOGIC;			-- OK	
		otx2_05_n : OUT  STD_LOGIC;			-- OK	
		otx2_06_p : OUT  STD_LOGIC;			-- OK	
		otx2_06_n : OUT  STD_LOGIC;			-- OK	
		otx2_07_p : OUT  STD_LOGIC;			-- OK	
		otx2_07_n : OUT  STD_LOGIC;			-- OK	
		otx2_08_p : OUT  STD_LOGIC;			-- OK	
		otx2_08_n : OUT  STD_LOGIC;			-- OK	
		otx2_09_p : OUT  STD_LOGIC;			-- OK	
		otx2_09_n : OUT  STD_LOGIC;			-- OK	
		otx2_10_p : OUT  STD_LOGIC;			-- OK	
		otx2_10_n : OUT  STD_LOGIC;			-- OK	
		otx2_11_p : OUT  STD_LOGIC;			-- OK	
		otx2_11_n : OUT  STD_LOGIC;			-- OK	
		otx2_12_p : OUT  STD_LOGIC;			-- OK	
		otx2_12_n : OUT  STD_LOGIC;			-- OK	

		otx2_tx_en : OUT  STD_LOGIC;			-- OK	
		otx2_tx_dis : OUT  STD_LOGIC;			-- OK	
		otx2_reset : OUT  STD_LOGIC;			-- OK	
		otx2_fault : IN  STD_LOGIC;			-- OK	

-- From/To RX1 

		orx1_01_p : IN  STD_LOGIC;				-- OK		
		orx1_01_n : IN  STD_LOGIC;				-- OK		
		orx1_02_p : IN  STD_LOGIC;				-- OK	
		orx1_02_n : IN  STD_LOGIC;				-- OK
		orx1_03_p : IN  STD_LOGIC;				-- OK
		orx1_03_n : IN  STD_LOGIC;				-- OK
		orx1_04_p : IN  STD_LOGIC;				-- OK
		orx1_04_n : IN  STD_LOGIC;				-- OK
		orx1_05_p : IN  STD_LOGIC;				-- OK
		orx1_05_n : IN  STD_LOGIC;				-- OK
		orx1_06_p : IN  STD_LOGIC;				-- OK
		orx1_06_n : IN  STD_LOGIC;				-- OK
		orx1_07_p : IN  STD_LOGIC;				-- OK
		orx1_07_n : IN  STD_LOGIC;				-- OK
		orx1_08_p : IN  STD_LOGIC;				-- OK
		orx1_08_n : IN  STD_LOGIC;				-- OK
		orx1_09_p : IN  STD_LOGIC;				-- OK
		orx1_09_n : IN  STD_LOGIC;				-- OK
		orx1_10_p : IN  STD_LOGIC;				-- OK
		orx1_10_n : IN  STD_LOGIC;				-- OK
		orx1_11_p : IN  STD_LOGIC;				-- OK
		orx1_11_n : IN  STD_LOGIC;				-- OK
		orx1_12_p : IN  STD_LOGIC;				-- OK
		orx1_12_n : IN  STD_LOGIC;				-- OK

		orx1_rx_en : OUT  STD_LOGIC;			-- OK
		orx1_en_sd : OUT  STD_LOGIC;			-- OK
		orx1_sd : IN  STD_LOGIC;				-- OK
		orx1_sq_en : OUT  STD_LOGIC;			-- OK

-- From/To RX2 

		orx2_01_p : IN  STD_LOGIC;				-- OK		
		orx2_01_n : IN  STD_LOGIC;				-- OK	
		orx2_02_p : IN  STD_LOGIC;				-- OK	
		orx2_02_n : IN  STD_LOGIC;				-- OK	
		orx2_03_p : IN  STD_LOGIC;				-- OK	
		orx2_03_n : IN  STD_LOGIC;				-- OK	
		orx2_04_p : IN  STD_LOGIC;				-- OK	
		orx2_04_n : IN  STD_LOGIC;				-- OK	
		orx2_05_p : IN  STD_LOGIC;				-- OK	
		orx2_05_n : IN  STD_LOGIC;				-- OK	
		orx2_06_p : IN  STD_LOGIC;				-- OK	
		orx2_06_n : IN  STD_LOGIC;				-- OK	
		orx2_07_p : IN  STD_LOGIC;				-- OK	
		orx2_07_n : IN  STD_LOGIC;				-- OK	
		orx2_08_p : IN  STD_LOGIC;				-- OK	
		orx2_08_n : IN  STD_LOGIC;				-- OK	
		orx2_09_p : IN  STD_LOGIC;				-- OK	
		orx2_09_n : IN  STD_LOGIC;				-- OK	
		orx2_10_p : IN  STD_LOGIC;				-- OK	
		orx2_10_n : IN  STD_LOGIC;				-- OK	
		orx2_11_p : IN  STD_LOGIC;				-- OK	
		orx2_11_n : IN  STD_LOGIC;				-- OK	
		orx2_12_p : IN  STD_LOGIC;				-- OK	
		orx2_12_n : IN  STD_LOGIC;				-- OK	

		orx2_rx_en : OUT  STD_LOGIC;			-- OK	
		orx2_en_sd : OUT  STD_LOGIC;			-- OK	
		orx2_sd : IN  STD_LOGIC;				-- OK	
		orx2_sq_en : OUT  STD_LOGIC;			-- OK	

-- From/To OT1 (GigaBit Link)

		gl0_tx_p : OUT  STD_LOGIC;				-- OK
		gl0_tx_n : OUT  STD_LOGIC;				-- OK
		gl0_rx_p : IN  STD_LOGIC;				-- OK
		gl0_rx_n : IN  STD_LOGIC;				-- OK

-- From/To OT2 (GigaBit Link)

		gl1_tx_p : OUT  STD_LOGIC;				-- OK
		gl1_tx_n : OUT  STD_LOGIC;				-- OK
		gl1_rx_p : IN  STD_LOGIC;				-- OK
		gl1_rx_n : IN  STD_LOGIC;				-- OK

-- From IC7 (Clock Driver CDC)

		cdc_clk_0_p : IN  STD_LOGIC;			-- OK
		cdc_clk_0_n : IN  STD_LOGIC;			-- OK
		cdc_clk_1_p : IN  STD_LOGIC;			-- OK
		cdc_clk_1_n : IN  STD_LOGIC;			-- OK
		cdc_clk_2_p : IN  STD_LOGIC;			-- OK
		cdc_clk_2_n : IN  STD_LOGIC;			-- OK
		cdc_clk_3_p : IN  STD_LOGIC;			-- OK
		cdc_clk_3_n : IN  STD_LOGIC;			-- OK
		cdc_clk_4_p : IN  STD_LOGIC;			-- OK
		cdc_clk_4_n : IN  STD_LOGIC;			-- OK
		cdc_clk_5_p : IN  STD_LOGIC;			-- OK
		cdc_clk_5_n : IN  STD_LOGIC;			-- OK
		cdc_clk_6_p : IN  STD_LOGIC;			-- OK
		cdc_clk_6_n : IN  STD_LOGIC;			-- OK
		cdc_clk_7_p : IN  STD_LOGIC;			-- OK
		cdc_clk_7_n : IN  STD_LOGIC;			-- OK

-- From IC31 

		gl0_clk : IN  STD_LOGIC;				-- OK
		gl1_clk : IN  STD_LOGIC;				-- OK
		
		done_in : IN  STD_LOGIC 

-- Configuration (FPGA inputs) 

-- Guido program_b :  IN  STD_LOGIC;
-- Guido init_b :  IN  STD_LOGIC;
-- Guido m2 :  IN  STD_LOGIC;
-- Guido m1 :  IN  STD_LOGIC;
-- Guido m0 :  IN  STD_LOGIC;
-- Guido prom_d :  IN  STD_LOGIC_VECTOR (15 downto 0);		-- ok
-- Guido tdi :  IN  STD_LOGIC;
-- Guido tms :  IN  STD_LOGIC;
-- Guido tck :  IN  STD_LOGIC;

-- Configuration (FPGA outputs) 

-- Guido tdo :  OUT  STD_LOGIC;
-- Guido prom_a :  OUT  STD_LOGIC_VECTOR (22 downto 0);
-- Guido prom_cs_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_oe_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_we_b :  OUT  STD_LOGIC;								-- ok
-- Guido prom_le_b :  OUT  STD_LOGIC;								-- ok
-- Guido cclk :  INOUT  STD_LOGIC;
-- Guido done :  OUT  STD_LOGIC

	);
END DMB_V6;

ARCHITECTURE bdf_type OF DMB_V6 IS 

-- bgb 
-- bgb  Added Chip Scope Pro Controller
-- bgb 
component csp_control_j3
  PORT (
    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL2 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL3 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL4 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0)
	 );

end component;

-- Synplicity black box declaration
attribute syn_black_box : boolean;
attribute syn_black_box of csp_control_j3: component is true;

-- bgb 
-- bgb End of Chip Scope Pro Control declaration
-- bgb 





COMPONENT LVMB_ADC_SDO_MUX IS
	port (

		adc_sdo : IN STD_LOGIC_VECTOR(6 downto 0);
		adc_ce : IN STD_LOGIC_VECTOR(6 downto 0);
		sdo : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT LVMB_ADC IS
	port (

		scl : IN STD_LOGIC;
		sdi : IN STD_LOGIC;
		sdo : INOUT STD_LOGIC;
		ce : IN STD_LOGIC;
		rst : IN STD_LOGIC;
		device : IN STD_LOGIC_VECTOR(3 downto 0)
	);
END COMPONENT;


COMPONENT DCFEB_V6 is
  port (

    CSP_DCFEB_LA_CTRL: inout std_logic_vector(35 downto 0);      -- bgb
    CSP_JTAG_SIM_LA_CTRL: inout std_logic_vector(35 downto 0);      -- bgb
	 VME_LA_TRG: in std_logic;
    FASTCLK : in std_logic;
 		adc_mask: INOUT STD_LOGIC_VECTOR(11 downto 0);
		
	   trst : IN STD_LOGIC;
	   tck : IN STD_LOGIC;
 		tms : IN STD_LOGIC;
 		tdi : IN STD_LOGIC;
		rtn_shft_en : OUT STD_LOGIC;
  		tdo : INOUT STD_LOGIC);

end COMPONENT;

COMPONENT dmb_ctrl IS
	port (

		ccb_cmd : IN STD_LOGIC_VECTOR (5 downto 0);				-- ccbcmnd(5 downto 0) - from J3
		ccb_cmd_s : IN STD_LOGIC;										-- ccbcmnd(6) - from J3
		ccb_data : IN STD_LOGIC_VECTOR (7 downto 0);				-- ccbdata(7 downto 0) - from J3
		ccb_data_s : IN STD_LOGIC;										-- ccbdata(8) - from J3
		ccb_cal : IN STD_LOGIC_VECTOR (2 downto 0);				-- ccbcal(2 downto 0) - from J3
		ccb_crsv : IN STD_LOGIC_VECTOR (4 downto 0);				-- NEW [ccbrsv(6)], ccbrsv(3 downto 0) - from J3
		ccb_drsv : IN STD_LOGIC_VECTOR (1 downto 0);				-- ccbrsv(5 downto 4) - from J3
		ccb_rsvo : IN STD_LOGIC_VECTOR (4 downto 0);				-- NEW [ccbrsv(11)], ccbrsv(10 downto 7) - from J3
		ccb_rsvi : OUT STD_LOGIC_VECTOR (2 downto 0);			-- ccbrsv(14 downto 12) - to J3
		ccb_bx0 : IN STD_LOGIC;											-- bx0 - from J3
		ccb_bxrst : IN STD_LOGIC;										-- bxrst - from J3
		ccb_l1acc : IN STD_LOGIC;										-- l1acc - from J3
		ccb_l1arst : IN STD_LOGIC;										-- l1rst - from J3
		ccb_l1rls : OUT STD_LOGIC;										-- l1rls - to J3
		ccb_clken : IN STD_LOGIC;										-- clken - from J3

		rawlct : IN STD_LOGIC_VECTOR (5 downto 0);				-- rawlct(5 downto 0) - from J4
		lctdav1 : IN STD_LOGIC;											-- lctdav1 - from J4
		lctdav2 : IN STD_LOGIC;											-- lctdav2 - from J4
		lctrqst : OUT STD_LOGIC_VECTOR (2 downto 1);				-- lctrqst(2 downto 1) - to J4
		rsvtd_in : IN STD_LOGIC_VECTOR(4 DOWNTO 0);				-- spare(7 DOWNTO 3) - to J4
		rsvtd_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);			-- spare(2 DOWNTO 0) - from J4

-- From GigaLinks

		grx0_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);	-- glin(15 downto 0)									  
		grx0_data_valid : IN STD_LOGIC;			 
		grx1_data : IN STD_LOGIC_VECTOR(15 DOWNTO 0);	-- glin(15 downto 0)											  
		grx1_data_valid : IN STD_LOGIC;			 
	
-- From GigaLinks

		gtx0_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);	-- dout(15 downto 0)											  
		gtx0_data_valid : OUT STD_LOGIC;			 
		gtx1_data : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);	-- dout(15 downto 0)											  
		gtx1_data_valid : OUT STD_LOGIC;			 
	
-- From/To FIFOs

		fifo_rd_ck : OUT STD_LOGIC;										  
		fifo_rd_en : OUT STD_LOGIC_VECTOR(9 DOWNTO 1);										  
		fifo_sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);			 

		fifo_out : IN STD_LOGIC_VECTOR(17 DOWNTO 0);				

		fifo_mrst_b : OUT STD_LOGIC;									-- ok -> fifo_mrst* - to FIFOs 
		fifo_prst_b : OUT STD_LOGIC;									-- ok -> fifo_pst* - to FIFOs 

		fifo_full_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- full*(7 DOWNTO 1) - from FIFOs 
		fifo_half_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- half*(7 DOWNTO 1) - from FIFOs 
		fifo_pae_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- paef*(7 DOWNTO 1) - from FIFOs 
		fifo_empty_b : IN STD_LOGIC_VECTOR(9 DOWNTO 1);			-- emptyf*(7 DOWNTO 1) - from FIFOs 

-- From/To DCFEBs (FF-EMU-MOD)

		ul_dav: IN STD_LOGIC_VECTOR(6 DOWNTO 0);						-- davf(5 DOWNTO 1) - from DCFEBs 
		ul_movlp: IN STD_LOGIC_VECTOR(6 DOWNTO 0);					-- movlp(5 DOWNTO 1) - from DCFEBs

		dl_lct : OUT STD_LOGIC_VECTOR(7 DOWNTO 1);					-- lctf(5 DOWNTO 1) - to DCFEBs
		dl_gtrig : OUT STD_LOGIC;											-- febrst - to DCFEBs
		dl_injpulse : OUT STD_LOGIC;										-- inject - to DCFEBs
		dl_extpulse : OUT STD_LOGIC;										-- extpulse - to DCFEBs

-- From/To LVMB

		r_lvmb_pon : IN STD_LOGIC_VECTOR(7 DOWNTO 0);		
		lvmb_csb : IN STD_LOGIC_VECTOR(6 DOWNTO 0);			
		lvmb_sclk : IN STD_LOGIC;
		lvmb_sdin : IN STD_LOGIC;			
		lvmb_sdout : IN STD_LOGIC

);
	
end COMPONENT;

COMPONENT dmb_vme IS
	port (

-- Chip Scope Pro Logic Analyzer control -- bgb

    CSP_VME_LA_CTRL: inout std_logic_vector(35 downto 0);       -- bgb
    CSP_LVMB_LA_CTRL: inout std_logic_vector(35 downto 0);      -- bgb
    CSP_CFEB_JTAG_LA_CTRL: inout std_logic_vector(35 downto 0); -- bgb
	 VME_LA_TRG: inout std_logic;                                -- bgb

-- VME signals

		vme_addr : IN STD_LOGIC_VECTOR (23 downto 1);			-- adr(23 downto 1)
		vme_data_in : IN STD_LOGIC_VECTOR (15 downto 0);		-- data_in(15 downto 0)
		vme_data_out : OUT STD_LOGIC_VECTOR (15 downto 0);		-- data_out(15 downto 0)
		vme_am : IN STD_LOGIC_VECTOR (5 downto 0);				-- am(5 downto 0)
		vme_ga : IN STD_LOGIC_VECTOR (4 downto 0);				-- iga(4 downto 0) -> ga*(4 downto 0)
		vme_gap : IN STD_LOGIC;											-- iga(5) -> ga*(5)
		vme_ds_b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);				-- ids1* -> ds1*, ids0* -> ds0*
		vme_as_b : IN STD_LOGIC;										-- ias* -> as*
		vme_lword_b : IN STD_LOGIC;									-- ilword* -> lword*
		vme_write_b : IN STD_LOGIC;									-- iwrite* -> write*
		vme_iack_b : IN STD_LOGIC;										-- inack* -> iack*
		vme_sysreset_b : IN STD_LOGIC;								-- isysrst* -> sysrest*
		vme_sysfail_b : IN STD_LOGIC;									-- isysfail* -> sysfail
		vme_sysfail_out : OUT STD_LOGIC;								-- NEW (N.1)
		vme_berr_b : IN STD_LOGIC;										-- iberr* -> berr*
		vme_berr_out : OUT STD_LOGIC;									-- NEW (N.1)
		vme_dtack_b : INOUT STD_LOGIC;									-- dtack* -> odtack*
		vme_tovme : OUT STD_LOGIC;										-- tovme
		vme_tovme_b : OUT STD_LOGIC;									-- tovme*
		vme_doe : OUT STD_LOGIC;										-- doe
		vme_doe_b : OUT STD_LOGIC;										-- doe*

-- Clock

		clk : IN STD_LOGIC;												-- fpgaclk (40MHz)
		clk_s1 : IN STD_LOGIC;											-- midclk (10MHz) 
		clk_s2  : IN STD_LOGIC;											-- slowclk (2.5MHz)
		clk_s3  : IN STD_LOGIC; 										-- slowclk2 (1.25MHz)

-- Reset

		rst : IN STD_LOGIC;												-- iglobalrst

-- JTAG signals To/From DCFEBs

		dl_jtag_tck : INOUT STD_LOGIC_VECTOR (6 downto 0);				
		dl_jtag_tms : INOUT STD_LOGIC;				
		dl_jtag_tdi : INOUT STD_LOGIC;				
		dl_jtag_tdo : IN STD_LOGIC_VECTOR (6 downto 0);				
		dl_rtn_shft_en  : IN STD_LOGIC_VECTOR (6 downto 0);
		ul_jtag_tck : IN STD_LOGIC_VECTOR (6 downto 0);				
		ul_jtag_tms : IN STD_LOGIC_VECTOR (6 downto 0);				
		ul_jtag_tdi : IN STD_LOGIC_VECTOR (6 downto 0);

-- reprogram To DCFEB FPGA (CFEBPRG)

		dl_reprogram : OUT STD_LOGIC_VECTOR(6 downto 0);

-- Done from DCFEB FPGA (CFEBPRG)

		ul_done : IN STD_LOGIC_VECTOR(6 downto 0);


-- To/From O-DMB ADC

		adc_cs : OUT STD_LOGIC;											
		adc_sclk : OUT STD_LOGIC;										
		adc_sdain : OUT STD_LOGIC;										
		adc_sdaout : IN STD_LOGIC;										
		
-- To/From O-DMB DAC

		dac_cs : OUT STD_LOGIC;											
		dac_sclk : OUT STD_LOGIC;										
		dac_sdain : OUT STD_LOGIC;										
		dac_sdaout : IN STD_LOGIC;										
		
-- To/From DCFEB FIFOs

		fifo_wr_ck : OUT STD_LOGIC;	
		fifo_wr_en : OUT STD_LOGIC_VECTOR (9 downto 1);
		fifo_rw_en : OUT STD_LOGIC_VECTOR (9 downto 1);	
		fifo_rm_en : OUT STD_LOGIC_VECTOR (9 downto 1);	
		fifo_tm_en : OUT STD_LOGIC_VECTOR (9 downto 1);	

		fifo_in : OUT STD_LOGIC_VECTOR (17 downto 0);			
		fifo_out : IN STD_LOGIC_VECTOR (17 downto 0);	

-- To/From DCFEB ADCs and DACs

		dl_spi_cs0 : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_cs1 : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_scl : OUT STD_LOGIC_VECTOR(6 downto 0);			
		dl_spi_sda : OUT STD_LOGIC_VECTOR(6 downto 0);			 
		ul_spi_scl : IN STD_LOGIC_VECTOR(6 downto 0);			
		ul_spi_sda : IN STD_LOGIC_VECTOR(6 downto 0);			 
		ul_spi_busy : IN STD_LOGIC_VECTOR(6 downto 0);			 

-- Token To/From DCFEB FF-EMU 

		dl_tkn : OUT STD_LOGIC_VECTOR(6 downto 0);				
		ul_tkn : IN STD_LOGIC_VECTOR(6 downto 0);					

-- I2C control signals To/From DCFEB FF-EMU (CFEBI2C)

		dl_i2c_scl : OUT STD_LOGIC_VECTOR(6 downto 0);				
		dl_i2c_sda : OUT STD_LOGIC_VECTOR(6 downto 0);				
		ul_i2c_scl : IN STD_LOGIC_VECTOR(6 downto 0);					
		ul_i2c_sda : IN STD_LOGIC_VECTOR(6 downto 0);					

-- From/To QPLL

		qpll_autorestart : OUT STD_LOGIC;						
		qpll_mode : OUT STD_LOGIC;									
		qpll_extcontrol : OUT STD_LOGIC;							
		qpll_reset : OUT STD_LOGIC;								
		qpll_f0sel : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);		
		qpll_locked : IN STD_LOGIC;								
		qpll_error : IN STD_LOGIC;									

-- From/To LVMB

		lvmb_pon : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		pon_load : OUT STD_LOGIC;
		pon_oe_b : OUT STD_LOGIC;
		r_lvmb_pon : IN STD_LOGIC_VECTOR(7 DOWNTO 0);		
		lvmb_csb : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);			
		lvmb_sclk : OUT STD_LOGIC;
		lvmb_sdin : OUT STD_LOGIC;			
		lvmb_sdout : IN STD_LOGIC;

		diagout_cfebjtag  : OUT std_logic_vector(17 downto 0)
		
);
	
END COMPONENT;

COMPONENT ot_mgr
	PORT(
		 otx1_tx_en : OUT STD_LOGIC;
		 otx1_tx_dis : OUT STD_LOGIC;
		 otx1_reset : OUT STD_LOGIC;
		 otx1_fault : IN STD_LOGIC;
		 otx2_tx_en : OUT STD_LOGIC;
		 otx2_tx_dis : OUT STD_LOGIC;
		 otx2_reset : OUT STD_LOGIC;
		 otx2_fault : IN STD_LOGIC;
		 orx1_rx_en : OUT STD_LOGIC;
		 orx1_en_sd : OUT STD_LOGIC;
		 orx1_sd : IN STD_LOGIC;
		 orx1_sq_en : OUT STD_LOGIC;
		 orx2_rx_en : OUT STD_LOGIC;
		 orx2_en_sd : OUT STD_LOGIC;
		 orx2_sd : IN STD_LOGIC;
		 orx2_sq_en : OUT STD_LOGIC
	);
END COMPONENT;


-- Test Signals From/To J3

SIGNAL 	d_in, d_out, d_oe : STD_LOGIC_VECTOR(63 DOWNTO 0);		

-- VME Signals

signal	vme_data_out : STD_LOGIC_VECTOR (15 downto 0);
signal	vme_data_in : STD_LOGIC_VECTOR (15 downto 0);
signal	vme_tovme_b : STD_LOGIC;
--Changed for 904 use
--signal	vme_doe_b : STD_LOGIC; -- not used
signal	vme_doe : STD_LOGIC; -- not used
-- To/From FIFOs

signal	dcfeb0_data, dcfeb0_fifo_in, dcfeb0_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb0_data_valid	: STD_LOGIC;
signal	dcfeb1_data, dcfeb1_fifo_in, dcfeb1_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb1_data_valid	: STD_LOGIC;
signal	dcfeb2_data, dcfeb2_fifo_in, dcfeb2_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb2_data_valid	: STD_LOGIC;
signal	dcfeb3_data, dcfeb3_fifo_in, dcfeb3_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb3_data_valid	: STD_LOGIC;
signal	dcfeb4_data, dcfeb4_fifo_in, dcfeb4_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb4_data_valid	: STD_LOGIC;
signal	dcfeb5_data, dcfeb5_fifo_in, dcfeb5_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb5_data_valid	: STD_LOGIC;
signal	dcfeb6_data, dcfeb6_fifo_in, dcfeb6_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb6_data_valid	: STD_LOGIC;
signal	dcfeb7_data, dcfeb7_fifo_in, dcfeb7_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	dcfeb7_data_valid	: STD_LOGIC;
signal	tmb_data, tmb_fifo_in, tmb_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	tmb_data_valid	: STD_LOGIC;
signal	alct_data, alct_fifo_in, alct_fifo_out : STD_LOGIC_VECTOR (17 downto 0);
signal	alct_data_valid	: STD_LOGIC;

signal	fifo_mrst_b, fifo_prst_b : STD_LOGIC;
signal	fifo_wr_ck, fifo_rd_ck : STD_LOGIC;
signal	fifo_tm_wr_en, fifo_wr_en, fifo_rd_en : STD_LOGIC_VECTOR(9 downto 1);
signal	fifo_rw_en, fifo_rm_en, fifo_tm_en : STD_LOGIC_VECTOR (9 downto 1);
signal	fifo_full, fifo_half, fifo_pae, fifo_empty : STD_LOGIC_VECTOR (9 downto 1);		
signal	fifo_sel : STD_LOGIC_VECTOR (3 downto 0);														
signal	fifo_in, fifo_out : STD_LOGIC_VECTOR (17 downto 0);													
													
-- TTC Signals

signal	dl_jtag_tck, dl_jtag_tdo, dl_rtn_shft_en : STD_LOGIC_VECTOR(7 downto 1);				
signal	dl_jtag_tms, dl_jtag_tdi : STD_LOGIC;				
signal	ul_jtag_tck, ul_jtag_tms, ul_jtag_tdi : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_spi_cs0, dl_spi_cs1, dl_spi_scl, dl_spi_sda : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_spi_scl, ul_spi_sda, ul_spi_busy : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_tkn : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_tkn : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_i2c_scl, dl_i2c_sda : STD_LOGIC_VECTOR(7 downto 1);				
signal	ul_i2c_scl, ul_i2c_sda : STD_LOGIC_VECTOR(7 downto 1);				

signal	dl_injpulse, dl_extpulse, dl_gtrig : STD_LOGIC;
signal	dl_lct, dl_l1t : STD_LOGIC_VECTOR (7 downto 1);
signal	dl_global_rst : STD_LOGIC;
signal	dl_resync : STD_LOGIC_VECTOR(7 downto 1);
SIGNAL	dl_reprogram :  STD_LOGIC_VECTOR(7 downto 1);
SIGNAL	ul_dav, ul_movlp, ul_done : STD_LOGIC_VECTOR (7 downto 1);

-- Mode Selection Signals

signal	pb_reset, lb_en, lb_ff_en, tm_en : STD_LOGIC;





-- From/To OTs 

signal	otx1_01, otx1_02, otx1_03, otx1_04, otx1_05, otx1_06, otx1_07, otx1_08, otx1_09, otx1_10, otx1_11, otx1_12 : STD_LOGIC;
signal	otx2_01, otx2_02, otx2_03, otx2_04, otx2_05, otx2_06, otx2_07, otx2_08, otx2_09, otx2_10, otx2_11, otx2_12 : STD_LOGIC;
signal	orx1_01, orx1_02, orx1_03, orx1_04, orx1_05, orx1_06, orx1_07, orx1_08, orx1_09, orx1_10, orx1_11, orx1_12 : STD_LOGIC;
signal	orx2_01, orx2_02, orx2_03, orx2_04, orx2_05, orx2_06, orx2_07, orx2_08, orx2_09, orx2_10, orx2_11, orx2_12 : STD_LOGIC;

-- From/To Giga-Bit Links

signal 	gl0_tx, gl0_rx, gl1_tx, gl1_rx : STD_LOGIC;

signal	grx0_data : STD_LOGIC_VECTOR(15 DOWNTO 0) := "0000000000000000";									  
signal	grx0_data_valid : STD_LOGIC := '0';			 
signal	grx1_data : STD_LOGIC_VECTOR(15 DOWNTO 0) := "0000000000000000";												  
signal	grx1_data_valid : STD_LOGIC := '0';	 
	
signal	gtx0_data : STD_LOGIC_VECTOR(15 DOWNTO 0);										  
signal	gtx0_data_valid : STD_LOGIC;			 
signal	gtx1_data : STD_LOGIC_VECTOR(15 DOWNTO 0);											  
signal	gtx1_data_valid : STD_LOGIC;			 

-- From LVDS Test Connector

signal 	ck_0, ck_1, ck_2, clk, tx_0, tx_1, tx_2, tx_3, tx_4, tx_5, tx_6, tx_7, tx_8, tx_9, tx_10 : STD_LOGIC;
signal 	rxb, rx_0, rx_1, rx_2, rx_3, rx_4, rx_5, rx_6, rx_7, rx_8, rx_9, rx_10 : STD_LOGIC;


-- PLL Signals

signal	clkin, qpll_clk40MHz, qpll_clk80MHz, qpll_clk160MHz : STD_LOGIC;

SIGNAL 	pll1_fb, pll1_rst, pll1_pd, pll1_locked : STD_LOGIC;
SIGNAL 	pll2_fb, pll2_rst, pll2_pd, pll2_locked : STD_LOGIC;
SIGNAL 	pll3_fb, pll3_rst, pll3_pd, pll3_locked : STD_LOGIC;

signal 	pll_clk40, clk40 : STD_LOGIC;
signal 	pll_clk320_tx, clk320_tx : STD_LOGIC;
signal	pll_dmbvme_clk, dmbvme_clk : STD_LOGIC;				-- fpgaclk (40MHz)
signal 	pll_dmbvme_clk_s1, dmbvme_clk_s1 : STD_LOGIC;	-- midclk (10MHz) 
signal 	pll_dmbvme_clk_s2, dmbvme_clk_s2 : STD_LOGIC;	-- slowclk (2.5MHz)
-- bgb signal 	pll_dmbvme_clk_s3, dmbvme_clk_s3 : STD_LOGIC;	-- slowclk2 (1.25MHz)
signal 	dmbvme_clk_s3, dmbvme_clk_s3_b : STD_LOGIC;	-- slowclk2 (1.25MHz)

signal 	pll_dcfeb0_clk320_tx, dcfeb0_clk320_tx, pll_dcfeb0_clk320_rx, dcfeb0_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb1_clk320_tx, dcfeb1_clk320_tx, pll_dcfeb1_clk320_rx, dcfeb1_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb2_clk320_tx, dcfeb2_clk320_tx, pll_dcfeb2_clk320_rx, dcfeb2_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb3_clk320_tx, dcfeb3_clk320_tx, pll_dcfeb3_clk320_rx, dcfeb3_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb4_clk320_tx, dcfeb4_clk320_tx, pll_dcfeb4_clk320_rx, dcfeb4_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb5_clk320_tx, dcfeb5_clk320_tx, pll_dcfeb5_clk320_rx, dcfeb5_clk320_rx : STD_LOGIC;
signal 	pll_dcfeb6_clk320_tx, dcfeb6_clk320_tx, pll_dcfeb6_clk320_rx, dcfeb6_clk320_rx : STD_LOGIC;


-- Other signals

signal	iob_rsvtd_out : STD_LOGIC_VECTOR (7 downto 0);
signal	iob_rsvtd_in : STD_LOGIC_VECTOR (7 downto 0);

signal	por : STD_LOGIC;

SIGNAL 	int_dl_jtag_tdo : STD_LOGIC_VECTOR(7 downto 1) := "0000000"; 
SIGNAL 	jtag_dr0 : STD_LOGIC_VECTOR(15 downto 0); 
SIGNAL 	jtag_ir : STD_LOGIC_VECTOR(10 downto 0); 

SIGNAL 	int_lvmb_pon : STD_LOGIC_VECTOR(7 downto 0); 
SIGNAL 	int_lvmb_adc_sdout : STD_LOGIC_VECTOR(6 downto 0); 
SIGNAL 	int_lvmb_csb : STD_LOGIC_VECTOR(6 downto 0); 
SIGNAL 	int_lvmb_sclk,int_lvmb_sdin,int_lvmb_sdout : STD_LOGIC; 

SIGNAL 	leds_in : STD_LOGIC_VECTOR(11 downto 0); 


signal	adc_mask, dcfeb1t_adc_mask, dcfeb2t_adc_mask : STD_LOGIC_VECTOR(11 downto 0);


signal	diagout_cfebjtag  : std_logic_vector(17 downto 0);
signal	csp_vme_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_lvmb_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_cfeb_jtag_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_dcfeb0_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal	csp_jtag_sim_la_ctrl : STD_LOGIC_VECTOR(35 downto 0); -- bgb logic analyzer control signals
signal   vme_la_trg : STD_LOGIC; -- bgb logic analyzer trigger


BEGIN 

-- bgb
-- bgb Need pullup on DTACK*
-- bgb 

PULLUP_dtack_b : PULLUP
   port map (O => vme_dtack_v6_b);


fd_clr <= '0';
fd_pre <= '1';

-- clkin <= ck_0;
clkin <= qpll_clk40MHz; -- for full speed operation

--
-- bgb added power on reset
--
   SRL16E_inst : SRL16E
   generic map (
      INIT => X"FFFF")
   port map (
      Q => por,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => clkin,   -- Clock input
      D => '0'        -- SRL data input
   );

-- bgb 
-- bgb  Added Chip Scope Pro Controller 
-- bgb 

csp_control_j3_i : csp_control_j3
  port map (
    CONTROL0 => csp_vme_la_ctrl,
    CONTROL1 => csp_lvmb_la_ctrl,
    CONTROL2 => csp_cfeb_jtag_la_ctrl,
    CONTROL3 => csp_dcfeb0_la_ctrl,
    CONTROL4 => csp_jtag_sim_la_ctrl
);
	 
-- bgb 
-- bgb  Added Chip Scope Pro Logic analyzer for VME signal
-- bgb 


-- VME I/O Signals From/To J4 (vme_data)

vme_d00_buf : IOBUF port map (O => vme_data_in(0), IO => vme_data(0), I => vme_data_out(0), T => vme_tovme_b);     	
vme_d01_buf : IOBUF port map (O => vme_data_in(1), IO => vme_data(1), I => vme_data_out(1), T => vme_tovme_b);     	
vme_d02_buf : IOBUF port map (O => vme_data_in(2), IO => vme_data(2), I => vme_data_out(2), T => vme_tovme_b);     	
vme_d03_buf : IOBUF port map (O => vme_data_in(3), IO => vme_data(3), I => vme_data_out(3), T => vme_tovme_b);     	
vme_d04_buf : IOBUF port map (O => vme_data_in(4), IO => vme_data(4), I => vme_data_out(4), T => vme_tovme_b);     	
vme_d05_buf : IOBUF port map (O => vme_data_in(5), IO => vme_data(5), I => vme_data_out(5), T => vme_tovme_b);     	
vme_d06_buf : IOBUF port map (O => vme_data_in(6), IO => vme_data(6), I => vme_data_out(6), T => vme_tovme_b);     	
vme_d07_buf : IOBUF port map (O => vme_data_in(7), IO => vme_data(7), I => vme_data_out(7), T => vme_tovme_b);     	
vme_d08_buf : IOBUF port map (O => vme_data_in(8), IO => vme_data(8), I => vme_data_out(8), T => vme_tovme_b);     	
vme_d09_buf : IOBUF port map (O => vme_data_in(9), IO => vme_data(9), I => vme_data_out(9), T => vme_tovme_b);     	
vme_d10_buf : IOBUF port map (O => vme_data_in(10), IO => vme_data(10), I => vme_data_out(10), T => vme_tovme_b);     	
vme_d11_buf : IOBUF port map (O => vme_data_in(11), IO => vme_data(11), I => vme_data_out(11), T => vme_tovme_b);     	
vme_d12_buf : IOBUF port map (O => vme_data_in(12), IO => vme_data(12), I => vme_data_out(12), T => vme_tovme_b);     	
vme_d13_buf : IOBUF port map (O => vme_data_in(13), IO => vme_data(13), I => vme_data_out(13), T => vme_tovme_b);     	
vme_d14_buf : IOBUF port map (O => vme_data_in(14), IO => vme_data(14), I => vme_data_out(14), T => vme_tovme_b);     	
vme_d15_buf : IOBUF port map (O => vme_data_in(15), IO => vme_data(15), I => vme_data_out(15), T => vme_tovme_b);     	



-- Initial Assignments

lvmb_csb <= int_lvmb_csb;
lvmb_sclk <= int_lvmb_sclk;									
lvmb_sdin <= int_lvmb_sdin;									


leds_in(8) <= pb(0);
leds_in(9) <= pb(1);
leds_in(10) <= pb(2);
leds_in(11) <= pb(3);

--d_out(0) <= d_in(0);
--d_oe(0) <= '0';
d_out(0) <= diagout_cfebjtag(0); -- TP58
d_oe(0) <= '1';
d00_buf : IOBUF port map (O => d_in(0), IO => d(0), I => d_out(0), T => d_oe(0));     	

--d_out(1) <= d_in(1);
--d_oe(1) <= '0';
d_out(1) <= diagout_cfebjtag(1); -- TP60
d_oe(1) <= '1';
d01_buf : IOBUF port map (O => d_in(1), IO => d(1), I => d_out(1), T => d_oe(1));     	

--d_out(2) <= d_in(2);
--d_oe(2) <= '0';
d_out(2) <= diagout_cfebjtag(2); -- TP62
d_oe(2) <= '1';
d02_buf : IOBUF port map (O => d_in(2), IO => d(2), I => d_out(2), T => d_oe(2));     	

--d_out(3) <= d_in(3);
--d_oe(3) <= '0';
d_out(3) <= diagout_cfebjtag(3); -- TP64
d_oe(3) <= '1';
d03_buf : IOBUF port map (O => d_in(3), IO => d(3), I => d_out(3), T => d_oe(3));     	

--d_out(4) <= d_in(4);
--d_oe(4) <= '0';
d_out(4) <= diagout_cfebjtag(4); -- TP66
d_oe(4) <= '1';
d04_buf : IOBUF port map (O => d_in(4), IO => d(4), I => d_out(4), T => d_oe(4));     	

--d_out(5) <= d_in(5);
--d_oe(5) <= '0';
d_out(5) <= diagout_cfebjtag(5); -- TP68
d_oe(5) <= '1';
d05_buf : IOBUF port map (O => d_in(5), IO => d(5), I => d_out(5), T => d_oe(5));     	

--d_out(6) <= d_in(6);
--d_oe(6) <= '0';
d_out(6) <= diagout_cfebjtag(6); -- TP70
d_oe(6) <= '1';
d06_buf : IOBUF port map (O => d_in(6), IO => d(6), I => d_out(6), T => d_oe(6));     	

--d_out(7) <= d_in(7);
--d_oe(7) <= '0';
d_out(7) <= diagout_cfebjtag(7); -- TP72
d_oe(7) <= '1';
d07_buf : IOBUF port map (O => d_in(7), IO => d(7), I => d_out(7), T => d_oe(7));     	

--d_out(8) <= d_in(8);
--d_oe(8) <= '0';
d_out(8) <= diagout_cfebjtag(8); -- TP74
d_oe(8) <= '1';
d08_buf : IOBUF port map (O => d_in(8), IO => d(8), I => d_out(8), T => d_oe(8));     	

d_out(9) <= d_in(9);
d_oe(9) <= '0';
d09_buf : IOBUF port map (O => d_in(9), IO => d(9), I => d_out(9), T => d_oe(9));     	

d_out(10) <= d_in(10);
d_oe(10) <= '0';	
d10_buf : IOBUF port map (O => d_in(10), IO => d(10), I => d_out(10), T => d_oe(10));     	

d_out(11) <= d_in(11);
d_oe(11) <= '0';
d11_buf : IOBUF port map (O => d_in(11), IO => d(11), I => d_out(11), T => d_oe(11));     	

d_out(12) <= d_in(12);
d_oe(12) <= '0';		
d12_buf : IOBUF port map (O => d_in(12), IO => d(12), I => d_out(12), T => d_oe(12));     	

d_out(13) <= d_in(13);
d_oe(13) <= '0';	
d13_buf : IOBUF port map (O => d_in(13), IO => d(13), I => d_out(13), T => d_oe(13));     	

d_out(14) <= d_in(14);
d_oe(14) <= '0';	
d14_buf : IOBUF port map (O => d_in(14), IO => d(14), I => d_out(14), T => d_oe(14));     	

d_out(15) <= d_in(15);
d_oe(15) <= '0';	
d15_buf : IOBUF port map (O => d_in(15), IO => d(15), I => d_out(15), T => d_oe(15));     	

d_out(16) <= d_in(16);
d_oe(16) <= '0';		
d16_buf : IOBUF port map (O => d_in(16), IO => d(16), I => d_out(16), T => d_oe(16));     	

d_out(17) <= d_in(17);
d_oe(17) <= '0';		
d17_buf : IOBUF port map (O => d_in(17), IO => d(17), I => d_out(17), T => d_oe(17));     	

d_out(18) <= d_in(18);
d_oe(18) <= '0';	
d18_buf : IOBUF port map (O => d_in(18), IO => d(18), I => d_out(18), T => d_oe(18));     	

d_out(19) <= d_in(19);
d_oe(19) <= '0';	
d19_buf : IOBUF port map (O => d_in(19), IO => d(19), I => d_out(19), T => d_oe(19));     	

d_out(20) <= d_in(20);
d_oe(20) <= '0';	
d20_buf : IOBUF port map (O => d_in(20), IO => d(20), I => d_out(20), T => d_oe(20));     	

d_out(21) <= d_in(21);
d_oe(21) <= '0';	
d21_buf : IOBUF port map (O => d_in(21), IO => d(21), I => d_out(21), T => d_oe(21));     	

d_out(22) <= d_in(22);
d_oe(22) <= '0';		
d22_buf : IOBUF port map (O => d_in(22), IO => d(22), I => d_out(22), T => d_oe(22));     	

d_out(23) <= d_in(23);
d_oe(23) <= '0';		
d23_buf : IOBUF port map (O => d_in(23), IO => d(23), I => d_out(23), T => d_oe(23));     	

d_out(24) <= d_in(24);
d_oe(24) <= '0';		
d24_buf : IOBUF port map (O => d_in(24), IO => d(24), I => d_out(24), T => d_oe(24));     	

d_out(25) <= d_in(25);
d_oe(25) <= '0';		
d25_buf : IOBUF port map (O => d_in(25), IO => d(25), I => d_out(25), T => d_oe(25));     	

d_out(26) <= d_in(26);
d_oe(26) <= '0';		
d26_buf : IOBUF port map (O => d_in(26), IO => d(26), I => d_out(26), T => d_oe(26));     	

d_out(27) <= d_in(27);
d_oe(27) <= '0';		
d27_buf : IOBUF port map (O => d_in(27), IO => d(27), I => d_out(27), T => d_oe(27));     	

d_out(28) <= d_in(28);
d_oe(28) <= '0';	
d28_buf : IOBUF port map (O => d_in(28), IO => d(28), I => d_out(28), T => d_oe(28));     	

d_out(29) <= d_in(29);
d_oe(29) <= '0';	
d29_buf : IOBUF port map (O => d_in(29), IO => d(29), I => d_out(29), T => d_oe(29));     	

d_out(30) <= d_in(30);
d_oe(30) <= '0';	
d30_buf : IOBUF port map (O => d_in(30), IO => d(30), I => d_out(30), T => d_oe(30));     	

d_out(31) <= d_in(31);
d_oe(31) <= '0';	
d31_buf : IOBUF port map (O => d_in(31), IO => d(31), I => d_out(31), T => d_oe(31));     	

--d_out(32) <= d_in(32);
--d_oe(32) <= '0';	
d_out(32) <= diagout_cfebjtag(9); -- TP59
d_oe(32) <= '1';
d32_buf : IOBUF port map (O => d_in(32), IO => d(32), I => d_out(32), T => d_oe(32));     	

--d_out(33) <= d_in(33);
--d_oe(33) <= '0';		
d_out(33) <= diagout_cfebjtag(10); -- TP61
d_oe(33) <= '1';
d33_buf : IOBUF port map (O => d_in(33), IO => d(33), I => d_out(33), T => d_oe(33));     	

--d_out(34) <= d_in(34);
--d_oe(34) <= '0';	
d_out(34) <= diagout_cfebjtag(11); -- TP63
d_oe(34) <= '1';
d34_buf : IOBUF port map (O => d_in(34), IO => d(34), I => d_out(34), T => d_oe(34));     	

--d_out(35) <= d_in(35);
--d_oe(35) <= '0';		
d_out(35) <= diagout_cfebjtag(12); -- TP65
d_oe(35) <= '1';
d35_buf : IOBUF port map (O => d_in(35), IO => d(35), I => d_out(35), T => d_oe(35));     	

--d_out(36) <= d_in(36);
--d_oe(36) <= '0';	
d_out(36) <= diagout_cfebjtag(13); -- TP67
d_oe(36) <= '1';
d36_buf : IOBUF port map (O => d_in(36), IO => d(36), I => d_out(36), T => d_oe(36));     	

--d_out(37) <= d_in(37);
--d_oe(37) <= '0';	
d_out(37) <= diagout_cfebjtag(14); -- TP69
d_oe(37) <= '1';
d37_buf : IOBUF port map (O => d_in(37), IO => d(37), I => d_out(37), T => d_oe(37));     	

--d_out(38) <= d_in(38);
--d_oe(38) <= '0';	
d_out(38) <= diagout_cfebjtag(15); -- TP71
d_oe(38) <= '1';
d38_buf : IOBUF port map (O => d_in(38), IO => d(38), I => d_out(38), T => d_oe(38));     	

--d_out(39) <= d_in(39);
--d_oe(39) <= '0';	
d_out(39) <= diagout_cfebjtag(16); -- TP73
d_oe(39) <= '1';
d39_buf : IOBUF port map (O => d_in(39), IO => d(39), I => d_out(39), T => d_oe(39));     	

--d_out(40) <= d_in(40);
--d_oe(40) <= '0';		
d_out(40) <= diagout_cfebjtag(17); -- TP75
d_oe(40) <= '1';
d40_buf : IOBUF port map (O => d_in(40), IO => d(40), I => d_out(40), T => d_oe(40));     	

d_out(41) <= d_in(41);
d_oe(41) <= '0';		
d41_buf : IOBUF port map (O => d_in(41), IO => d(41), I => d_out(41), T => d_oe(41));     	

d_out(42) <= d_in(42);
d_oe(42)  <= '0';	
d42_buf : IOBUF port map (O => d_in(42), IO => d(42), I => d_out(42), T => d_oe(42));     	

d_out(43) <= d_in(43);
d_oe(43)  <= '0';	
d43_buf : IOBUF port map (O => d_in(43), IO => d(43), I => d_out(43), T => d_oe(43));     	

d_out(44) <= d_in(44);
d_oe(44)  <= '0';		
d44_buf : IOBUF port map (O => d_in(44), IO => d(44), I => d_out(44), T => d_oe(44));     	

d_out(45) <= d_in(45);
d_oe(45)  <= '0';		
d45_buf : IOBUF port map (O => d_in(45), IO => d(45), I => d_out(45), T => d_oe(45));     	

d_out(46) <= d_in(46);
d_oe(46)  <= '0';		
d46_buf : IOBUF port map (O => d_in(46), IO => d(46), I => d_out(46), T => d_oe(46));     	

d_out(47) <= d_in(47);
d_oe(47)  <= '0';		
d47_buf : IOBUF port map (O => d_in(47), IO => d(47), I => d_out(47), T => d_oe(47));     	

d_out(48) <= d_in(48);
d_oe(48)  <= '0';		
d48_buf : IOBUF port map (O => d_in(48), IO => d(48), I => d_out(48), T => d_oe(48));     	

d_out(49) <= d_in(49);
d_oe(49)  <= '0';		
d49_buf : IOBUF port map (O => d_in(49), IO => d(49), I => d_out(49), T => d_oe(49));     	

d_out(50) <= d_in(50);
d_oe(50)  <= '0';		
d50_buf : IOBUF port map (O => d_in(50), IO => d(50), I => d_out(50), T => d_oe(50));     	

d_out(51) <= d_in(51);
d_oe(51)  <= '0';		
d51_buf : IOBUF port map (O => d_in(51), IO => d(51), I => d_out(51), T => d_oe(51));     	

d_out(52) <= d_in(52);
d_oe(52)  <= '0';		
d52_buf : IOBUF port map (O => d_in(52), IO => d(52), I => d_out(52), T => d_oe(52));     	

d_out(53) <= d_in(53);
d_oe(53)  <= '0';	
d53_buf : IOBUF port map (O => d_in(53), IO => d(53), I => d_out(53), T => d_oe(53));     	

d_out(54) <= d_in(54);
d_oe(54)  <= '0';		
d54_buf : IOBUF port map (O => d_in(54), IO => d(54), I => d_out(54), T => d_oe(54));     	

d_out(55) <= d_in(55);
d_oe(55)  <= '0';		
d55_buf : IOBUF port map (O => d_in(55), IO => d(55), I => d_out(55), T => d_oe(55));     	

d_out(56) <= d_in(56);
d_oe(56)  <= '0';		
d56_buf : IOBUF port map (O => d_in(56), IO => d(56), I => d_out(56), T => d_oe(56));     	

d_out(57) <= d_in(57);
d_oe(57)  <= '0';	
d57_buf : IOBUF port map (O => d_in(57), IO => d(57), I => d_out(57), T => d_oe(57));     	

d_out(58) <= d_in(58);
d_oe(58)  <= '0';		
d58_buf : IOBUF port map (O => d_in(58), IO => d(58), I => d_out(58), T => d_oe(58));     	

d_out(59) <= d_in(59);
d_oe(59)  <= '0';		
d59_buf : IOBUF port map (O => d_in(59), IO => d(59), I => d_out(59), T => d_oe(59));     	

d_out(60) <= d_in(60);
d_oe(60)  <= '0';		
d60_buf : IOBUF port map (O => d_in(60), IO => d(60), I => d_out(60), T => d_oe(60));     	

d_out(61) <= d_in(61);
d_oe(61)  <= '0';		
d61_buf : IOBUF port map (O => d_in(61), IO => d(61), I => d_out(61), T => d_oe(61));     	

d_out(62) <= d_in(62);
d_oe(62)  <= '0';	
d62_buf : IOBUF port map (O => d_in(62), IO => d(62), I => d_out(62), T => d_oe(62));     	

d_out(63) <= d_in(63);
d_oe(63)  <= '0';	
d63_buf : IOBUF port map (O => d_in(63), IO => d(63), I => d_out(63), T => d_oe(63));     	

-- FW Version Jun_28_01

-- leds(11 downto 0) <= test_vme_data_in(11 downto 0);

leds_in(7 downto 0) <= not adc_mask(7 downto 0);

-- leds_in(7 downto 0) <= int_lvmb_pon(7 downto 0);
lvmb_pon <= int_lvmb_pon(7 downto 0);

led00_buf : OBUF port map (O => leds(0), I => leds_in(0));    	
led01_buf : OBUF port map (O => leds(1), I => leds_in(1));    	
led02_buf : OBUF port map (O => leds(2), I => leds_in(2));    	
led03_buf : OBUF port map (O => leds(3), I => leds_in(3));    	
led04_buf : OBUF port map (O => leds(4), I => leds_in(4));    	
led05_buf : OBUF port map (O => leds(5), I => leds_in(5));    	
led06_buf : OBUF port map (O => leds(6), I => leds_in(6));    	
led07_buf : OBUF port map (O => leds(7), I => leds_in(7));    	
led08_buf : OBUF port map (O => leds(8), I => leds_in(8));    	
led09_buf : OBUF port map (O => leds(9), I => leds_in(9));    	
led10_buf : OBUF port map (O => leds(10), I => leds_in(10));    	
led11_buf : OBUF port map (O => leds(11), I => leds_in(11));    	

-- LVDS input buffers

-- From OT1 (GigaBit Link)

-- gl1_rx
gl1_rx_buf : IBUFDS port map (I=>gl0_rx_p, IB=>gl0_rx_n, O=>gl0_rx);

-- From OT2 (GigaBit Link)

-- gl2_rx
gl2_rx_buf : IBUFDS port map (I=>gl1_rx_p, IB=>gl1_rx_n, O=>gl1_rx);


-- From ORX1

-- orx1_01
orx1_01_buf : IBUFDS port map (I=>orx1_01_p, IB=>orx1_01_n, O=>orx1_01);
-- orx1_02
orx1_02_buf : IBUFDS port map (I=>orx1_02_p, IB=>orx1_02_n, O=>orx1_02);
-- orx1_03
orx1_03_buf : IBUFDS port map (I=>orx1_03_p, IB=>orx1_03_n, O=>orx1_03);
-- orx1_04
orx1_04_buf : IBUFDS port map (I=>orx1_04_p, IB=>orx1_04_n, O=>orx1_04);
-- orx1_05
orx1_05_buf : IBUFDS port map (I=>orx1_05_p, IB=>orx1_05_n, O=>orx1_05);
-- orx1_06
orx1_06_buf : IBUFDS port map (I=>orx1_06_p, IB=>orx1_06_n, O=>orx1_06);
-- orx1_07
orx1_07_buf : IBUFDS port map (I=>orx1_07_p, IB=>orx1_07_n, O=>orx1_07);
-- orx1_08
orx1_08_buf : IBUFDS port map (I=>orx1_08_p, IB=>orx1_08_n, O=>orx1_08);
-- orx1_09
orx1_09_buf : IBUFDS port map (I=>orx1_09_p, IB=>orx1_09_n, O=>orx1_09);
-- orx1_10
orx1_10_buf : IBUFDS port map (I=>orx1_10_p, IB=>orx1_10_n, O=>orx1_10);
-- orx1_11
orx1_11_buf : IBUFDS port map (I=>orx1_11_p, IB=>orx1_11_n, O=>orx1_11);
-- orx1_12
orx1_12_buf : IBUFDS port map (I=>orx1_12_p, IB=>orx1_12_n, O=>orx1_12);


-- From ORX2

-- orx2_01
orx2_01_buf : IBUFDS port map (I=>orx2_01_p, IB=>orx2_01_n, O=>orx2_01);
-- orx2_02
orx2_02_buf : IBUFDS port map (I=>orx2_02_p, IB=>orx2_02_n, O=>orx2_02);
-- orx2_03
orx2_03_buf : IBUFDS port map (I=>orx2_03_p, IB=>orx2_03_n, O=>orx2_03);
-- orx2_04
orx2_04_buf : IBUFDS port map (I=>orx2_04_p, IB=>orx2_04_n, O=>orx2_04);
-- orx2_05
orx2_05_buf : IBUFDS port map (I=>orx2_05_p, IB=>orx2_05_n, O=>orx2_05);
-- orx2_06
orx2_06_buf : IBUFDS port map (I=>orx2_06_p, IB=>orx2_06_n, O=>orx2_06);
-- orx2_07
orx2_07_buf : IBUFDS port map (I=>orx2_07_p, IB=>orx2_07_n, O=>orx2_07);
-- orx2_08
orx2_08_buf : IBUFDS port map (I=>orx2_08_p, IB=>orx2_08_n, O=>orx2_08);
-- orx2_09
orx2_09_buf : IBUFDS port map (I=>orx2_09_p, IB=>orx2_09_n, O=>orx2_09);
-- orx2_10
orx2_10_buf : IBUFDS port map (I=>orx2_10_p, IB=>orx2_10_n, O=>orx2_10);
-- orx2_11
orx2_11_buf : IBUFDS port map (I=>orx2_11_p, IB=>orx2_11_n, O=>orx2_11);
-- orx2_12
orx2_12_buf : IBUFDS port map (I=>orx2_12_p, IB=>orx2_12_n, O=>orx2_12);


-- From QPLL

-- qpll_clk40MHz
qpll_clk40MHz_buf : IBUFDS port map (I=>qpll_clk40MHz_p, IB=>qpll_clk40MHz_n, O=>qpll_clk40MHz);
-- qpll_clk80MHz
qpll_clk80MHz_buf : IBUFDS port map (I=>qpll_clk80MHz_p, IB=>qpll_clk80MHz_n, O=>qpll_clk80MHz);


-- From Test Connector

-- ck_0
ck_0_buf : IBUFDS port map (I=>ck_0_p, IB=>ck_0_n, O=>ck_0);
-- ck_1
ck_1_buf : IBUFDS port map (I=>ck_1_p, IB=>ck_1_n, O=>ck_1);
-- tclk
tclk_buf : IBUFDS port map (I=>tclk_p, IB=>tclk_n, O=>ck_2);

-- rx_0
rx_0_buf : IBUFDS port map (I=>rx_0_p, IB=>rx_0_n, O=>rx_0);
-- rx_1
rx_1_buf : IBUFDS port map (I=>rx_1_p, IB=>rx_1_n, O=>rx_1);
-- rx_2
rx_2_buf : IBUFDS port map (I=>rx_2_p, IB=>rx_2_n, O=>rx_2);
-- rx_3
rx_3_buf : IBUFDS port map (I=>rx_3_p, IB=>rx_3_n, O=>rx_3);
-- rx_4
rx_4_buf : IBUFDS port map (I=>rx_4_p, IB=>rx_4_n, O=>rx_4);
-- rx_5
rx_5_buf : IBUFDS port map (I=>rx_5_p, IB=>rx_5_n, O=>rx_5);
-- rx_6
rx_6_buf : IBUFDS port map (I=>rx_6_p, IB=>rx_6_n, O=>rx_6);
-- rx_7
rx_7_buf : IBUFDS port map (I=>rx_7_p, IB=>rx_7_n, O=>rx_7);
-- rx_8
rx_8_buf : IBUFDS port map (I=>rx_8_p, IB=>rx_8_n, O=>rx_8);
-- rx_9
rx_9_buf : IBUFDS port map (I=>rx_9_p, IB=>rx_9_n, O=>rx_9);
-- rx_10
rx_10_buf : IBUFDS port map (I=>rx_10_p, IB=>rx_10_n, O=>rx_10);


-- LVDS output buffers

-- To OT1 (GigaBit Link)

-- gl1_tx
gl1_tx_buf : OBUFDS port map (I=>gl0_tx, O=>gl0_tx_p, OB=>gl0_tx_n);


-- To OT2 (GigaBit Link)

-- gl2_tx
gl2_tx_buf : OBUFDS port map (I=>gl1_tx, O=>gl1_tx_p, OB=>gl1_tx_n);


-- To TX1 

-- otx1_01
otx1_01_buf : OBUFDS port map (I=>otx1_01, O=>otx1_01_p, OB=>otx1_01_n);
-- otx1_02
otx1_02_buf : OBUFDS port map (I=>otx1_02, O=>otx1_02_p, OB=>otx1_02_n);
-- otx1_03
otx1_03_buf : OBUFDS port map (I=>otx1_03, O=>otx1_03_p, OB=>otx1_03_n);
-- otx1_04
otx1_04_buf : OBUFDS port map (I=>otx1_04, O=>otx1_04_p, OB=>otx1_04_n);
-- otx1_05
otx1_05_buf : OBUFDS port map (I=>otx1_05, O=>otx1_05_p, OB=>otx1_05_n);
-- otx1_06
otx1_06_buf : OBUFDS port map (I=>otx1_06, O=>otx1_06_p, OB=>otx1_06_n);
-- otx1_07
otx1_07_buf : OBUFDS port map (I=>otx1_07, O=>otx1_07_p, OB=>otx1_07_n);
-- otx1_08
otx1_08_buf : OBUFDS port map (I=>otx1_08, O=>otx1_08_p, OB=>otx1_08_n);
-- otx1_09
otx1_09_buf : OBUFDS port map (I=>otx1_09, O=>otx1_09_p, OB=>otx1_09_n);
-- otx1_10
otx1_10_buf : OBUFDS port map (I=>otx1_10, O=>otx1_10_p, OB=>otx1_10_n);
-- otx1_11
otx1_11_buf : OBUFDS port map (I=>otx1_11, O=>otx1_11_p, OB=>otx1_11_n);
-- otx1_12
otx1_12_buf : OBUFDS port map (I=>otx1_12, O=>otx1_12_p, OB=>otx1_12_n);

-- To TX2 

-- otx2_01
otx2_01_buf : OBUFDS port map (I=>otx2_01, O=>otx2_01_p, OB=>otx2_01_n);
-- otx2_02
otx2_02_buf : OBUFDS port map (I=>otx2_02, O=>otx2_02_p, OB=>otx2_02_n);
-- otx2_03
otx2_03_buf : OBUFDS port map (I=>otx2_03, O=>otx2_03_p, OB=>otx2_03_n);
-- otx2_04
otx2_04_buf : OBUFDS port map (I=>otx2_04, O=>otx2_04_p, OB=>otx2_04_n);
-- otx2_05
otx2_05_buf : OBUFDS port map (I=>otx2_05, O=>otx2_05_p, OB=>otx2_05_n);
-- otx2_06
otx2_06_buf : OBUFDS port map (I=>otx2_06, O=>otx2_06_p, OB=>otx2_06_n);
-- otx2_07
otx2_07_buf : OBUFDS port map (I=>otx2_07, O=>otx2_07_p, OB=>otx2_07_n);
-- otx2_08
otx2_08_buf : OBUFDS port map (I=>otx2_08, O=>otx2_08_p, OB=>otx2_08_n);
-- otx2_09
otx2_09_buf : OBUFDS port map (I=>otx2_09, O=>otx2_09_p, OB=>otx2_09_n);
-- otx2_10
otx2_10_buf : OBUFDS port map (I=>otx2_10, O=>otx2_10_p, OB=>otx2_10_n);
-- otx2_11
otx2_11_buf : OBUFDS port map (I=>otx2_11, O=>otx2_11_p, OB=>otx2_11_n);
-- otx2_12
otx2_12_buf : OBUFDS port map (I=>otx2_12, O=>otx2_12_p, OB=>otx2_12_n);


-- To Test Connector

-- rxb
rxb_buf : OBUFDS port map (I=>rxb, O=>rxb_p, OB=>rxb_n);
-- tx_0
tx_0_buf : OBUFDS port map (I=>tx_0, O=>tx_0_p, OB=>tx_0_n);
-- tx_1
tx_1_buf : OBUFDS port map (I=>tx_1, O=>tx_1_p, OB=>tx_1_n);
-- tx_2
tx_2_buf : OBUFDS port map (I=>tx_2, O=>tx_2_p, OB=>tx_2_n);
-- tx_1
tx_3_buf : OBUFDS port map (I=>tx_3, O=>tx_3_p, OB=>tx_3_n);
-- tx_1
tx_4_buf : OBUFDS port map (I=>tx_4, O=>tx_4_p, OB=>tx_4_n);
-- tx_1
tx_5_buf : OBUFDS port map (I=>tx_5, O=>tx_5_p, OB=>tx_5_n);
-- tx_1
tx_6_buf : OBUFDS port map (I=>tx_6, O=>tx_6_p, OB=>tx_6_n);
-- tx_1
tx_7_buf : OBUFDS port map (I=>tx_7, O=>tx_7_p, OB=>tx_7_n);
-- tx_1
tx_8_buf : OBUFDS port map (I=>tx_8, O=>tx_8_p, OB=>tx_8_n);
-- tx_1
tx_9_buf : OBUFDS port map (I=>tx_9, O=>tx_9_p, OB=>tx_9_n);
-- tx_1
tx_10_buf : OBUFDS port map (I=>tx_10, O=>tx_10_p, OB=>tx_10_n);




-- PLL_BASE_inst0 : PLL_BASE
-- generic map (
-- BANDWIDTH => "OPTIMIZED", -- "HIGH", "LOW" or "OPTIMIZED"
-- CLKFBOUT_MULT => 1, -- Multiplication factor for all output clocks
-- CLKFBOUT_PHASE => 0.0, -- Phase shift (degrees) of all output clocks
-- CLKIN_PERIOD => 25.000, -- Clock period (ns) of input clock on CLKIN
-- CLKOUT0_DIVIDE => 4, -- Division factor for CLKOUT0 (1 to 128)
-- CLKOUT0_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT0 (0.01 to 0.99)
-- CLKOUT0_PHASE => 0.0,
-- CLKOUT1_DIVIDE => 2, -- Division factor for CLKOUT1 (1 to 128)
-- CLKOUT1_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT1 (0.01 to 0.99)
-- CLKOUT1_PHASE => 0.0, -- Phase shift (degrees) for CLKOUT1 (0.0 to 360.0)
-- CLKOUT2_DIVIDE => 20, -- Division factor for CLKOUT2 (1 to 128)
-- CLKOUT2_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT2 (0.01 to 0.99)
-- CLKOUT2_PHASE => 0.0, -- Phase shift (degrees) for CLKOUT2 (0.0 to 360.0)
-- CLKOUT3_DIVIDE => 20, -- Division factor for CLKOUT3 (1 to 128)
-- CLKOUT3_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT3 (0.01 to 0.99)
-- CLKOUT3_PHASE => 0.0, -- Phase shift (degrees) for CLKOUT3 (0.0 to 360.0)
-- CLKOUT4_DIVIDE => 20, -- Division factor for CLKOUT4 (1 to 128)
-- CLKOUT4_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT4 (0.01 to 0.99)
-- CLKOUT4_PHASE => 0.0, -- Phase shift (degrees) for CLKOUT4 (0.0 to 360.0)
-- CLKOUT5_DIVIDE => 20, -- Division factor for CLKOUT5 (1 to 128)
-- CLKOUT5_DUTY_CYCLE => 0.5, -- Duty cycle for CLKOUT5 (0.01 to 0.99)
-- CLKOUT5_PHASE => 0.0, -- Phase shift (degrees) for CLKOUT5 (0.0 to 360.0)
-- -- THIS WAS MISSING !!!!!!!
-- CLK_FEEDBACK => "CLKFBOUT",           -- Clock source to drive CLKFBIN ("CLKFBOUT" or "CLKOUT0")
-- COMPENSATION => "SYSTEM_SYNCHRONOUS", -- "SYSTEM_SYNCHRNOUS",
-- -- "SOURCE_SYNCHRNOUS", "INTERNAL",
-- -- "EXTERNAL", "DCM2PLL", "PLL2DCM"
-- DIVCLK_DIVIDE => 1, -- Division factor for all clocks (1 to 52)
-- REF_JITTER => 0.100,
-- RESET_ON_LOSS_OF_LOCK => FALSE        -- Must be set to FALSE
-- ) -- Input reference jitter (0.000 to 0.999 UI%)
-- port map (
-- CLKFBOUT => pll_fb0,
-- CLKOUT0 => pll_jtag_m_tck, -- One of six general clock output signals
-- CLKOUT1 => pll_jtag_m_tck_tp, -- One of six general clock output signals
-- LOCKED => pll_locked0, -- Active high PLL lock signal
-- CLKIN => cmsclk_in, 
-- CLKFBIN => pll_fb0,-- Clock input
-- RST => '0' -- Asynchronous PLL reset
-- );

  -- MMCM_BASE: Base Mixed Mode Clock Manager
   --            Virtex-6
   -- Xilinx HDL Language Template, version 12.3

pll1_rst <= '0';
pll1_pd <= '0';
pll2_rst <= '0';
pll2_pd <= '0';
pll3_rst <= '0';
pll3_pd <= '0';


   MMCM_BASE_PLL1 : MMCM_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- Jitter programming ("HIGH","LOW","OPTIMIZED")
      CLKFBOUT_MULT_F => 16.0,    -- Multiply value for all CLKOUT (5.0-64.0).
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB (0.00-360.00).
      CLKIN1_PERIOD => 25.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
-- bgb      CLKOUT0_DIVIDE_F => 2.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
      CLKOUT0_DIVIDE_F => 16.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
      -- CLKOUT0_DUTY_CYCLE - CLKOUT6_DUTY_CYCLE: Duty cycle for each CLKOUT (0.01-0.99).
      CLKOUT0_DUTY_CYCLE => 0.5,
      CLKOUT1_DUTY_CYCLE => 0.5,
      CLKOUT2_DUTY_CYCLE => 0.5,
      CLKOUT3_DUTY_CYCLE => 0.5,
      CLKOUT4_DUTY_CYCLE => 0.5,
      CLKOUT5_DUTY_CYCLE => 0.5,
      CLKOUT6_DUTY_CYCLE => 0.5,
      -- CLKOUT0_PHASE - CLKOUT6_PHASE: Phase offset for each CLKOUT (-360.000-360.000).
      CLKOUT0_PHASE => 0.0,
      CLKOUT1_PHASE => 0.0,
      CLKOUT2_PHASE => 0.0,
      CLKOUT3_PHASE => 0.0,
      CLKOUT4_PHASE => 0.0,
      CLKOUT5_PHASE => 0.0,
      CLKOUT6_PHASE => 0.0,
      -- CLKOUT1_DIVIDE - CLKOUT6_DIVIDE: Divide amount for each CLKOUT (1-128)
-- bgb     CLKOUT1_DIVIDE => 16,
-- bgb     CLKOUT2_DIVIDE => 2,
-- bgb     CLKOUT3_DIVIDE => 16,
-- bgb     CLKOUT4_DIVIDE => 64,
-- bgb     CLKOUT5_DIVIDE => 128, --- 256,
-- bgb     CLKOUT6_DIVIDE => 128, --- 512,
      CLKOUT1_DIVIDE => 2, -- 320 MHz
      CLKOUT2_DIVIDE => 16, -- 40 MHz
      CLKOUT3_DIVIDE => 64, -- 10 MHz
      CLKOUT4_DIVIDE => 2,  --  2.5 MHz
      CLKOUT5_DIVIDE => 128, -- 5 MHz
      CLKOUT6_DIVIDE => 128, -- 5 MHz
-- bgb     CLKOUT4_CASCADE => FALSE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
      CLKOUT4_CASCADE => TRUE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
      CLOCK_HOLD => FALSE,       -- Hold VCO Frequency (TRUE/FALSE)
      DIVCLK_DIVIDE => 1,        -- Master division value (1-80)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI (0.000-0.999).
      STARTUP_WAIT => FALSE      -- Not supported. Must be set to FALSE.
   )
   port map (
      -- Clock Outputs: 1-bit (each) User configurable clock outputs
      CLKOUT0 => pll_clk40,     			-- 1-bit CLKOUT0 output
      CLKOUT0B => open,   					-- 1-bit Inverted CLKOUT0 output
      CLKOUT1 => pll_clk320_tx,     	-- 1-bit CLKOUT1 output
      CLKOUT1B => open,   					-- 1-bit Inverted CLKOUT1 output
      CLKOUT2 => pll_dmbvme_clk,    	-- 1-bit CLKOUT2 output
      CLKOUT2B => open,   					-- 1-bit Inverted CLKOUT2 output
      CLKOUT3 => pll_dmbvme_clk_s1,    -- 1-bit CLKOUT3 output
      CLKOUT3B => open,   					-- 1-bit Inverted CLKOUT3 output
      CLKOUT4 => pll_dmbvme_clk_s2,    -- 1-bit CLKOUT4 output
-- bgb      CLKOUT5 => pll_dmbvme_clk_s3,    -- 1-bit CLKOUT5 output
      CLKOUT5 => open,    -- 1-bit CLKOUT5 output
      CLKOUT6 => open,      				-- 1-bit CLKOUT6 output
      -- Feedback Clocks: 1-bit (each) Clock feedback ports
      CLKFBOUT => pll1_fb,   				-- 1-bit Feedback clock output
      CLKFBOUTB => open, 					-- 1-bit Inverted CLKFBOUT output
      -- Status Port: 1-bit (each) MMCM status ports
      LOCKED => pll1_locked,  			-- 1-bit LOCK output
      -- Clock Input: 1-bit (each) Clock input
      CLKIN1 => clkin, -- qpll_clk40MHz,
      -- Control Ports: 1-bit (each) MMCM control ports
      PWRDWN => pll1_pd,       			-- 1-bit Power-down input
      RST => pll1_rst,             		-- 1-bit Reset input
      -- Feedback Clocks: 1-bit (each) Clock feedback ports
      CLKFBIN => pll1_fb      			-- 1-bit Feedback clock input
   );

--   MMCM_BASE_PLL2 : MMCM_BASE
--   generic map (
--      BANDWIDTH => "OPTIMIZED",  -- Jitter programming ("HIGH","LOW","OPTIMIZED")
--      CLKFBOUT_MULT_F => 16.0,    -- Multiply value for all CLKOUT (5.0-64.0).
--      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB (0.00-360.00).
--      CLKIN1_PERIOD => 25.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
--      CLKOUT0_DIVIDE_F => 2.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
--      -- CLKOUT0_DUTY_CYCLE - CLKOUT6_DUTY_CYCLE: Duty cycle for each CLKOUT (0.01-0.99).
--      CLKOUT0_DUTY_CYCLE => 0.5,
--      CLKOUT1_DUTY_CYCLE => 0.5,
--      CLKOUT2_DUTY_CYCLE => 0.5,
--      CLKOUT3_DUTY_CYCLE => 0.5,
--      CLKOUT4_DUTY_CYCLE => 0.5,
--      CLKOUT5_DUTY_CYCLE => 0.5,
--      CLKOUT6_DUTY_CYCLE => 0.5,
--      -- CLKOUT0_PHASE - CLKOUT6_PHASE: Phase offset for each CLKOUT (-360.000-360.000).
--      CLKOUT0_PHASE => 0.0,
--      CLKOUT1_PHASE => 0.0,
--      CLKOUT2_PHASE => 0.0,
--      CLKOUT3_PHASE => 0.0,
--      CLKOUT4_PHASE => 0.0,
--      CLKOUT5_PHASE => 0.0,
--      CLKOUT6_PHASE => 0.0,
--      -- CLKOUT1_DIVIDE - CLKOUT6_DIVIDE: Divide amount for each CLKOUT (1-128)
--      CLKOUT1_DIVIDE => 2,
--      CLKOUT2_DIVIDE => 2,
--      CLKOUT3_DIVIDE => 2,
--      CLKOUT4_DIVIDE => 2,
--      CLKOUT5_DIVIDE => 2,
--      CLKOUT6_DIVIDE => 2,
--      CLKOUT4_CASCADE => FALSE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
--      CLOCK_HOLD => FALSE,       -- Hold VCO Frequency (TRUE/FALSE)
--      DIVCLK_DIVIDE => 1,        -- Master division value (1-80)
--      REF_JITTER1 => 0.0,        -- Reference input jitter in UI (0.000-0.999).
--      STARTUP_WAIT => FALSE      -- Not supported. Must be set to FALSE.
--   )
--   port map (
--      -- Clock Outputs: 1-bit (each) User configurable clock outputs
--      CLKOUT0 => pll_dcfeb0_clk320_tx, -- 1-bit CLKOUT0 output
--      CLKOUT0B => open,   					-- 1-bit Inverted CLKOUT0 output
--      CLKOUT1 => pll_dcfeb1_clk320_tx,  -- 1-bit CLKOUT1 output
--      CLKOUT1B => open,   					-- 1-bit Inverted CLKOUT1 output
--      CLKOUT2 => pll_dcfeb2_clk320_tx,  -- 1-bit CLKOUT2 output
--      CLKOUT2B => open,   					-- 1-bit Inverted CLKOUT2 output
--      CLKOUT3 => pll_dcfeb3_clk320_tx, -- 1-bit CLKOUT3 output
--      CLKOUT3B => open,   					-- 1-bit Inverted CLKOUT3 output
--      CLKOUT4 => pll_dcfeb4_clk320_tx, -- 1-bit CLKOUT4 output
--      CLKOUT5 => pll_dcfeb5_clk320_tx, -- 1-bit CLKOUT5 output
--      CLKOUT6 => pll_dcfeb6_clk320_tx, -- 1-bit CLKOUT6 output
--      -- Feedback Clocks: 1-bit (each) Clock feedback ports
--      CLKFBOUT => pll2_fb,   				-- 1-bit Feedback clock output
--      CLKFBOUTB => open, 					-- 1-bit Inverted CLKFBOUT output
--      -- Status Port: 1-bit (each) MMCM status ports
--      LOCKED => pll2_locked,  			-- 1-bit LOCK output
--      -- Clock Input: 1-bit (each) Clock input
--      CLKIN1 => clkin, -- qpll_clk40MHz,
--      -- Control Ports: 1-bit (each) MMCM control ports
--      PWRDWN => pll2_pd,       			-- 1-bit Power-down input
--      RST => pll2_rst,             		-- 1-bit Reset input
--      -- Feedback Clocks: 1-bit (each) Clock feedback ports
--      CLKFBIN => pll2_fb      			-- 1-bit Feedback clock input
--   );
--
--   MMCM_BASE_PLL3 : MMCM_BASE
--   generic map (
--      BANDWIDTH => "OPTIMIZED",  -- Jitter programming ("HIGH","LOW","OPTIMIZED")
--      CLKFBOUT_MULT_F => 16.0,    -- Multiply value for all CLKOUT (5.0-64.0).
--      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB (0.00-360.00).
--      CLKIN1_PERIOD => 25.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
--      CLKOUT0_DIVIDE_F => 2.0,   -- Divide amount for CLKOUT0 (1.000-128.000).
--      -- CLKOUT0_DUTY_CYCLE - CLKOUT6_DUTY_CYCLE: Duty cycle for each CLKOUT (0.01-0.99).
--      CLKOUT0_DUTY_CYCLE => 0.5,
--      CLKOUT1_DUTY_CYCLE => 0.5,
--      CLKOUT2_DUTY_CYCLE => 0.5,
--      CLKOUT3_DUTY_CYCLE => 0.5,
--      CLKOUT4_DUTY_CYCLE => 0.5,
--      CLKOUT5_DUTY_CYCLE => 0.5,
--      CLKOUT6_DUTY_CYCLE => 0.5,
--      -- CLKOUT0_PHASE - CLKOUT6_PHASE: Phase offset for each CLKOUT (-360.000-360.000).
--      CLKOUT0_PHASE => 0.0,
--      CLKOUT1_PHASE => 0.0,
--      CLKOUT2_PHASE => 0.0,
--      CLKOUT3_PHASE => 0.0,
--      CLKOUT4_PHASE => 0.0,
--      CLKOUT5_PHASE => 0.0,
--      CLKOUT6_PHASE => 0.0,
--      -- CLKOUT1_DIVIDE - CLKOUT6_DIVIDE: Divide amount for each CLKOUT (1-128)
--      CLKOUT1_DIVIDE => 2,
--      CLKOUT2_DIVIDE => 2,
--      CLKOUT3_DIVIDE => 2,
--      CLKOUT4_DIVIDE => 2,
--      CLKOUT5_DIVIDE => 2,
--      CLKOUT6_DIVIDE => 2,
--      CLKOUT4_CASCADE => FALSE,  -- Cascase CLKOUT4 counter with CLKOUT6 (TRUE/FALSE)
--      CLOCK_HOLD => FALSE,       -- Hold VCO Frequency (TRUE/FALSE)
--      DIVCLK_DIVIDE => 1,        -- Master division value (1-80)
--      REF_JITTER1 => 0.0,        -- Reference input jitter in UI (0.000-0.999).
--      STARTUP_WAIT => FALSE      -- Not supported. Must be set to FALSE.
--   )
--   port map (
--      -- Clock Outputs: 1-bit (each) User configurable clock outputs
--      CLKOUT0 => pll_dcfeb0_clk320_rx, -- 1-bit CLKOUT0 output
--      CLKOUT0B => open,   					-- 1-bit Inverted CLKOUT0 output
--      CLKOUT1 => pll_dcfeb1_clk320_rx, -- 1-bit CLKOUT1 output
--      CLKOUT1B => open,   					-- 1-bit Inverted CLKOUT1 output
--      CLKOUT2 => pll_dcfeb2_clk320_rx, -- 1-bit CLKOUT2 output
--      CLKOUT2B => open,   					-- 1-bit Inverted CLKOUT2 output
--      CLKOUT3 => pll_dcfeb3_clk320_rx, -- 1-bit CLKOUT3 output
--      CLKOUT3B => open,   					-- 1-bit Inverted CLKOUT3 output
--      CLKOUT4 => pll_dcfeb4_clk320_rx, -- 1-bit CLKOUT4 output
--      CLKOUT5 => pll_dcfeb5_clk320_rx, -- 1-bit CLKOUT5 output
--      CLKOUT6 => pll_dcfeb6_clk320_rx, -- 1-bit CLKOUT6 output
--      -- Feedback Clocks: 1-bit (each) Clock feedback ports
--      CLKFBOUT => pll3_fb,   				-- 1-bit Feedback clock output
--      CLKFBOUTB => open, 					-- 1-bit Inverted CLKFBOUT output
--      -- Status Port: 1-bit (each) MMCM status ports
--      LOCKED => pll3_locked,  			-- 1-bit LOCK output
--      -- Clock Input: 1-bit (each) Clock input
--      CLKIN1 => clkin, -- qpll_clk80MHz,
--      -- Control Ports: 1-bit (each) MMCM control ports
--      PWRDWN => pll3_pd,       			-- 1-bit Power-down input
--      RST => pll3_rst,             		-- 1-bit Reset input
--      -- Feedback Clocks: 1-bit (each) Clock feedback ports
--      CLKFBIN => pll3_fb      			-- 1-bit Feedback clock input
--   );

    -- End of MMCM_BASE_inst instantiation
				
---- Global Clock Buffers !!!!!!!
--dcfeb0_clk320_rx_buf : BUFG port map (I=>pll_dcfeb0_clk320_rx, O=>dcfeb0_clk320_rx);
--dcfeb1_clk320_rx_buf : BUFG port map (I=>pll_dcfeb1_clk320_rx, O=>dcfeb1_clk320_rx);
--dcfeb2_clk320_rx_buf : BUFG port map (I=>pll_dcfeb2_clk320_rx, O=>dcfeb2_clk320_rx);
--dcfeb3_clk320_rx_buf : BUFG port map (I=>pll_dcfeb3_clk320_rx, O=>dcfeb3_clk320_rx);
--dcfeb4_clk320_rx_buf : BUFG port map (I=>pll_dcfeb4_clk320_rx, O=>dcfeb4_clk320_rx);
--dcfeb5_clk320_rx_buf : BUFG port map (I=>pll_dcfeb5_clk320_rx, O=>dcfeb5_clk320_rx);
--dcfeb6_clk320_rx_buf : BUFG port map (I=>pll_dcfeb6_clk320_rx, O=>dcfeb6_clk320_rx);

--dcfeb0_clk320_tx_buf : BUFG port map (I=>pll_dcfeb0_clk320_tx, O=>dcfeb0_clk320_tx);
--dcfeb1_clk320_tx_buf : BUFG port map (I=>pll_dcfeb1_clk320_tx, O=>dcfeb1_clk320_tx);
--dcfeb2_clk320_tx_buf : BUFG port map (I=>pll_dcfeb2_clk320_tx, O=>dcfeb2_clk320_tx);
--dcfeb3_clk320_tx_buf : BUFG port map (I=>pll_dcfeb3_clk320_tx, O=>dcfeb3_clk320_tx);
--dcfeb4_clk320_tx_buf : BUFG port map (I=>pll_dcfeb4_clk320_tx, O=>dcfeb4_clk320_tx);
--dcfeb5_clk320_tx_buf : BUFG port map (I=>pll_dcfeb5_clk320_tx, O=>dcfeb5_clk320_tx);
--dcfeb6_clk320_tx_buf : BUFG port map (I=>pll_dcfeb6_clk320_tx, O=>dcfeb6_clk320_tx);

clk40_buf : BUFG port map (I=>pll_clk40, O=>clk40);
clk320_tx_buf : BUFG port map (I=>pll_clk320_tx, O=>clk320_tx);
dmbvme_clk_buf : BUFG port map (I=>pll_dmbvme_clk, O=>dmbvme_clk);
dmbvme_clk_s1_buf : BUFG port map (I=>pll_dmbvme_clk_s1, O=>dmbvme_clk_s1);
dmbvme_clk_s2_buf : BUFG port map (I=>pll_dmbvme_clk_s2, O=>dmbvme_clk_s2);
-- bgb dmbvme_clk_s3_buf : BUFG port map (I=>pll_dmbvme_clk_s3, O=>dmbvme_clk_s3);
   dmbvme_clk_s3_b <= not dmbvme_clk_s3;
    FD(dmbvme_clk_s3_b,dmbvme_clk_s2,dmbvme_clk_s3); -- 1.25 MHz clock (bgb)


--otx2_01 <= dcfeb0_clk320_tx;
--otx2_02 <= dcfeb1_clk320_tx;
--otx2_03 <= dcfeb2_clk320_tx;
--otx2_04 <= dcfeb3_clk320_tx;
--otx2_05 <= dcfeb4_clk320_tx;
--otx2_06 <= dcfeb5_clk320_tx;
--otx2_07 <= dcfeb6_clk320_tx;
otx2_01 <= clk320_tx;
otx2_02 <= clk320_tx;
otx2_03 <= clk320_tx;
otx2_04 <= clk320_tx;
otx2_05 <= clk320_tx;
otx2_06 <= clk320_tx;
otx2_07 <= clk320_tx;
otx2_08 <= '0';
otx2_09 <= '0';
otx2_10 <= '0'; 
otx2_11 <= '0'; 
otx2_12 <= '0'; 
 
otx1_01 <= '0'; 	-- in the LoopBack Configuration otx1_01 is driven by dcfebx_tx_dat   
otx1_02 <= '0'; 
otx1_03 <= '0'; 
otx1_04 <= '0'; 
otx1_05 <= '0'; 
otx1_06 <= '0'; 
otx1_07 <= '0'; 
otx1_08 <= '0';
 otx1_09 <= '0';
 otx1_10 <= '0'; 
otx1_11 <= '0'; 
 otx1_12 <= '0';

--dcfeb0_rx_dat <= orx1_01;
-- dcfeb1_rx_dat <= orx1_02; 	
-- dcfeb2_rx_dat <= orx1_03;
--dcfeb3_rx_dat <= orx1_04;
--dcfeb4_rx_dat <= orx1_05;
--dcfeb5_rx_dat <= orx1_06;
--dcfeb6_rx_dat <= orx1_07;

b2v_mbv : dmb_vme
PORT MAP (

-- Chip Scope Pro Logic Analyzer control -- bgb

    CSP_VME_LA_CTRL       => csp_vme_la_ctrl,       -- bgb -- inout
    CSP_LVMB_LA_CTRL       => csp_lvmb_la_ctrl,       -- bgb -- inout
    CSP_CFEB_JTAG_LA_CTRL => csp_cfeb_jtag_la_ctrl, -- bgb -- inout
	 VME_LA_TRG => vme_la_trg,                       -- bgb

-- VME signals 

		vme_addr => vme_addr,									-- input
		vme_data_in => vme_data_in,							-- input
		vme_data_out => vme_data_out,							-- output
		vme_am => vme_am,											-- input
		vme_gap => vme_gap,										-- input
		vme_ga => vme_ga,											-- input
		vme_ds_b => vme_ds_b,									-- input
		vme_as_b => vme_as_b,									-- input
		vme_lword_b => vme_lword_b,							-- input
		vme_write_b => vme_write_b,							-- input
		vme_iack_b => vme_iack_b,								-- input
		vme_sysreset_b => vme_sysreset_b,					-- input
		vme_sysfail_b => vme_sysfail_b,						-- input
		vme_sysfail_out => vme_sysfail_out,				-- output
		vme_berr_b => vme_berr_b,								-- input
		vme_berr_out => vme_berr_out,						-- output
		vme_dtack_b => vme_dtack_v6_b,							-- output
		vme_tovme => vme_tovme,										-- tovme
		vme_tovme_b => vme_tovme_b,										-- tovme*
		vme_doe => vme_doe,									-- doe
		vme_doe_b => vme_doe_b,									-- doe*

-- Clock

		clk => dmbvme_clk,											-- fpgaclk (40MHz)
		clk_s1 => dmbvme_clk_s1,									-- midclk (10MHz) 
		clk_s2 => dmbvme_clk_s2,									-- slowclk (2.5MHz)
		clk_s3 => dmbvme_clk_s3, 									-- slowclk2 (1.25MHz)

-- Reset

		rst => por,
		
-- JTAG signals To/From DCFEBs

		dl_jtag_tck => dl_jtag_tck,			
		dl_jtag_tms => dl_jtag_tms,					
		dl_jtag_tdi => dl_jtag_tdi,						
		dl_jtag_tdo => dl_jtag_tdo,					
		dl_rtn_shft_en => dl_rtn_shft_en,
		ul_jtag_tck => ul_jtag_tck,					
		ul_jtag_tms => ul_jtag_tms,				
		ul_jtag_tdi => ul_jtag_tdi,						

-- Reprogram To DCFEB FPGA (CFEBPRG)

		dl_reprogram => dl_reprogram,

-- Done from DCFEB FPGA (CFEBPRG)

		ul_done => ul_done,

-- To/From O-DMB ADC

		adc_cs => adc_cs,									
		adc_sclk =>	adc_sclk,								
		adc_sdain => adc_sdain,								
		adc_sdaout => adc_sdaout,							
		
-- To/From O-DMB DAC

		dac_cs => dac_cs,								
		dac_sclk => dac_sclk,										
		dac_sdain => dac_sdain,									
		dac_sdaout => dac_sdaout,										

-- To/From DCFEB FIFOs

		fifo_wr_ck => fifo_wr_ck,
		fifo_wr_en => fifo_tm_wr_en,	
		fifo_rw_en => fifo_rw_en,	
		fifo_rm_en => fifo_rm_en,	
		fifo_tm_en => fifo_tm_en,	

		fifo_in => fifo_in,
		fifo_out => fifo_out,

-- SPI signals To/From DCFEBs (ADCs and DACs)

		dl_spi_cs0 => dl_spi_cs0,
		dl_spi_cs1 => dl_spi_cs1,		
		dl_spi_scl => dl_spi_scl,			
		dl_spi_sda => dl_spi_sda,		 
		ul_spi_scl => ul_spi_scl,	
		ul_spi_sda => ul_spi_sda,	 
		ul_spi_busy => ul_spi_busy,		 

-- Token signals To/From DCFEBs

		dl_tkn => dl_tkn,				
		ul_tkn => ul_tkn,				

-- I2C signals To/From DCFEBs (FF-EMU ASICs)

		dl_i2c_scl => dl_i2c_scl,				
		dl_i2c_sda => dl_i2c_sda,				
		ul_i2c_scl => ul_i2c_scl,				
		ul_i2c_sda => ul_i2c_sda,			

-- From/To QPLL

		qpll_autorestart => qpll_autorestart,						-- NEW!
		qpll_mode => qpll_mode,											-- NEW!
		qpll_extcontrol => qpll_extcontrol,							-- NEW!
		qpll_reset => qpll_reset,										-- NEW!
		qpll_f0sel => qpll_f0sel,										-- NEW!
		qpll_locked => qpll_locked,									-- NEW!
		qpll_error => qpll_error,										-- NEW!

-- From/To LVMB

		lvmb_pon => int_lvmb_pon,
		pon_load => pon_load,
		pon_oe_b => pon_en,
		r_lvmb_pon => r_lvmb_pon,		
		lvmb_csb => int_lvmb_csb,			
		lvmb_sclk => int_lvmb_sclk,
		lvmb_sdin => int_lvmb_sdin,			
		lvmb_sdout => int_lvmb_sdout,
		
		diagout_cfebjtag => diagout_cfebjtag

);

		lvmb_sdout <= int_lvmb_sdout;

-- DMB_CTRL FPGA

b2v_mbc : dmb_ctrl
PORT MAP (

		ccb_cmd => ccb_cmd,												-- ccbcmnd(5 downto 0) - from J3
		ccb_cmd_s => ccb_cmd_s,											-- ccbcmnd(6) - from J3
		ccb_data => ccb_data,											-- ccbdata(7 downto 0) - from J3
		ccb_data_s => ccb_data_s,										-- ccbdata(8) - from J3
		ccb_cal => ccb_cal,												-- ccbcal(2 downto 0) - from J3
		ccb_crsv => ccb_crsv,											-- NEW [ccbrsv(6)], ccbrsv(3 downto 0) - from J3
		ccb_drsv => ccb_drsv,											-- ccbrsv(5 downto 4) - from J3
		ccb_rsvo => ccb_rsvo,											-- NEW [ccbrsv(11)], ccbrsv(10 downto 7) - from J3
		ccb_rsvi => ccb_rsvi,											-- ccbrsv(14 downto 12) - to J3
		ccb_bx0 => ccb_bx0,												-- bx0 - from J3
		ccb_bxrst => ccb_bxrst,											-- bxrst - from J3
		ccb_l1acc => ccb_l1acc,											-- l1acc - from J3
		ccb_l1arst => ccb_l1arst,										-- l1rst - from J3
		ccb_l1rls => ccb_l1rls,											-- l1rls - to J3
		ccb_clken => ccb_clken,											-- clken - from J3

		rawlct => rawlct,													-- rawlct(5 downto 0) - from J4
		lctdav1 => lctdav1,												-- lctdav1 - from J4
		lctdav2 => lctdav2,												-- lctdav2 - from J4
		lctrqst => lctrqst,												-- lctrqst(2 downto 1) - to J4
		rsvtd_in => rsvtd_in,											-- spare(7 DOWNTO 3) - to J4
--		rsvtd_out => rsvtd_out(6 downto 3),											-- spare(7 DOWNTO 3) - from J4
		rsvtd_out => rsvtd_out,											-- spare(2 DOWNTO 0) - from J4

-- From GigaLinks

		grx0_data => "0000000000000000",								-- glin(15 downto 0)									  
		grx0_data_valid => '0',		 
		grx1_data => "0000000000000000",								-- glin(15 downto 0)											  
		grx1_data_valid => '0',			 
	
-- To GigaLinks

		gtx0_data => gtx0_data,											-- dout(15 downto 0)											  
		gtx0_data_valid => gtx0_data_valid,												
		gtx1_data => gtx1_data,													-- dout(15 downto 0)											  
		gtx1_data_valid => gtx1_data_valid,												
	
-- From/To FIFOs

		fifo_rd_ck => fifo_rd_ck,										  
		fifo_rd_en => fifo_rd_en,										  
		fifo_sel => fifo_sel,			 

		fifo_out => fifo_out,				

		fifo_mrst_b => fifo_mrst_b,									-- ok -> fifo_mrst* - to FIFOs 
		fifo_prst_b => fifo_prst_b,									-- ok -> fifo_prst* - to FIFOs 

		fifo_full_b => fifo_full,									-- full*(7 DOWNTO 1) - from FIFOs 
		fifo_half_b => fifo_half,									-- half*(7 DOWNTO 1) - from FIFOs 
		fifo_pae_b => fifo_pae,										-- paef*(7 DOWNTO 1) - from FIFOs 
		fifo_empty_b => fifo_empty,									-- emptyf*(7 DOWNTO 1) - from FIFOs 

-- From/To DCFEBs (FF-EMU-MOD)

		ul_dav => ul_dav,															-- davf(5 DOWNTO 1) - from DCFEBs 
		ul_movlp => ul_movlp,													-- movlp(5 DOWNTO 1) - from DCFEBs

		dl_lct => dl_lct, 														-- lctf(5 DOWNTO 1) - to DCFEBs
		dl_gtrig =>	dl_gtrig,													-- febrst - to DCFEBs
		dl_injpulse => dl_injpulse,											-- inject - to DCFEBs
		dl_extpulse => dl_extpulse,											-- extpulse - to DCFEBs

-- From/To LVMB

		r_lvmb_pon => r_lvmb_pon,		
		lvmb_csb => int_lvmb_csb,			
		lvmb_sclk => int_lvmb_sclk,
		lvmb_sdin => int_lvmb_sdin,		
		lvmb_sdout => int_lvmb_sdout

);

-- OT Manager
	  
b2v_otm : ot_mgr
PORT MAP (
		 otx1_tx_en => otx1_tx_en,
		 otx1_tx_dis => otx1_tx_dis,
		 otx1_reset => otx1_reset,
		 otx1_fault => otx1_fault,
		 otx2_tx_en => otx2_tx_en,
		 otx2_tx_dis => otx2_tx_dis,
		 otx2_reset => otx2_reset,
		 otx2_fault => otx2_fault,
		 orx1_rx_en => orx1_rx_en,
		 orx1_en_sd => orx1_en_sd,
		 orx1_sd => orx1_sd,
		 orx1_sq_en => orx1_sq_en,
		 orx2_rx_en => orx2_rx_en,
		 orx2_en_sd => orx2_en_sd,
		 orx2_sd => orx2_sd,
		 orx2_sq_en => orx2_sq_en);



			
PMAP_V6_DCFEB0 : DCFEB_V6
	PORT MAP(

		CSP_DCFEB_LA_CTRL => csp_dcfeb0_la_ctrl, -- bgb logic analyzer control
		CSP_JTAG_SIM_LA_CTRL => csp_jtag_sim_la_ctrl, -- bgb logic analyzer control
		VME_LA_TRG => vme_la_trg,               -- trigger from VME logic analyzer 
      FASTCLK => clk40,								 -- clock for logic analyzer
		adc_mask => adc_mask,						 -- outto LED's
		
	    trst => por, 	
	    tck => dl_jtag_tck(1), 	
	    tms => dl_jtag_tms,
	    tdi => dl_jtag_tdi,
		 rtn_shft_en => dl_rtn_shft_en(1),
	    tdo => dl_jtag_tdo(1));
			
ul_jtag_tck(1) <= dl_jtag_tck(1);





-- LVMB ADCs

PMAP_LVMB_ADC1 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(0),
		ce => int_lvmb_csb(0),
		rst => por,
		device => "0001");

PMAP_LVMB_ADC2 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(1),
		ce => int_lvmb_csb(1),
		rst => por,
		device => "0010");

PMAP_LVMB_ADC3 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(2),
		ce => int_lvmb_csb(2),
		rst => por,
		device => "0011");

PMAP_LVMB_ADC4 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(3),
		ce => int_lvmb_csb(3),
		rst => por,
		device => "0100");

PMAP_LVMB_ADC5 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(4),
		ce => int_lvmb_csb(4),
		rst => por,
		device => "0101");

PMAP_LVMB_ADC6 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(5),
		ce => int_lvmb_csb(5),
		rst => por,
		device => "0110");

PMAP_LVMB_ADC7 : LVMB_ADC
   port map (
		scl => int_lvmb_sclk,
		sdi => int_lvmb_sdin,
		sdo => int_lvmb_adc_sdout(6),
		ce => int_lvmb_csb(6),
		rst => por,
		device => "0111");

PMAP_LVMB_ADC_SDO_MUX : LVMB_ADC_SDO_MUX
	port map (

		adc_sdo => int_lvmb_adc_sdout,
		adc_ce => int_lvmb_csb,
		sdo => int_lvmb_sdout);


END bdf_type;