-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:35:21 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY cnt_3 IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_a_out :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_b_out :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_c_out :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END cnt_3;

ARCHITECTURE bdf_type OF cnt_3 IS 

COMPONENT inc_n
GENERIC (n : INTEGER
			);
	PORT(enable : IN STD_LOGIC;
		 data_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	cnt_a_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_a_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_b_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_b_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_c_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_c_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_CNT_A_CL : inc_n
GENERIC MAP(n => 3
			)
PORT MAP(enable => enable(0),
		 data_in => cnt_a_cs,
		 data_out => cnt_a_ns);


b2v_CNT_B_CL : inc_n
GENERIC MAP(n => 3
			)
PORT MAP(enable => enable(1),
		 data_in => cnt_b_cs,
		 data_out => cnt_b_ns);


b2v_CNT_C_CL : inc_n
GENERIC MAP(n => 3
			)
PORT MAP(enable => enable(2),
		 data_in => cnt_c_cs,
		 data_out => cnt_c_ns);


b2v_CNT_R : reg_n_secdecset
GENERIC MAP(n => 3
			)
PORT MAP(clk => clk,
		 data_a_in => cnt_a_ns,
		 data_b_in => cnt_b_ns,
		 data_c_in => cnt_c_ns,
		 enable => enable,
		 reset => reset,
		 data_a_out => cnt_a_cs,
		 data_b_out => cnt_b_cs,
		 data_c_out => cnt_c_cs);

cnt_a_out <= cnt_a_cs;
cnt_b_out <= cnt_b_cs;
cnt_c_out <= cnt_c_cs;

END bdf_type;