-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 15:02:13 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY delay_manager IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		cnt_a_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		cnt_b_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		cnt_c_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		delay_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		delay_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		delay_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		edge :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_res :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sample :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END delay_manager;

ARCHITECTURE bdf_type OF delay_manager IS 

COMPONENT delay_manager_logic
	PORT(edge : IN STD_LOGIC;
		 current_state : IN STD_LOGIC;
		 cnt_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 delay : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 next_state : OUT STD_LOGIC;
		 cnt_en : OUT STD_LOGIC;
		 cnt_res : OUT STD_LOGIC;
		 sample : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT reg_1r_secdecset
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC;
		 data_b_in : IN STD_LOGIC;
		 data_c_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC;
		 data_b_out : OUT STD_LOGIC;
		 data_c_out : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	cnt_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_res_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	current_state_a :  STD_LOGIC;
SIGNAL	current_state_b :  STD_LOGIC;
SIGNAL	current_state_c :  STD_LOGIC;
SIGNAL	next_state_a :  STD_LOGIC;
SIGNAL	next_state_b :  STD_LOGIC;
SIGNAL	next_state_c :  STD_LOGIC;
SIGNAL	sample_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_DML_A : delay_manager_logic
PORT MAP(edge => edge(0),
		 current_state => current_state_a,
		 cnt_out => cnt_a_out,
		 delay => delay_a,
		 next_state => next_state_a,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(0),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(0),
		 sample => sample_ALTERA_SYNTHESIZED(0));


b2v_DML_B : delay_manager_logic
PORT MAP(edge => edge(1),
		 current_state => current_state_b,
		 cnt_out => cnt_b_out,
		 delay => delay_b,
		 next_state => next_state_b,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(1),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(1),
		 sample => sample_ALTERA_SYNTHESIZED(1));


b2v_DML_C : delay_manager_logic
PORT MAP(edge => edge(2),
		 current_state => current_state_c,
		 cnt_out => cnt_c_out,
		 delay => delay_c,
		 next_state => next_state_c,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(2),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(2),
		 sample => sample_ALTERA_SYNTHESIZED(2));


b2v_DMR : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => next_state_a,
		 data_b_in => next_state_b,
		 data_c_in => next_state_c,
		 enable => enable,
		 reset => reset,
		 data_a_out => current_state_a,
		 data_b_out => current_state_b,
		 data_c_out => current_state_c);

cnt_en <= cnt_en_ALTERA_SYNTHESIZED;
cnt_res <= cnt_res_ALTERA_SYNTHESIZED;
sample <= sample_ALTERA_SYNTHESIZED;

END bdf_type;