-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 14:48:46 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY edge_detector IS 
	PORT
	(
		data :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		edge :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END edge_detector;

ARCHITECTURE bdf_type OF edge_detector IS 

COMPONENT edge_detector_logic
	PORT(data : IN STD_LOGIC;
		 current_state : IN STD_LOGIC;
		 next_state : OUT STD_LOGIC;
		 edge : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT reg_1sr_secdecset
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC;
		 data_b_in : IN STD_LOGIC;
		 data_c_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 set : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC;
		 data_b_out : OUT STD_LOGIC;
		 data_c_out : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	current_state_a :  STD_LOGIC;
SIGNAL	current_state_b :  STD_LOGIC;
SIGNAL	current_state_c :  STD_LOGIC;
SIGNAL	edge_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_state_a :  STD_LOGIC;
SIGNAL	next_state_b :  STD_LOGIC;
SIGNAL	next_state_c :  STD_LOGIC;
SIGNAL	reg_reset :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	reg_set :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC;


BEGIN 



b2v_EDL_A : edge_detector_logic
PORT MAP(data => data,
		 current_state => current_state_a,
		 next_state => next_state_a,
		 edge => edge_ALTERA_SYNTHESIZED(0));


b2v_EDL_B : edge_detector_logic
PORT MAP(data => data,
		 current_state => current_state_b,
		 next_state => next_state_b,
		 edge => edge_ALTERA_SYNTHESIZED(1));


b2v_EDL_C : edge_detector_logic
PORT MAP(data => data,
		 current_state => current_state_c,
		 next_state => next_state_c,
		 edge => edge_ALTERA_SYNTHESIZED(2));


b2v_EDR : reg_1sr_secdecset
PORT MAP(clk => clk,
		 data_a_in => next_state_a,
		 data_b_in => next_state_b,
		 data_c_in => next_state_c,
		 enable => enable,
		 reset => reg_reset,
		 set => reg_set,
		 data_a_out => current_state_a,
		 data_b_out => current_state_b,
		 data_c_out => current_state_c);


reg_reset(2) <= reset(2) AND SYNTHESIZED_WIRE_0;


SYNTHESIZED_WIRE_1 <= NOT(data);



SYNTHESIZED_WIRE_2 <= NOT(data);



SYNTHESIZED_WIRE_0 <= NOT(data);



reg_set(0) <= reset(0) AND data;


reg_set(1) <= reset(1) AND data;


reg_set(2) <= reset(2) AND data;


reg_reset(0) <= reset(0) AND SYNTHESIZED_WIRE_1;


reg_reset(1) <= reset(1) AND SYNTHESIZED_WIRE_2;

edge <= edge_ALTERA_SYNTHESIZED;

END bdf_type;