-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:25:40 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY error_cnt_SECDECSET IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		error_a :  IN  STD_LOGIC;
		error_b :  IN  STD_LOGIC;
		error_c :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ec_cnt_out_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_cnt_out_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ec_cnt_out_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ef :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END error_cnt_SECDECSET;

ARCHITECTURE bdf_type OF error_cnt_SECDECSET IS 

COMPONENT inc_n
GENERIC (n : INTEGER
			);
	PORT(enable : IN STD_LOGIC;
		 data_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT ec_fsm_logic
	PORT(clk : IN STD_LOGIC;
		 error : IN STD_LOGIC;
		 enable : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 current_state : IN STD_LOGIC;
		 next_state : OUT STD_LOGIC;
		 ec_en : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ec_cnt_a_cs :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_cnt_a_en :  STD_LOGIC;
SIGNAL	ec_cnt_a_ns :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_cnt_b_cs :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_cnt_b_en :  STD_LOGIC;
SIGNAL	ec_cnt_b_ns :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_cnt_c_cs :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_cnt_c_en :  STD_LOGIC;
SIGNAL	ec_cnt_c_ns :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ec_fsm_a_cs :  STD_LOGIC;
SIGNAL	ec_fsm_a_ns :  STD_LOGIC;
SIGNAL	ec_fsm_b_cs :  STD_LOGIC;
SIGNAL	ec_fsm_b_ns :  STD_LOGIC;
SIGNAL	ec_fsm_c_cs :  STD_LOGIC;
SIGNAL	ec_fsm_c_ns :  STD_LOGIC;
SIGNAL	ef_a_cs :  STD_LOGIC;
SIGNAL	ef_a_ns :  STD_LOGIC;
SIGNAL	ef_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ef_b_cs :  STD_LOGIC;
SIGNAL	ef_b_ns :  STD_LOGIC;
SIGNAL	ef_c_cs :  STD_LOGIC;
SIGNAL	ef_c_ns :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC;


BEGIN 
SYNTHESIZED_WIRE_3 <= '1';



b2v_EC_CNT_CL_A : inc_n
GENERIC MAP(n => 8
			)
PORT MAP(enable => ec_cnt_a_en,
		 data_in => ec_cnt_a_cs,
		 data_out => ec_cnt_a_ns);


b2v_EC_CNT_CL_B : inc_n
GENERIC MAP(n => 8
			)
PORT MAP(enable => ec_cnt_b_en,
		 data_in => ec_cnt_b_cs,
		 data_out => ec_cnt_b_ns);


b2v_EC_CNT_CL_C : inc_n
GENERIC MAP(n => 8
			)
PORT MAP(enable => ec_cnt_c_en,
		 data_in => ec_cnt_c_cs,
		 data_out => ec_cnt_c_ns);


b2v_EC_CNT_R : reg_n_secdecset
GENERIC MAP(n => 8
			)
PORT MAP(clk => clk,
		 data_a_in => ec_cnt_a_ns,
		 data_b_in => ec_cnt_b_ns,
		 data_c_in => ec_cnt_c_ns,
		 enable => enable,
		 reset => reset,
		 data_a_out => ec_cnt_a_cs,
		 data_b_out => ec_cnt_b_cs,
		 data_c_out => ec_cnt_c_cs);


b2v_EC_FSM_CL_A : ec_fsm_logic
PORT MAP(clk => clk,
		 error => error_a,
		 enable => enable(0),
		 reset => reset(0),
		 current_state => ec_fsm_a_cs,
		 next_state => ec_fsm_a_ns,
		 ec_en => ec_cnt_a_en);


b2v_EC_FSM_CL_B : ec_fsm_logic
PORT MAP(clk => clk,
		 error => error_b,
		 enable => enable(1),
		 reset => reset(1),
		 current_state => ec_fsm_b_cs,
		 next_state => ec_fsm_b_ns,
		 ec_en => ec_cnt_b_en);


b2v_EC_FSM_CL_C : ec_fsm_logic
PORT MAP(clk => clk,
		 error => error_c,
		 enable => enable(2),
		 reset => reset(2),
		 current_state => ec_fsm_c_cs,
		 next_state => ec_fsm_c_ns,
		 ec_en => ec_cnt_c_en);


b2v_EC_FSM_R : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => ec_fsm_a_ns,
		 data_b_in(0) => ec_fsm_b_ns,
		 data_c_in(0) => ec_fsm_c_ns,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => ec_fsm_a_cs,
		 data_b_out(0) => ec_fsm_b_cs,
		 data_c_out(0) => ec_fsm_c_cs);


b2v_EF_FSM_CL_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => error_a,
		 data0(0) => ef_a_cs,
		 data1(0) => SYNTHESIZED_WIRE_3,
		 result(0) => ef_a_ns);


b2v_EF_FSM_CL_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => error_b,
		 data0(0) => ef_b_cs,
		 data1(0) => SYNTHESIZED_WIRE_3,
		 result(0) => ef_b_ns);


b2v_EF_FSM_CL_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => error_c,
		 data0(0) => ef_c_cs,
		 data1(0) => SYNTHESIZED_WIRE_3,
		 result(0) => ef_c_ns);


b2v_EF_FSM_R : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => ef_a_ns,
		 data_b_in(0) => ef_b_ns,
		 data_c_in(0) => ef_c_ns,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => ef_a_cs,
		 data_b_out(0) => ef_b_cs,
		 data_c_out(0) => ef_c_cs);

ec_cnt_out_a <= ec_cnt_a_cs;



ec_cnt_out_b <= ec_cnt_b_cs;


ec_cnt_out_c <= ec_cnt_c_cs;


ef_ALTERA_SYNTHESIZED(1) <= ef_b_cs;


ef_ALTERA_SYNTHESIZED(0) <= ef_a_cs;


ef_ALTERA_SYNTHESIZED(2) <= ef_c_cs;


ef <= ef_ALTERA_SYNTHESIZED;

END bdf_type;