-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:34:27 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_i2c_slave_core IS 
	PORT
	(
		ch_addr :  IN  STD_LOGIC;
		sdain :  IN  STD_LOGIC;
		scl :  IN  STD_LOGIC;
		dout_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		dout_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		dout_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sdaout :  OUT  STD_LOGIC;
		sdaouten :  OUT  STD_LOGIC;
		addr_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		addr_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		addr_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		din_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		din_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		din_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		wr_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END ff_emu_i2c_slave_core;

ARCHITECTURE bdf_type OF ff_emu_i2c_slave_core IS 

COMPONENT shr_l
	PORT(clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 pin_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 pin_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 pin_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sin : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 pout_a : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 pout_b : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 pout_c : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 sout : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT cnt_3
	PORT(clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_a_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_b_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_c_out : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT ff_emu_i2c_slave_fsm
	PORT(sdain : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 ch_addr : IN STD_LOGIC;
		 dr_a_out : IN STD_LOGIC;
		 dr_b_out : IN STD_LOGIC;
		 dr_c_out : IN STD_LOGIC;
		 ar_a_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ar_b_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 ar_c_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt_a_out : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_b_out : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_c_out : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sdaout : OUT STD_LOGIC;
		 sdaouten : OUT STD_LOGIC;
		 ar_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_res : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dr_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rd_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 wr_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	addr_a_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	addr_b_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	addr_c_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ar_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_a_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_b_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_c_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	dout :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	dr_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rd_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	scl_b :  STD_LOGIC;
SIGNAL	sin :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(0 TO 2);
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC_VECTOR(0 TO 7);


BEGIN 
SYNTHESIZED_WIRE_0 <= "000";
SYNTHESIZED_WIRE_4 <= "00000000";



b2v_AR : shr_l
PORT MAP(clk => scl,
		 enable => ar_en,
		 load => SYNTHESIZED_WIRE_0,
		 pin_a => SYNTHESIZED_WIRE_4,
		 pin_b => SYNTHESIZED_WIRE_4,
		 pin_c => SYNTHESIZED_WIRE_4,
		 reset => reset,
		 sin => sin,
		 pout_a => addr_a_ALTERA_SYNTHESIZED,
		 pout_b => addr_b_ALTERA_SYNTHESIZED,
		 pout_c => addr_c_ALTERA_SYNTHESIZED);


b2v_CNT_3 : cnt_3
PORT MAP(clk => scl_b,
		 enable => cnt_en,
		 reset => cnt_res,
		 cnt_a_out => cnt_a_out,
		 cnt_b_out => cnt_b_out,
		 cnt_c_out => cnt_c_out);


b2v_DR_POUT : shr_l
PORT MAP(clk => scl,
		 enable => dr_en,
		 load => rd_en,
		 pin_a => dout_a,
		 pin_b => dout_b,
		 pin_c => dout_c,
		 reset => reset,
		 sin => sin,
		 pout_a => din_a,
		 pout_b => din_b,
		 pout_c => din_c);


b2v_DR_SOUT : shr_l
PORT MAP(clk => scl_b,
		 enable => dr_en,
		 load => rd_en,
		 pin_a => dout_a,
		 pin_b => dout_b,
		 pin_c => dout_c,
		 reset => reset,
		 sin => sin,
		 sout => dout);


b2v_I2C_SLAVE_FSM : ff_emu_i2c_slave_fsm
PORT MAP(sdain => sdain,
		 clk => scl_b,
		 ch_addr => ch_addr,
		 dr_a_out => dout(0),
		 dr_b_out => dout(1),
		 dr_c_out => dout(2),
		 ar_a_out => addr_a_ALTERA_SYNTHESIZED,
		 ar_b_out => addr_b_ALTERA_SYNTHESIZED,
		 ar_c_out => addr_c_ALTERA_SYNTHESIZED,
		 cnt_a_out => cnt_a_out,
		 cnt_b_out => cnt_b_out,
		 cnt_c_out => cnt_c_out,
		 enable => enable,
		 reset => reset,
		 sdaout => sdaout,
		 sdaouten => sdaouten,
		 ar_en => ar_en,
		 cnt_en => cnt_en,
		 cnt_res => cnt_res,
		 dr_en => dr_en,
		 rd_en => rd_en,
		 wr_en => wr_en);



sin(2) <= sdain;


sin(0) <= sdain;


sin(1) <= sdain;



scl_b <= NOT(scl);


addr_a <= addr_a_ALTERA_SYNTHESIZED;
addr_b <= addr_b_ALTERA_SYNTHESIZED;
addr_c <= addr_c_ALTERA_SYNTHESIZED;

END bdf_type;