-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:32:56 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu_i2c_slave_fsm IS 
	PORT
	(
		sdain :  IN  STD_LOGIC;
		ch_addr :  IN  STD_LOGIC;
		dr_a_out :  IN  STD_LOGIC;
		dr_b_out :  IN  STD_LOGIC;
		dr_c_out :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		ar_a_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ar_b_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ar_c_out :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		cnt_a_out :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_b_out :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_c_out :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sdaouten :  OUT  STD_LOGIC;
		sdaout :  OUT  STD_LOGIC;
		ar_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		cnt_res :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		dr_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		rd_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0);
		wr_en :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END ff_emu_i2c_slave_fsm;

ARCHITECTURE bdf_type OF ff_emu_i2c_slave_fsm IS 

COMPONENT ff_emu_i2c_slave_fsm_logic
	PORT(sdain : IN STD_LOGIC;
		 ch_addr : IN STD_LOGIC;
		 datain : IN STD_LOGIC;
		 addr : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 current_state : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sdaout : OUT STD_LOGIC;
		 sdaouten : OUT STD_LOGIC;
		 cnt_en : OUT STD_LOGIC;
		 cnt_res : OUT STD_LOGIC;
		 ar_en : OUT STD_LOGIC;
		 dr_en : OUT STD_LOGIC;
		 rd_en : OUT STD_LOGIC;
		 wr_en : OUT STD_LOGIC;
		 next_state : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ar_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	cnt_res_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	dr_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_a_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_a_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_b_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_b_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_c_cs :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	i2c_fsm_c_ns :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rd_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	sdaout_a :  STD_LOGIC;
SIGNAL	sdaout_b :  STD_LOGIC;
SIGNAL	sdaout_c :  STD_LOGIC;
SIGNAL	sdaouten_a :  STD_LOGIC;
SIGNAL	sdaouten_b :  STD_LOGIC;
SIGNAL	sdaouten_c :  STD_LOGIC;
SIGNAL	wr_en_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_I2C_FSM_CL_A : ff_emu_i2c_slave_fsm_logic
PORT MAP(sdain => sdain,
		 ch_addr => ch_addr,
		 datain => dr_a_out,
		 addr => ar_a_out,
		 cnt => cnt_a_out,
		 current_state => i2c_fsm_a_cs,
		 sdaout => sdaout_a,
		 sdaouten => sdaouten_a,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(0),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(0),
		 ar_en => ar_en_ALTERA_SYNTHESIZED(0),
		 dr_en => dr_en_ALTERA_SYNTHESIZED(0),
		 rd_en => rd_en_ALTERA_SYNTHESIZED(0),
		 wr_en => wr_en_ALTERA_SYNTHESIZED(0),
		 next_state => i2c_fsm_a_ns);


b2v_I2C_FSM_CL_B : ff_emu_i2c_slave_fsm_logic
PORT MAP(sdain => sdain,
		 ch_addr => ch_addr,
		 datain => dr_b_out,
		 addr => ar_b_out,
		 cnt => cnt_b_out,
		 current_state => i2c_fsm_b_cs,
		 sdaout => sdaout_b,
		 sdaouten => sdaouten_b,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(1),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(1),
		 ar_en => ar_en_ALTERA_SYNTHESIZED(1),
		 dr_en => dr_en_ALTERA_SYNTHESIZED(1),
		 rd_en => rd_en_ALTERA_SYNTHESIZED(1),
		 wr_en => wr_en_ALTERA_SYNTHESIZED(1),
		 next_state => i2c_fsm_b_ns);


b2v_I2C_FSM_CL_C : ff_emu_i2c_slave_fsm_logic
PORT MAP(sdain => sdain,
		 ch_addr => ch_addr,
		 datain => dr_c_out,
		 addr => ar_c_out,
		 cnt => cnt_c_out,
		 current_state => i2c_fsm_c_cs,
		 sdaout => sdaout_c,
		 sdaouten => sdaouten_c,
		 cnt_en => cnt_en_ALTERA_SYNTHESIZED(2),
		 cnt_res => cnt_res_ALTERA_SYNTHESIZED(2),
		 ar_en => ar_en_ALTERA_SYNTHESIZED(2),
		 dr_en => dr_en_ALTERA_SYNTHESIZED(2),
		 rd_en => rd_en_ALTERA_SYNTHESIZED(2),
		 wr_en => wr_en_ALTERA_SYNTHESIZED(2),
		 next_state => i2c_fsm_c_ns);


b2v_I2C_FSM_R : reg_n_secdecset
GENERIC MAP(n => 3
			)
PORT MAP(clk => clk,
		 data_a_in => i2c_fsm_a_ns,
		 data_b_in => i2c_fsm_b_ns,
		 data_c_in => i2c_fsm_c_ns,
		 enable => enable,
		 reset => reset,
		 data_a_out => i2c_fsm_a_cs,
		 data_b_out => i2c_fsm_b_cs,
		 data_c_out => i2c_fsm_c_cs);


b2v_SDAOUT_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => sdaout_a,
		 data_b_in(0) => sdaout_b,
		 data_c_in(0) => sdaout_c,
		 data_out(0) => sdaout);


b2v_SDAOUTEN_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => sdaouten_a,
		 data_b_in(0) => sdaouten_b,
		 data_c_in(0) => sdaouten_c,
		 data_out(0) => sdaouten);

ar_en <= ar_en_ALTERA_SYNTHESIZED;
cnt_en <= cnt_en_ALTERA_SYNTHESIZED;
cnt_res <= cnt_res_ALTERA_SYNTHESIZED;
dr_en <= dr_en_ALTERA_SYNTHESIZED;
rd_en <= rd_en_ALTERA_SYNTHESIZED;
wr_en <= wr_en_ALTERA_SYNTHESIZED;

END bdf_type;