-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.


-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Fri Sep 21 17:50:15 2007

LIBRARY ieee;
use IEEE.STD_LOGIC_UNSIGNED.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_1164.all;


--  Entity Declaration

ENTITY ff_emu_i2c_slave_fsm_logic IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		sdain : IN STD_LOGIC;
		addr : IN STD_LOGIC_VECTOR(7 downto 0);
		ch_addr : IN STD_LOGIC;
		cnt : IN STD_LOGIC_VECTOR(2 downto 0);
		datain : IN STD_LOGIC;
		sdaout : OUT STD_LOGIC;
		sdaouten : OUT STD_LOGIC;
		cnt_en : OUT STD_LOGIC;
		cnt_res : OUT STD_LOGIC;
		ar_en : OUT STD_LOGIC;
		dr_en : OUT STD_LOGIC;
		rd_en : OUT STD_LOGIC;
		wr_en : OUT STD_LOGIC;
		current_state : IN STD_LOGIC_VECTOR(2 downto 0);
		next_state : OUT STD_LOGIC_VECTOR(2 downto 0)

	);
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END ff_emu_i2c_slave_fsm_logic;


--  Architecture Body

ARCHITECTURE i2c_slave_fsm_logic_architecture OF ff_emu_i2c_slave_fsm_logic IS

constant IDLE : std_logic_vector(2 downto 0) := "000";
constant GET_ADDR : std_logic_vector(2 downto 0) := "001";
constant GET_OPCODE : std_logic_vector(2 downto 0) := "010";
constant ACK_ADDR : std_logic_vector(2 downto 0) := "011";
constant RX_DATA : std_logic_vector(2 downto 0) := "100";
constant TX_DATA : std_logic_vector(2 downto 0) := "101";
constant ACK_DATA : std_logic_vector(2 downto 0) := "110";
    
begin
	
fsm_logic: process(current_state, datain, addr, cnt, ch_addr)
    
begin		
					  
   	case current_state is

	    when IDLE =>	
			sdaout <= '1';
			sdaouten <= '0';
			cnt_en <= '1';
			cnt_res <= '1';
			ar_en <= '0';
			dr_en <= '0';
			rd_en <= '0';
			wr_en <= '0';
			next_state <= GET_ADDR;

	    when GET_ADDR =>	
			sdaout <= '1';
			sdaouten <= '0';
			cnt_en <= '1';
			cnt_res <= '0';
			ar_en <= '1';
			dr_en <= '0';
			rd_en <= '0';
			wr_en <= '0';
-- MODIFICA!
--			if cnt = "110" then 
			if cnt = "111" then 
			    next_state <= GET_OPCODE;
			else  
			    next_state <= GET_ADDR ;
			end if;

	    when GET_OPCODE =>	
			sdaout <= '1';
			sdaouten <= '0';
			cnt_en <= '1';
			cnt_res <= '0';
			ar_en <= '1';
			dr_en <= '0';
			rd_en <= '0';
			wr_en <= '0';
			next_state <= ACK_ADDR;

	    when ACK_ADDR =>
			cnt_res <= '1';
			cnt_en <= '0';
			ar_en <= '0';
			wr_en <= '0';
			if (addr(6) = ch_addr) then
				sdaout <= '0';
				sdaouten <= '1';
--				if addr(7) = '0' then 
				if addr(0) = '0' then 
			    	next_state <= RX_DATA; -- write 
					rd_en <= '0';
					dr_en <= '0';
				else
			    	next_state <= TX_DATA; -- read
					rd_en <= '1';
					dr_en <= '1';
				end if;
			else
				sdaout <= '1';
				sdaouten <= '0';    
				rd_en <= '0';
				dr_en <= '0';
				next_state <= IDLE;
			end if;

	    when TX_DATA =>	
			sdaout <= datain;
			sdaouten <= '1';
			cnt_res <= '0';
			cnt_en <= '1';
			ar_en <= '0';
			dr_en <= '1';
			rd_en <= '0';
			wr_en <= '0';
			if cnt= "111" then 
			    next_state <= ACK_DATA;
			else  
			    next_state <= TX_DATA ;
			end if;

	    when RX_DATA =>	
			sdaout <= '1';
			sdaouten <= '0';
			cnt_res <= '0';
			cnt_en <= '1';
			ar_en <= '0';
			dr_en <= '1';
			rd_en <= '0';
			wr_en <= '0';
			if cnt = "111" then 
			    next_state <= ACK_DATA;
			else  
			    next_state <= RX_DATA ;
			end if;

	    when ACK_DATA =>
			sdaout <= '0';
			sdaouten <= '1';
			cnt_res <= '1';
			cnt_en <= '0';
			ar_en <= '0';
			dr_en <= '0';
			rd_en <= '0';
--			if addr(7) = '0' then 
			if addr(0) = '0' then 
				wr_en <= '1';  -- write
			else
				wr_en <= '0';  -- read
			end if;
--  		  next_state <= IDLE;
			next_state <= GET_ADDR;

	    when others =>
			sdaout <= '1';
			sdaouten <= '0';
			cnt_en <= '1';
			cnt_res <= '1';
			ar_en <= '0';
			dr_en <= '0';
			rd_en <= '0';
			wr_en <= '0';
			next_state <= IDLE;

	end case;

end process;

END i2c_slave_fsm_logic_architecture;
