-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.


-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Fri Sep 21 17:50:15 2007

LIBRARY ieee;
use IEEE.STD_LOGIC_UNSIGNED.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_1164.all;


--  Entity Declaration

ENTITY flf_dec_logic IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		flf_data_valid : IN STD_LOGIC;
		current_state : IN STD_LOGIC_VECTOR(1 downto 0);
		next_state : OUT STD_LOGIC_VECTOR(1 downto 0);
		load_w1 : OUT STD_LOGIC;
		load_w2 : OUT STD_LOGIC;
		load_w3 : OUT STD_LOGIC;
		next_load_h : OUT STD_LOGIC;
		next_reset_h : OUT STD_LOGIC
	);

	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END flf_dec_logic;


--  Architecture Body

ARCHITECTURE flf_dec_logic_architecture OF flf_dec_logic IS

constant IDLE : std_logic_vector(1 downto 0) := "00";
constant CYCLE1 : std_logic_vector(1 downto 0) := "01";
constant CYCLE2 : std_logic_vector(1 downto 0) := "10";

begin

fsm_logic: process(current_state, flf_data_valid)
    
begin		
					  
   	case current_state is

	    when IDLE =>

			if (flf_data_valid = '1') then
				load_w1 <= '1';
				load_w2 <= '0';
				load_w3 <= '0';
				next_load_h <= '0';
				next_reset_h <= '1';
				next_state <= CYCLE1;
			else
				load_w1 <= '0';
				load_w2 <= '0';
				load_w3 <= '0';
				next_load_h <= '0';
				next_reset_h <= '1';
				next_state <= IDLE;
			end if;		
		
	    when CYCLE1 =>

			load_w1 <= '0';
			load_w2 <= '1';
			load_w3 <= '0';
			next_load_h <= '0';
			next_reset_h <= '1';
			next_state <= CYCLE2;
				
	    when CYCLE2 =>

			load_w1 <= '0';
			load_w2 <= '0';
			load_w3 <= '1';
			next_load_h <= '1';
			next_reset_h <= '0';
			next_state <= IDLE;
		
	    when others =>

			load_w1 <= '0';
			load_w2 <= '0';
			load_w3 <= '0';
			next_load_h <= '0';
			next_reset_h <= '1';
			next_state <= IDLE;
		
		end case;

end process;


END flf_dec_logic_architecture;
