-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Wed Feb 02 02:26:40 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY flf_dec_rh IS 
	PORT
	(
		flf_data_valid :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		flf_data :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		e1_out :  OUT  STD_LOGIC;
		p1_out :  OUT  STD_LOGIC;
		p2_out :  OUT  STD_LOGIC;
		e2_out :  OUT  STD_LOGIC
	);
END flf_dec_rh;

ARCHITECTURE bdf_type OF flf_dec_rh IS 

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT and_3x2
	PORT(dina : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dinb : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dout : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT sh_dec
	PORT(sh1_dv_p_in_a : IN STD_LOGIC;
		 sh1_dv_p_in_b : IN STD_LOGIC;
		 sh1_dv_p_in_c : IN STD_LOGIC;
		 sh2_dv_p_in_a : IN STD_LOGIC;
		 sh2_dv_p_in_b : IN STD_LOGIC;
		 sh2_dv_p_in_c : IN STD_LOGIC;
		 sh3_dv_p_in_a : IN STD_LOGIC;
		 sh3_dv_p_in_b : IN STD_LOGIC;
		 sh3_dv_p_in_c : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh1_load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh2_load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh3_load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh_data_out_a : OUT STD_LOGIC;
		 sh_data_out_b : OUT STD_LOGIC;
		 sh_data_out_c : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT sh_dec_ctrl
	PORT(timing_a : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 timing_b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 timing_c : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 sh1_load : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh2_load : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh3_load : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_dec_logic
	PORT(flf_data_valid : IN STD_LOGIC;
		 current_state : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 load_w1 : OUT STD_LOGIC;
		 load_w2 : OUT STD_LOGIC;
		 load_w3 : OUT STD_LOGIC;
		 next_load_h : OUT STD_LOGIC;
		 next_reset_h : OUT STD_LOGIC;
		 next_state : OUT STD_LOGIC_VECTOR(1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_hamming_dec
	PORT(ham_dec_in : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 ham_dec_out : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	current_state_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	current_state_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	current_state_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e1_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_sh1_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_sh2_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_sh3_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_sh_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_timing_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e1_timing_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e1_timing_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e1_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_sh1_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_sh2_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_sh3_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_sh_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_timing_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e2_timing_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e2_timing_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e2_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	h1_reg_in_a :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h1_reg_in_b :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h1_reg_in_c :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h1_reg_out_a :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h1_reg_out_b :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h1_reg_out_c :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_in_a :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_in_b :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_in_c :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_out_a :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_out_b :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	h2_reg_out_c :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1a_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_1a_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1b_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_1b_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1c_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_1c_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2a_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2a_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2b_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2b_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2c_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2c_out :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	load_h :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	load_w1 :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	load_w2 :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	load_w3 :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_load_h :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_reset_h :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_state_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	next_state_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	next_state_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_sh1_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_sh2_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_sh3_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_sh_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_timing_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_timing_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_timing_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_sh1_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_sh2_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_sh3_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_sh_out :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_timing_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_timing_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_timing_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	reset_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	reset_h :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	reset_h_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	w1_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	w1_reg_out_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w1_reg_out_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w1_reg_out_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w2_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	w2_reg_out_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w2_reg_out_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w2_reg_out_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w3_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	w3_reg_out_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w3_reg_out_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	w3_reg_out_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_48 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_9 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_10 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_11 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_49 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_21 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_22 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_23 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_50 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_33 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_34 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_35 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_51 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_45 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_46 :  STD_LOGIC_VECTOR(0 TO 0);
SIGNAL	SYNTHESIZED_WIRE_47 :  STD_LOGIC_VECTOR(0 TO 0);


BEGIN 
SYNTHESIZED_WIRE_48 <= '1';
SYNTHESIZED_WIRE_49 <= '1';
SYNTHESIZED_WIRE_50 <= '1';
SYNTHESIZED_WIRE_51 <= '1';



b2v_E1_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => e1_sh_out(0),
		 data_b_in(0) => e1_sh_out(1),
		 data_c_in(0) => e1_sh_out(2),
		 enable => e1_reg_en,
		 reset => reset_en,
		 data_a_out(0) => SYNTHESIZED_WIRE_9(0),
		 data_b_out(0) => SYNTHESIZED_WIRE_10(0),
		 data_c_out(0) => SYNTHESIZED_WIRE_11(0));


b2v_E1_REGEN : and_3x2
PORT MAP(dina => e1_edge,
		 dinb => enable,
		 dout => e1_reg_en);


b2v_E1_SH1 : sh_dec
PORT MAP(sh1_dv_p_in_a => SYNTHESIZED_WIRE_48,
		 sh1_dv_p_in_b => SYNTHESIZED_WIRE_48,
		 sh1_dv_p_in_c => SYNTHESIZED_WIRE_48,
		 sh2_dv_p_in_a => SYNTHESIZED_WIRE_48,
		 sh2_dv_p_in_b => SYNTHESIZED_WIRE_48,
		 sh2_dv_p_in_c => SYNTHESIZED_WIRE_48,
		 sh3_dv_p_in_a => SYNTHESIZED_WIRE_48,
		 sh3_dv_p_in_b => SYNTHESIZED_WIRE_48,
		 sh3_dv_p_in_c => SYNTHESIZED_WIRE_48,
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => e1_sh1_load,
		 sh2_load => e1_sh2_load,
		 sh3_load => e1_sh3_load,
		 sh_data_out_a => e1_edge(0),
		 sh_data_out_b => e1_edge(1),
		 sh_data_out_c => e1_edge(2));


b2v_E1_SH2 : sh_dec
PORT MAP(sh1_dv_p_in_a => e1_value(0),
		 sh1_dv_p_in_b => e1_value(1),
		 sh1_dv_p_in_c => e1_value(2),
		 sh2_dv_p_in_a => e1_value(0),
		 sh2_dv_p_in_b => e1_value(1),
		 sh2_dv_p_in_c => e1_value(2),
		 sh3_dv_p_in_a => e1_value(0),
		 sh3_dv_p_in_b => e1_value(1),
		 sh3_dv_p_in_c => e1_value(2),
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => e1_sh1_load,
		 sh2_load => e1_sh2_load,
		 sh3_load => e1_sh3_load,
		 sh_data_out_a => e1_sh_out(0),
		 sh_data_out_b => e1_sh_out(1),
		 sh_data_out_c => e1_sh_out(2));


b2v_E1_SHC : sh_dec_ctrl
PORT MAP(timing_a => e1_timing_a,
		 timing_b => e1_timing_b,
		 timing_c => e1_timing_c,
		 sh1_load => e1_sh1_load,
		 sh2_load => e1_sh2_load,
		 sh3_load => e1_sh3_load);


b2v_E1_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => SYNTHESIZED_WIRE_9(0),
		 data_b_in(0) => SYNTHESIZED_WIRE_10(0),
		 data_c_in(0) => SYNTHESIZED_WIRE_11(0),
		 data_out(0) => e1_out);


b2v_E2_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => e2_sh_out(0),
		 data_b_in(0) => e2_sh_out(1),
		 data_c_in(0) => e2_sh_out(2),
		 enable => e2_reg_en,
		 reset => reset_en,
		 data_a_out(0) => SYNTHESIZED_WIRE_21(0),
		 data_b_out(0) => SYNTHESIZED_WIRE_22(0),
		 data_c_out(0) => SYNTHESIZED_WIRE_23(0));


b2v_E2_REGEN : and_3x2
PORT MAP(dina => e2_edge,
		 dinb => enable,
		 dout => e2_reg_en);


b2v_E2_SH1 : sh_dec
PORT MAP(sh1_dv_p_in_a => SYNTHESIZED_WIRE_49,
		 sh1_dv_p_in_b => SYNTHESIZED_WIRE_49,
		 sh1_dv_p_in_c => SYNTHESIZED_WIRE_49,
		 sh2_dv_p_in_a => SYNTHESIZED_WIRE_49,
		 sh2_dv_p_in_b => SYNTHESIZED_WIRE_49,
		 sh2_dv_p_in_c => SYNTHESIZED_WIRE_49,
		 sh3_dv_p_in_a => SYNTHESIZED_WIRE_49,
		 sh3_dv_p_in_b => SYNTHESIZED_WIRE_49,
		 sh3_dv_p_in_c => SYNTHESIZED_WIRE_49,
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => e2_sh1_load,
		 sh2_load => e2_sh2_load,
		 sh3_load => e2_sh3_load,
		 sh_data_out_a => e2_edge(0),
		 sh_data_out_b => e2_edge(1),
		 sh_data_out_c => e2_edge(2));


b2v_E2_SH2 : sh_dec
PORT MAP(sh1_dv_p_in_a => e2_value(0),
		 sh1_dv_p_in_b => e2_value(1),
		 sh1_dv_p_in_c => e2_value(2),
		 sh2_dv_p_in_a => e2_value(0),
		 sh2_dv_p_in_b => e2_value(1),
		 sh2_dv_p_in_c => e2_value(2),
		 sh3_dv_p_in_a => e2_value(0),
		 sh3_dv_p_in_b => e2_value(1),
		 sh3_dv_p_in_c => e2_value(2),
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => e2_sh1_load,
		 sh2_load => e2_sh2_load,
		 sh3_load => e2_sh3_load,
		 sh_data_out_a => e2_sh_out(0),
		 sh_data_out_b => e2_sh_out(1),
		 sh_data_out_c => e2_sh_out(2));


b2v_E2_SHC : sh_dec_ctrl
PORT MAP(timing_a => e2_timing_a,
		 timing_b => e2_timing_b,
		 timing_c => e2_timing_c,
		 sh1_load => e2_sh1_load,
		 sh2_load => e2_sh2_load,
		 sh3_load => e2_sh3_load);


b2v_E2_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => SYNTHESIZED_WIRE_21(0),
		 data_b_in(0) => SYNTHESIZED_WIRE_22(0),
		 data_c_in(0) => SYNTHESIZED_WIRE_23(0),
		 data_out(0) => e2_out);


b2v_FSM_A : flf_dec_logic
PORT MAP(flf_data_valid => flf_data_valid,
		 current_state => current_state_a,
		 load_w1 => load_w1(0),
		 load_w2 => load_w2(0),
		 load_w3 => load_w3(0),
		 next_load_h => next_load_h(0),
		 next_reset_h => next_reset_h(0),
		 next_state => next_state_a);


b2v_FSM_B : flf_dec_logic
PORT MAP(flf_data_valid => flf_data_valid,
		 current_state => current_state_b,
		 load_w1 => load_w1(1),
		 load_w2 => load_w2(1),
		 load_w3 => load_w3(1),
		 next_load_h => next_load_h(1),
		 next_reset_h => next_reset_h(1),
		 next_state => next_state_b);


b2v_FSM_C : flf_dec_logic
PORT MAP(flf_data_valid => flf_data_valid,
		 current_state => current_state_c,
		 load_w1 => load_w1(2),
		 load_w2 => load_w2(2),
		 load_w3 => load_w3(2),
		 next_load_h => next_load_h(2),
		 next_reset_h => next_reset_h(2),
		 next_state => next_state_c);


b2v_H1_REG : reg_n_secdecset
GENERIC MAP(n => 5
			)
PORT MAP(clk => clk,
		 data_a_in => h1_reg_in_a,
		 data_b_in => h1_reg_in_b,
		 data_c_in => h1_reg_in_c,
		 enable => enable,
		 reset => reset_h_en,
		 data_a_out => h1_reg_out_a,
		 data_b_out => h1_reg_out_b,
		 data_c_out => h1_reg_out_c);


b2v_H2_REG : reg_n_secdecset
GENERIC MAP(n => 5
			)
PORT MAP(clk => clk,
		 data_a_in => h2_reg_in_a,
		 data_b_in => h2_reg_in_b,
		 data_c_in => h2_reg_in_c,
		 enable => enable,
		 reset => reset_h_en,
		 data_a_out => h2_reg_out_a,
		 data_b_out => h2_reg_out_b,
		 data_c_out => h2_reg_out_c);


b2v_H_DEC_1A : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_1a_in,
		 ham_dec_out => ham_enc_1a_out);


b2v_H_DEC_1B : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_1b_in,
		 ham_dec_out => ham_enc_1b_out);


b2v_H_DEC_1C : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_1c_in,
		 ham_dec_out => ham_enc_1c_out);


b2v_H_DEC_2A : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_2a_in,
		 ham_dec_out => ham_enc_2a_out);


b2v_H_DEC_2B : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_2b_in,
		 ham_dec_out => ham_enc_2b_out);


b2v_H_DEC_2C : flf_hamming_dec
PORT MAP(ham_dec_in => ham_enc_2c_in,
		 ham_dec_out => ham_enc_2c_out);





ham_enc_2a_in(8 DOWNTO 3) <= w1_reg_out_a;


ham_enc_2a_in(2 DOWNTO 0) <= w2_reg_out_a(5 DOWNTO 3);


ham_enc_1a_in(8 DOWNTO 6) <= w2_reg_out_a(2 DOWNTO 0);


ham_enc_1a_in(5 DOWNTO 0) <= w3_reg_out_a;


ham_enc_2b_in(8 DOWNTO 3) <= w1_reg_out_b;


ham_enc_2b_in(2 DOWNTO 0) <= w2_reg_out_b(5 DOWNTO 3);


ham_enc_1b_in(8 DOWNTO 6) <= w2_reg_out_b(2 DOWNTO 0);


ham_enc_1b_in(5 DOWNTO 0) <= w3_reg_out_b;


ham_enc_2c_in(8 DOWNTO 3) <= w1_reg_out_c;


ham_enc_2c_in(2 DOWNTO 0) <= w2_reg_out_c(5 DOWNTO 3);


ham_enc_1c_in(8 DOWNTO 6) <= w2_reg_out_c(2 DOWNTO 0);


ham_enc_1c_in(5 DOWNTO 0) <= w3_reg_out_c;


p1_timing_a <= h1_reg_out_a(1 DOWNTO 0);


e1_value(0) <= h1_reg_out_a(4);


e1_timing_a <= h1_reg_out_a(3 DOWNTO 2);


p2_timing_a <= h2_reg_out_a(1 DOWNTO 0);


e2_value(0) <= h2_reg_out_a(4);


e2_timing_a <= h2_reg_out_a(3 DOWNTO 2);


p1_timing_b <= h1_reg_out_b(1 DOWNTO 0);


e1_value(1) <= h1_reg_out_b(4);


e1_timing_b <= h1_reg_out_b(3 DOWNTO 2);


p2_timing_b <= h2_reg_out_b(1 DOWNTO 0);


e2_value(1) <= h2_reg_out_b(4);


e2_timing_b <= h2_reg_out_b(3 DOWNTO 2);


p1_timing_c <= h1_reg_out_c(1 DOWNTO 0);


e1_value(2) <= h1_reg_out_c(4);


e1_timing_c <= h1_reg_out_c(3 DOWNTO 2);


p2_timing_c <= h2_reg_out_c(1 DOWNTO 0);


e2_value(2) <= h2_reg_out_c(4);


e2_timing_c <= h2_reg_out_c(3 DOWNTO 2);



b2v_inst71 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(0),
		 data0 => h1_reg_out_a,
		 data1 => ham_enc_1a_out,
		 result => h1_reg_in_a);


b2v_inst72 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(1),
		 data0 => h1_reg_out_b,
		 data1 => ham_enc_1b_out,
		 result => h1_reg_in_b);


b2v_inst73 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(2),
		 data0 => h1_reg_out_c,
		 data1 => ham_enc_1c_out,
		 result => h1_reg_in_c);


b2v_inst74 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(0),
		 data0 => h2_reg_out_a,
		 data1 => ham_enc_2a_out,
		 result => h2_reg_in_a);


b2v_inst75 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(1),
		 data0 => h2_reg_out_b,
		 data1 => ham_enc_2b_out,
		 result => h2_reg_in_b);


b2v_inst76 : mux_2xn
GENERIC MAP(n => 5
			)
PORT MAP(sel => load_h(2),
		 data0 => h2_reg_out_c,
		 data1 => ham_enc_2c_out,
		 result => h2_reg_in_c);


b2v_LOAD_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => next_load_h(0),
		 data_b_in(0) => next_load_h(1),
		 data_c_in(0) => next_load_h(2),
		 enable => enable,
		 reset => reset_en,
		 data_a_out(0) => load_h(0),
		 data_b_out(0) => load_h(1),
		 data_c_out(0) => load_h(2));


b2v_P1_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => p1_sh_out(0),
		 data_b_in(0) => p1_sh_out(1),
		 data_c_in(0) => p1_sh_out(2),
		 enable => enable,
		 reset => reset_en,
		 data_a_out(0) => SYNTHESIZED_WIRE_33(0),
		 data_b_out(0) => SYNTHESIZED_WIRE_34(0),
		 data_c_out(0) => SYNTHESIZED_WIRE_35(0));


b2v_P1_SH : sh_dec
PORT MAP(sh1_dv_p_in_a => SYNTHESIZED_WIRE_50,
		 sh1_dv_p_in_b => SYNTHESIZED_WIRE_50,
		 sh1_dv_p_in_c => SYNTHESIZED_WIRE_50,
		 sh2_dv_p_in_a => SYNTHESIZED_WIRE_50,
		 sh2_dv_p_in_b => SYNTHESIZED_WIRE_50,
		 sh2_dv_p_in_c => SYNTHESIZED_WIRE_50,
		 sh3_dv_p_in_a => SYNTHESIZED_WIRE_50,
		 sh3_dv_p_in_b => SYNTHESIZED_WIRE_50,
		 sh3_dv_p_in_c => SYNTHESIZED_WIRE_50,
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => p1_sh1_load,
		 sh2_load => p1_sh2_load,
		 sh3_load => p1_sh3_load,
		 sh_data_out_a => p1_sh_out(0),
		 sh_data_out_b => p1_sh_out(1),
		 sh_data_out_c => p1_sh_out(2));


b2v_P1_SHC : sh_dec_ctrl
PORT MAP(timing_a => p1_timing_a,
		 timing_b => p1_timing_b,
		 timing_c => p1_timing_c,
		 sh1_load => p1_sh1_load,
		 sh2_load => p1_sh2_load,
		 sh3_load => p1_sh3_load);


b2v_P1_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => SYNTHESIZED_WIRE_33(0),
		 data_b_in(0) => SYNTHESIZED_WIRE_34(0),
		 data_c_in(0) => SYNTHESIZED_WIRE_35(0),
		 data_out(0) => p1_out);


b2v_P2_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => p2_sh_out(0),
		 data_b_in(0) => p2_sh_out(1),
		 data_c_in(0) => p2_sh_out(2),
		 enable => enable,
		 reset => reset_en,
		 data_a_out(0) => SYNTHESIZED_WIRE_45(0),
		 data_b_out(0) => SYNTHESIZED_WIRE_46(0),
		 data_c_out(0) => SYNTHESIZED_WIRE_47(0));


b2v_P2_SH : sh_dec
PORT MAP(sh1_dv_p_in_a => SYNTHESIZED_WIRE_51,
		 sh1_dv_p_in_b => SYNTHESIZED_WIRE_51,
		 sh1_dv_p_in_c => SYNTHESIZED_WIRE_51,
		 sh2_dv_p_in_a => SYNTHESIZED_WIRE_51,
		 sh2_dv_p_in_b => SYNTHESIZED_WIRE_51,
		 sh2_dv_p_in_c => SYNTHESIZED_WIRE_51,
		 sh3_dv_p_in_a => SYNTHESIZED_WIRE_51,
		 sh3_dv_p_in_b => SYNTHESIZED_WIRE_51,
		 sh3_dv_p_in_c => SYNTHESIZED_WIRE_51,
		 clk => clk,
		 enable => enable,
		 reset => reset_en,
		 sh1_load => p2_sh1_load,
		 sh2_load => p2_sh2_load,
		 sh3_load => p2_sh3_load,
		 sh_data_out_a => p2_sh_out(0),
		 sh_data_out_b => p2_sh_out(1),
		 sh_data_out_c => p2_sh_out(2));


b2v_P2_SHC : sh_dec_ctrl
PORT MAP(timing_a => p2_timing_a,
		 timing_b => p2_timing_b,
		 timing_c => p2_timing_c,
		 sh1_load => p2_sh1_load,
		 sh2_load => p2_sh2_load,
		 sh3_load => p2_sh3_load);


b2v_P2_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => SYNTHESIZED_WIRE_45(0),
		 data_b_in(0) => SYNTHESIZED_WIRE_46(0),
		 data_c_in(0) => SYNTHESIZED_WIRE_47(0),
		 data_out(0) => p2_out);


b2v_RESET_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => next_reset_h(0),
		 data_b_in(0) => next_reset_h(1),
		 data_c_in(0) => next_reset_h(2),
		 enable => enable,
		 reset => reset_en,
		 data_a_out(0) => reset_h(0),
		 data_b_out(0) => reset_h(1),
		 data_c_out(0) => reset_h(2));


b2v_STATE_REG : reg_n_secdecset
GENERIC MAP(n => 2
			)
PORT MAP(clk => clk,
		 data_a_in => next_state_a,
		 data_b_in => next_state_b,
		 data_c_in => next_state_c,
		 enable => enable,
		 reset => reset_en,
		 data_a_out => current_state_a,
		 data_b_out => current_state_b,
		 data_c_out => current_state_c);


b2v_W1REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => flf_data,
		 data_b_in => flf_data,
		 data_c_in => flf_data,
		 enable => w1_reg_en,
		 reset => reset_en,
		 data_a_out => w1_reg_out_a,
		 data_b_out => w1_reg_out_b,
		 data_c_out => w1_reg_out_c);


b2v_W1REG_EN : and_3x2
PORT MAP(dina => load_w1,
		 dinb => enable,
		 dout => w1_reg_en);


b2v_W1REG_EN1 : and_3x2
PORT MAP(dina => reset,
		 dinb => enable,
		 dout => reset_en);


b2v_W1REG_EN2 : and_3x2
PORT MAP(dina => reset_h,
		 dinb => enable,
		 dout => reset_h_en);


b2v_W2REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => flf_data,
		 data_b_in => flf_data,
		 data_c_in => flf_data,
		 enable => w2_reg_en,
		 reset => reset_en,
		 data_a_out => w2_reg_out_a,
		 data_b_out => w2_reg_out_b,
		 data_c_out => w2_reg_out_c);


b2v_W2REGEN : and_3x2
PORT MAP(dina => load_w2,
		 dinb => enable,
		 dout => w2_reg_en);


b2v_W3REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => flf_data,
		 data_b_in => flf_data,
		 data_c_in => flf_data,
		 enable => w3_reg_en,
		 reset => reset_en,
		 data_a_out => w3_reg_out_a,
		 data_b_out => w3_reg_out_b,
		 data_c_out => w3_reg_out_c);


b2v_W3REGEN : and_3x2
PORT MAP(dina => load_w3,
		 dinb => enable,
		 dout => w3_reg_en);


END bdf_type;