-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Wed Feb 02 02:28:40 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY flf_enc_rh IS 
	PORT
	(
		e1_in :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		p1_in :  IN  STD_LOGIC;
		p2_in :  IN  STD_LOGIC;
		e2_in :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		flf_data_valid :  OUT  STD_LOGIC;
		flf_data :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0)
	);
END flf_enc_rh;

ARCHITECTURE bdf_type OF flf_enc_rh IS 

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT edge_detector
	PORT(data : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 edge : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_1sr_secdecset
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC;
		 data_b_in : IN STD_LOGIC;
		 data_c_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 set : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC;
		 data_b_out : OUT STD_LOGIC;
		 data_c_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT and_3x2
	PORT(dina : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dinb : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dout : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_enc_logic
	PORT(p1_in : IN STD_LOGIC;
		 p2_in : IN STD_LOGIC;
		 e1_edge : IN STD_LOGIC;
		 e1_value : IN STD_LOGIC;
		 e2_edge : IN STD_LOGIC;
		 e2_value : IN STD_LOGIC;
		 p1_en : IN STD_LOGIC;
		 p2_en : IN STD_LOGIC;
		 e1_en : IN STD_LOGIC;
		 e2_en : IN STD_LOGIC;
		 current_state : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 p1_we : OUT STD_LOGIC;
		 p1_en_set : OUT STD_LOGIC;
		 p1_en_res : OUT STD_LOGIC;
		 p2_we : OUT STD_LOGIC;
		 p2_en_set : OUT STD_LOGIC;
		 p2_en_res : OUT STD_LOGIC;
		 e1_we : OUT STD_LOGIC;
		 e1_en_set : OUT STD_LOGIC;
		 e1_en_res : OUT STD_LOGIC;
		 e2_we : OUT STD_LOGIC;
		 e2_en_set : OUT STD_LOGIC;
		 e2_en_res : OUT STD_LOGIC;
		 next_load : OUT STD_LOGIC;
		 e1_data : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 e2_data : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 next_state : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
		 p1_data : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
		 p2_data : OUT STD_LOGIC_VECTOR(1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT flf_hamming_enc
	PORT(ham_enc_in : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		 ham_enc_out : OUT STD_LOGIC_VECTOR(8 DOWNTO 0)
	);
END COMPONENT;

COMPONENT sh_data
	PORT(clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh1_data_p_in_a : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh1_data_p_in_b : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh1_data_p_in_c : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh2_data_p_in_a : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh2_data_p_in_b : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh2_data_p_in_c : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh3_data_p_in_a : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh3_data_p_in_b : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh3_data_p_in_c : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh_data_out_a : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh_data_out_b : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 sh_data_out_c : OUT STD_LOGIC_VECTOR(5 DOWNTO 0)
	);
END COMPONENT;

COMPONENT sh_dv
	PORT(sh1_dv_p_in_a : IN STD_LOGIC;
		 sh1_dv_p_in_b : IN STD_LOGIC;
		 sh1_dv_p_in_c : IN STD_LOGIC;
		 sh2_dv_p_in_a : IN STD_LOGIC;
		 sh2_dv_p_in_b : IN STD_LOGIC;
		 sh2_dv_p_in_c : IN STD_LOGIC;
		 sh3_dv_p_in_a : IN STD_LOGIC;
		 sh3_dv_p_in_b : IN STD_LOGIC;
		 sh3_dv_p_in_c : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 load : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sh_data_out_a : OUT STD_LOGIC;
		 sh_data_out_b : OUT STD_LOGIC;
		 sh_data_out_c : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	current_state_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	current_state_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	current_state_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	e1_data_a :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_data_b :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_data_c :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_en_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_en_set :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_data_a :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_data_b :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_data_c :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_we :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_data_a :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_data_b :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_data_c :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_en_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_en_set :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_data_a :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_data_b :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_data_c :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_we :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ham_enc_1a_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1a_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_1b_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1b_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_1c_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_1c_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2a_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2a_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2b_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2b_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ham_enc_2c_in :  STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL	ham_enc_2c_out :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_load :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	next_state_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	next_state_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	next_state_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_data_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_data_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_data_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_en_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_en_set :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_reg_data_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_reg_data_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_reg_data_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p1_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p1_we :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_data_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_data_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_data_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_en_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_en_set :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_reg_data_a :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_reg_data_b :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_reg_data_c :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	p2_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	p2_we :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	sh1_data_p_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_p_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_p_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_p_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_p_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_p_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_p_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_p_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_p_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_15 :  STD_LOGIC;


BEGIN 
SYNTHESIZED_WIRE_15 <= '1';



b2v_DATA_VL : vl_n
GENERIC MAP(n => 6
			)
PORT MAP(data_a_in => SYNTHESIZED_WIRE_0,
		 data_b_in => SYNTHESIZED_WIRE_1,
		 data_c_in => SYNTHESIZED_WIRE_2,
		 data_out => flf_data);


b2v_DV_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => SYNTHESIZED_WIRE_3,
		 data_b_in(0) => SYNTHESIZED_WIRE_4,
		 data_c_in(0) => SYNTHESIZED_WIRE_5,
		 data_out(0) => flf_data_valid);


b2v_E1_ED : edge_detector
PORT MAP(data => e1_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e1_edge);


b2v_E1EN_REG : reg_1sr_secdecset
PORT MAP(clk => clk,
		 data_a_in => e1_en(0),
		 data_b_in => e1_en(1),
		 data_c_in => e1_en(2),
		 enable => enable,
		 reset => e1_en_res,
		 set => e1_en_set,
		 data_a_out => e1_en(0),
		 data_b_out => e1_en(1),
		 data_c_out => e1_en(2));


b2v_E1REG : reg_n_secdecset
GENERIC MAP(n => 3
			)
PORT MAP(clk => clk,
		 data_a_in => e1_data_a,
		 data_b_in => e1_data_b,
		 data_c_in => e1_data_c,
		 enable => e1_reg_en,
		 reset => reset,
		 data_a_out => e1_reg_data_a,
		 data_b_out => e1_reg_data_b,
		 data_c_out => e1_reg_data_c);


b2v_E1REG_EN : and_3x2
PORT MAP(dina => e1_we,
		 dinb => enable,
		 dout => e1_reg_en);


b2v_E2_ED : edge_detector
PORT MAP(data => e2_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e2_edge);


b2v_E2EN_REG : reg_1sr_secdecset
PORT MAP(clk => clk,
		 data_a_in => e2_en(0),
		 data_b_in => e2_en(1),
		 data_c_in => e2_en(2),
		 enable => enable,
		 reset => e2_en_res,
		 set => e2_en_set,
		 data_a_out => e2_en(0),
		 data_b_out => e2_en(1),
		 data_c_out => e2_en(2));


b2v_E2REG : reg_n_secdecset
GENERIC MAP(n => 3
			)
PORT MAP(clk => clk,
		 data_a_in => e2_data_a,
		 data_b_in => e2_data_b,
		 data_c_in => e2_data_c,
		 enable => e2_reg_en,
		 reset => reset,
		 data_a_out => e2_reg_data_a,
		 data_b_out => e2_reg_data_b,
		 data_c_out => e2_reg_data_c);


b2v_E2REG_EN : and_3x2
PORT MAP(dina => e2_we,
		 dinb => enable,
		 dout => e2_reg_en);


b2v_FSM_A : flf_enc_logic
PORT MAP(p1_in => p1_in,
		 p2_in => p2_in,
		 e1_edge => e1_edge(0),
		 e1_value => e1_in,
		 e2_edge => e2_edge(0),
		 e2_value => e2_in,
		 p1_en => p1_en(0),
		 p2_en => p2_en(0),
		 e1_en => e1_en(0),
		 e2_en => e2_en(0),
		 current_state => current_state_a,
		 p1_we => p1_we(0),
		 p1_en_set => p1_en_set(0),
		 p1_en_res => p1_en_res(0),
		 p2_we => p2_we(0),
		 p2_en_set => p2_en_set(0),
		 p2_en_res => p2_en_res(0),
		 e1_we => e1_we(0),
		 e1_en_set => e1_en_set(0),
		 e1_en_res => e1_en_res(0),
		 e2_we => e2_we(0),
		 e2_en_set => e2_en_set(0),
		 e2_en_res => e2_en_res(0),
		 next_load => next_load(0),
		 e1_data => e1_data_a,
		 e2_data => e2_data_a,
		 next_state => next_state_a,
		 p1_data => p1_data_a,
		 p2_data => p2_data_a);


b2v_H_ENC_1A : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_1a_in,
		 ham_enc_out => ham_enc_1a_out);


b2v_H_ENC_1B : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_1b_in,
		 ham_enc_out => ham_enc_1b_out);


b2v_H_ENC_1C : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_1c_in,
		 ham_enc_out => ham_enc_1c_out);


b2v_H_ENC_2A : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_2a_in,
		 ham_enc_out => ham_enc_2a_out);


b2v_H_ENC_2B : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_2b_in,
		 ham_enc_out => ham_enc_2b_out);


b2v_H_ENC_2C : flf_hamming_enc
PORT MAP(ham_enc_in => ham_enc_2c_in,
		 ham_enc_out => ham_enc_2c_out);


b2v_inst10 : flf_enc_logic
PORT MAP(p1_in => p1_in,
		 p2_in => p2_in,
		 e1_edge => e1_edge(2),
		 e1_value => e1_in,
		 e2_edge => e2_edge(2),
		 e2_value => e2_in,
		 p1_en => p1_en(2),
		 p2_en => p2_en(2),
		 e1_en => e1_en(2),
		 e2_en => e2_en(2),
		 current_state => current_state_c,
		 p1_we => p1_we(2),
		 p1_en_set => p1_en_set(2),
		 p1_en_res => p1_en_res(2),
		 p2_we => p2_we(2),
		 p2_en_set => p2_en_set(2),
		 p2_en_res => p2_en_res(2),
		 e1_we => e1_we(2),
		 e1_en_set => e1_en_set(2),
		 e1_en_res => e1_en_res(2),
		 e2_we => e2_we(2),
		 e2_en_set => e2_en_set(2),
		 e2_en_res => e2_en_res(2),
		 next_load => next_load(2),
		 e1_data => e1_data_c,
		 e2_data => e2_data_c,
		 next_state => next_state_c,
		 p1_data => p1_data_c,
		 p2_data => p2_data_c);

ham_enc_1a_in(1 DOWNTO 0) <= p1_reg_data_a;


ham_enc_1a_in(4 DOWNTO 2) <= e1_reg_data_a;


ham_enc_2a_in(1 DOWNTO 0) <= p2_reg_data_a;


ham_enc_2a_in(4 DOWNTO 2) <= e2_reg_data_a;


ham_enc_1b_in(1 DOWNTO 0) <= p1_reg_data_b;


ham_enc_1b_in(4 DOWNTO 2) <= e1_reg_data_b;


ham_enc_2b_in(1 DOWNTO 0) <= p2_reg_data_b;


ham_enc_2b_in(4 DOWNTO 2) <= e2_reg_data_b;


ham_enc_1c_in(1 DOWNTO 0) <= p1_reg_data_c;


ham_enc_1c_in(4 DOWNTO 2) <= e1_reg_data_c;


ham_enc_2c_in(1 DOWNTO 0) <= p2_reg_data_c;


ham_enc_2c_in(4 DOWNTO 2) <= e2_reg_data_c;


sh1_data_p_in_a <= ham_enc_1a_out(5 DOWNTO 0);


sh2_data_p_in_a(2 DOWNTO 0) <= ham_enc_1a_out(8 DOWNTO 6);


sh2_data_p_in_a(5 DOWNTO 3) <= ham_enc_2a_out(2 DOWNTO 0);


sh3_data_p_in_a <= ham_enc_2a_out(8 DOWNTO 3);


sh1_data_p_in_b <= ham_enc_1b_out(5 DOWNTO 0);


sh2_data_p_in_b(2 DOWNTO 0) <= ham_enc_1b_out(8 DOWNTO 6);


sh2_data_p_in_b(5 DOWNTO 3) <= ham_enc_2b_out(2 DOWNTO 0);


sh3_data_p_in_b <= ham_enc_2b_out(8 DOWNTO 3);


sh1_data_p_in_c <= ham_enc_1c_out(5 DOWNTO 0);


sh2_data_p_in_c(2 DOWNTO 0) <= ham_enc_1c_out(8 DOWNTO 6);


sh2_data_p_in_c(5 DOWNTO 3) <= ham_enc_2c_out(2 DOWNTO 0);


sh3_data_p_in_c <= ham_enc_2c_out(8 DOWNTO 3);



b2v_inst45 : sh_data
PORT MAP(clk => clk,
		 enable => enable,
		 load => load,
		 reset => reset,
		 sh1_data_p_in_a => sh1_data_p_in_a,
		 sh1_data_p_in_b => sh1_data_p_in_b,
		 sh1_data_p_in_c => sh1_data_p_in_c,
		 sh2_data_p_in_a => sh2_data_p_in_a,
		 sh2_data_p_in_b => sh2_data_p_in_b,
		 sh2_data_p_in_c => sh2_data_p_in_c,
		 sh3_data_p_in_a => sh3_data_p_in_a,
		 sh3_data_p_in_b => sh3_data_p_in_b,
		 sh3_data_p_in_c => sh3_data_p_in_c,
		 sh_data_out_a => SYNTHESIZED_WIRE_0,
		 sh_data_out_b => SYNTHESIZED_WIRE_1,
		 sh_data_out_c => SYNTHESIZED_WIRE_2);


b2v_inst46 : sh_dv
PORT MAP(sh1_dv_p_in_a => SYNTHESIZED_WIRE_15,
		 sh1_dv_p_in_b => SYNTHESIZED_WIRE_15,
		 sh1_dv_p_in_c => SYNTHESIZED_WIRE_15,
		 sh2_dv_p_in_a => SYNTHESIZED_WIRE_15,
		 sh2_dv_p_in_b => SYNTHESIZED_WIRE_15,
		 sh2_dv_p_in_c => SYNTHESIZED_WIRE_15,
		 sh3_dv_p_in_a => SYNTHESIZED_WIRE_15,
		 sh3_dv_p_in_b => SYNTHESIZED_WIRE_15,
		 sh3_dv_p_in_c => SYNTHESIZED_WIRE_15,
		 clk => clk,
		 enable => enable,
		 load => load,
		 reset => reset,
		 sh_data_out_a => SYNTHESIZED_WIRE_3,
		 sh_data_out_b => SYNTHESIZED_WIRE_4,
		 sh_data_out_c => SYNTHESIZED_WIRE_5);



b2v_inst9 : flf_enc_logic
PORT MAP(p1_in => p1_in,
		 p2_in => p2_in,
		 e1_edge => e1_edge(1),
		 e1_value => e1_in,
		 e2_edge => e2_edge(1),
		 e2_value => e2_in,
		 p1_en => p1_en(1),
		 p2_en => p2_en(1),
		 e1_en => e1_en(1),
		 e2_en => e2_en(1),
		 current_state => current_state_b,
		 p1_we => p1_we(1),
		 p1_en_set => p1_en_set(1),
		 p1_en_res => p1_en_res(1),
		 p2_we => p2_we(1),
		 p2_en_set => p2_en_set(1),
		 p2_en_res => p2_en_res(1),
		 e1_we => e1_we(1),
		 e1_en_set => e1_en_set(1),
		 e1_en_res => e1_en_res(1),
		 e2_we => e2_we(1),
		 e2_en_set => e2_en_set(1),
		 e2_en_res => e2_en_res(1),
		 next_load => next_load(1),
		 e1_data => e1_data_b,
		 e2_data => e2_data_b,
		 next_state => next_state_b,
		 p1_data => p1_data_b,
		 p2_data => p2_data_b);


b2v_LOAD_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => next_load(0),
		 data_b_in(0) => next_load(1),
		 data_c_in(0) => next_load(2),
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => load(0),
		 data_b_out(0) => load(1),
		 data_c_out(0) => load(2));


b2v_P1EN_REG : reg_1sr_secdecset
PORT MAP(clk => clk,
		 data_a_in => p1_en(0),
		 data_b_in => p1_en(1),
		 data_c_in => p1_en(2),
		 enable => enable,
		 reset => p1_en_res,
		 set => p1_en_set,
		 data_a_out => p1_en(0),
		 data_b_out => p1_en(1),
		 data_c_out => p1_en(2));


b2v_P1REG : reg_n_secdecset
GENERIC MAP(n => 2
			)
PORT MAP(clk => clk,
		 data_a_in => p1_data_a,
		 data_b_in => p1_data_b,
		 data_c_in => p1_data_c,
		 enable => p1_reg_en,
		 reset => reset,
		 data_a_out => p1_reg_data_a,
		 data_b_out => p1_reg_data_b,
		 data_c_out => p1_reg_data_c);


b2v_P1REG_EN : and_3x2
PORT MAP(dina => p1_we,
		 dinb => enable,
		 dout => p1_reg_en);


b2v_P2EN_REG : reg_1sr_secdecset
PORT MAP(clk => clk,
		 data_a_in => p2_en(0),
		 data_b_in => p2_en(1),
		 data_c_in => p2_en(2),
		 enable => enable,
		 reset => p2_en_res,
		 set => p2_en_set,
		 data_a_out => p2_en(0),
		 data_b_out => p2_en(1),
		 data_c_out => p2_en(2));


b2v_P2REG : reg_n_secdecset
GENERIC MAP(n => 2
			)
PORT MAP(clk => clk,
		 data_a_in => p2_data_a,
		 data_b_in => p2_data_b,
		 data_c_in => p2_data_c,
		 enable => p2_reg_en,
		 reset => reset,
		 data_a_out => p2_reg_data_a,
		 data_b_out => p2_reg_data_b,
		 data_c_out => p2_reg_data_c);


b2v_P2REG_EN : and_3x2
PORT MAP(dina => p2_we,
		 dinb => enable,
		 dout => p2_reg_en);


b2v_STATE_REG : reg_n_secdecset
GENERIC MAP(n => 2
			)
PORT MAP(clk => clk,
		 data_a_in => next_state_a,
		 data_b_in => next_state_b,
		 data_c_in => next_state_c,
		 enable => enable,
		 reset => reset,
		 data_a_out => current_state_a,
		 data_b_out => current_state_b,
		 data_c_out => current_state_c);


END bdf_type;