-- Hamming (16,11) encoder (SECDED)
--
--

LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

entity hamming_16_11_encoder is
  port(
    word_in  : in std_logic_vector(10 downto 0);
    word_enc : out std_logic_vector(15 downto 0)
  );
end hamming_16_11_encoder;


architecture arch1 of hamming_16_11_encoder is 

	signal x : std_logic_vector(1 to 11); -- message vector
	signal p : std_logic_vector(1 to 5); -- vector of parity bits
	
begin  
		
	x(1 to 11) <= word_in(10 downto 0);
	
	p(1) <= x(1) XOR x(2) XOR x(4) XOR x(5) XOR x(7) XOR x(9) XOR x(11);	
	p(2) <= x(1) XOR x(3) XOR x(4) XOR x(6) XOR x(7) XOR x(10) XOR x(11);
	p(3) <= x(2) XOR x(3) XOR x(4) XOR x(8) XOR x(9) XOR x(10) XOR x(11);
	p(4) <= x(5) XOR x(6) XOR x(7) XOR x(8) XOR x(9) XOR x(10) XOR x(11);
    -- additional overall parity bit
	p(5) <= x(1) XOR x(2) XOR x(3) XOR x(6) XOR x(8) XOR x(11);
	
	word_enc(15 downto 5) <=  x(1 to 11);
	word_enc(4 downto 0)  <=  p(1 to 5);

end arch1;
