-- Hamming (9,5) encoder (SEC)
--
--

LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

entity hamming_9_5_encoder is
  port(
    word_in  : in std_logic_vector(4 downto 0);
    word_enc : out std_logic_vector(8 downto 0)
  );
end hamming_9_5_encoder;


architecture arch1 of hamming_9_5_encoder is 

	signal x : std_logic_vector(1 to 5); -- message vector
	signal p : std_logic_vector(1 to 4); -- vector of parity bits
	
begin  
		
	x(1 to 5) <= word_in(4 downto 0);
	
	p(1) <= x(1) XOR x(2) XOR x(4) XOR x(5);	
	p(2) <= x(1) XOR x(3) XOR x(4);
	p(3) <= x(2) XOR x(3) XOR x(4);
	p(4) <= x(5) ;
    
	word_enc(8 downto 4) <=  x(1 to 5);
	word_enc(3 downto 0) <=  p(1 to 4);

end arch1;
