LIBRARY ieee;
use IEEE.STD_LOGIC_UNSIGNED.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_1164.all;

--  Entity Declaration

ENTITY mux_2xn IS
GENERIC (
  n: integer range 1 to 64 := 1 -- number of bits
);
PORT (

		sel : IN STD_LOGIC;
		data0 : IN STD_LOGIC_VECTOR(n-1 downto 0);
		data1 : IN STD_LOGIC_VECTOR(n-1 downto 0);
		result : OUT STD_LOGIC_VECTOR(n-1 downto 0)

	);
	
end mux_2xn;


--  Architecture Body

ARCHITECTURE mux_2xn_architecture OF mux_2xn IS

begin

mux: process (data0, data1, sel)

begin

	if (sel = '0') then
		result <= data0;
	else
		result <= data1;
	end if;

end process;
	      
END mux_2xn_architecture;
