-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Mon Oct 11 17:10:55 2010"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY reg_n_SECDECSET_init IS 
GENERIC (
  n: integer range 1 to 64 := 1 -- number of bits
);
	PORT
	(
		clk :  IN  STD_LOGIC;
		data_a_in :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_b_in :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_c_in :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_a_init :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_b_init :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_c_init :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_a_reset :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_b_reset :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_c_reset :  IN  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		init :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		data_a_out :  OUT  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_b_out :  OUT  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		data_c_out :  OUT  STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END reg_n_SECDECSET_init;

ARCHITECTURE bdf_type OF reg_n_SECDECSET_init IS 

COMPONENT reg_n_SECDECSET_ml
GENERIC (n : INTEGER
			);
	PORT(data_1_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_2_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_3_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_4_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_5_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_SECDECSET_regs_init
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_1_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_2_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_3_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_1_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_2_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_3_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_1_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_2_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_3_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 init : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_1_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_2_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_3_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_4_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_5_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	reg_1_data :  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
SIGNAL	reg_2_data :  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
SIGNAL	reg_3_data :  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
SIGNAL	reg_4_data :  STD_LOGIC_VECTOR(n-1 DOWNTO 0);
SIGNAL	reg_5_data :  STD_LOGIC_VECTOR(n-1 DOWNTO 0);


BEGIN 



b2v_ML_A : reg_n_SECDECSET_ml
GENERIC MAP(n => n
			)
PORT MAP(data_1_in => reg_1_data,
		 data_2_in => reg_2_data,
		 data_3_in => reg_3_data,
		 data_4_in => reg_4_data,
		 data_5_in => reg_5_data,
		 data_out => data_a_out);


b2v_ML_B : reg_n_SECDECSET_ml
GENERIC MAP(n => n
			)
PORT MAP(data_1_in => reg_1_data,
		 data_2_in => reg_2_data,
		 data_3_in => reg_3_data,
		 data_4_in => reg_4_data,
		 data_5_in => reg_5_data,
		 data_out => data_b_out);


b2v_ML_C : reg_n_SECDECSET_ml
GENERIC MAP(n => n
			)
PORT MAP(data_1_in => reg_1_data,
		 data_2_in => reg_2_data,
		 data_3_in => reg_3_data,
		 data_4_in => reg_4_data,
		 data_5_in => reg_5_data,
		 data_out => data_c_out);


b2v_REGS : reg_n_SECDECSET_regs_init
GENERIC MAP(n => n
			)
PORT MAP(clk => clk,
		 data_1_in => data_a_in,
		 data_2_in => data_b_in,
		 data_3_in => data_c_in,
		 data_1_init => data_a_init,
		 data_2_init => data_b_init,
		 data_3_init => data_c_init,
		 data_1_reset => data_a_reset,
		 data_2_reset => data_b_reset,
		 data_3_reset => data_c_reset,
		 enable => enable,
		 reset => reset,
		 init => init,
		 data_1_out => reg_1_data,
		 data_2_out => reg_2_data,
		 data_3_out => reg_3_data,
		 data_4_out => reg_4_data,
		 data_5_out => reg_5_data);

END bdf_type;