-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:04:49 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY rx_sl_sync_reg IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		rx_sl :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sync_rx_sl :  OUT  STD_LOGIC
	);
END rx_sl_sync_reg;

ARCHITECTURE bdf_type OF rx_sl_sync_reg IS 

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	s1_rx_sl_a :  STD_LOGIC;
SIGNAL	s1_rx_sl_b :  STD_LOGIC;
SIGNAL	s1_rx_sl_c :  STD_LOGIC;
SIGNAL	s2_rx_sl_a :  STD_LOGIC;
SIGNAL	s2_rx_sl_b :  STD_LOGIC;
SIGNAL	s2_rx_sl_c :  STD_LOGIC;


BEGIN 



b2v_REG1 : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => rx_sl,
		 data_b_in(0) => rx_sl,
		 data_c_in(0) => rx_sl,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => s1_rx_sl_a,
		 data_b_out(0) => s1_rx_sl_b,
		 data_c_out(0) => s1_rx_sl_c);


b2v_REG2 : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => s1_rx_sl_a,
		 data_b_in(0) => s1_rx_sl_b,
		 data_c_in(0) => s1_rx_sl_c,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => s2_rx_sl_a,
		 data_b_out(0) => s2_rx_sl_b,
		 data_c_out(0) => s2_rx_sl_c);


b2v_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => s2_rx_sl_a,
		 data_b_in(0) => s2_rx_sl_b,
		 data_c_in(0) => s2_rx_sl_c,
		 data_out(0) => sync_rx_sl);


END bdf_type;