-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 16:08:52 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY sh_data IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		load :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sh1_data_p_in_a :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh1_data_p_in_b :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh1_data_p_in_c :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh2_data_p_in_a :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh2_data_p_in_b :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh2_data_p_in_c :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh3_data_p_in_a :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh3_data_p_in_b :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh3_data_p_in_c :  IN  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh_data_out_a :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh_data_out_b :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0);
		sh_data_out_c :  OUT  STD_LOGIC_VECTOR(5 DOWNTO 0)
	);
END sh_data;

ARCHITECTURE bdf_type OF sh_data IS 

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	sh1_data_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_out_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_out_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh1_data_out_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_out_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_out_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh2_data_out_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_in_a :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_in_b :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	sh3_data_in_c :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(0 TO 5);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(0 TO 5);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(0 TO 5);


BEGIN 
SYNTHESIZED_WIRE_0 <= "000000";
SYNTHESIZED_WIRE_1 <= "000000";
SYNTHESIZED_WIRE_2 <= "000000";






b2v_SH1_MUX_A : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(0),
		 data0 => SYNTHESIZED_WIRE_0,
		 data1 => sh1_data_p_in_a,
		 result => sh1_data_in_a);


b2v_SH1_MUX_B : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(1),
		 data0 => SYNTHESIZED_WIRE_1,
		 data1 => sh1_data_p_in_b,
		 result => sh1_data_in_b);


b2v_SH1_MUX_C : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(2),
		 data0 => SYNTHESIZED_WIRE_2,
		 data1 => sh1_data_p_in_c,
		 result => sh1_data_in_c);


b2v_SH1_REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => sh1_data_in_a,
		 data_b_in => sh1_data_in_b,
		 data_c_in => sh1_data_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out => sh1_data_out_a,
		 data_b_out => sh1_data_out_b,
		 data_c_out => sh1_data_out_c);


b2v_SH2_MUX_A : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(0),
		 data0 => sh1_data_out_a,
		 data1 => sh2_data_p_in_a,
		 result => sh2_data_in_a);


b2v_SH2_MUX_B : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(1),
		 data0 => sh1_data_out_b,
		 data1 => sh2_data_p_in_b,
		 result => sh2_data_in_b);


b2v_SH2_MUX_C : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(2),
		 data0 => sh1_data_out_c,
		 data1 => sh2_data_p_in_c,
		 result => sh2_data_in_c);


b2v_SH2_REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => sh2_data_in_a,
		 data_b_in => sh2_data_in_b,
		 data_c_in => sh2_data_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out => sh2_data_out_a,
		 data_b_out => sh2_data_out_b,
		 data_c_out => sh2_data_out_c);


b2v_SH3_MUX_A : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(0),
		 data0 => sh2_data_out_a,
		 data1 => sh3_data_p_in_a,
		 result => sh3_data_in_a);


b2v_SH3_MUX_B : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(1),
		 data0 => sh2_data_out_b,
		 data1 => sh3_data_p_in_b,
		 result => sh3_data_in_b);


b2v_SH3_MUX_C : mux_2xn
GENERIC MAP(n => 6
			)
PORT MAP(sel => load(2),
		 data0 => sh2_data_out_c,
		 data1 => sh3_data_p_in_c,
		 result => sh3_data_in_c);


b2v_SH3_REG : reg_n_secdecset
GENERIC MAP(n => 6
			)
PORT MAP(clk => clk,
		 data_a_in => sh3_data_in_a,
		 data_b_in => sh3_data_in_b,
		 data_c_in => sh3_data_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out => sh_data_out_a,
		 data_b_out => sh_data_out_b,
		 data_c_out => sh_data_out_c);


END bdf_type;