-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 16:07:21 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY sh_dec IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		sh1_dv_p_in_a :  IN  STD_LOGIC;
		sh1_dv_p_in_b :  IN  STD_LOGIC;
		sh1_dv_p_in_c :  IN  STD_LOGIC;
		sh2_dv_p_in_a :  IN  STD_LOGIC;
		sh2_dv_p_in_b :  IN  STD_LOGIC;
		sh2_dv_p_in_c :  IN  STD_LOGIC;
		sh3_dv_p_in_a :  IN  STD_LOGIC;
		sh3_dv_p_in_b :  IN  STD_LOGIC;
		sh3_dv_p_in_c :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sh1_load :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sh2_load :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sh3_load :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sh_data_out_a :  OUT  STD_LOGIC;
		sh_data_out_b :  OUT  STD_LOGIC;
		sh_data_out_c :  OUT  STD_LOGIC
	);
END sh_dec;

ARCHITECTURE bdf_type OF sh_dec IS 

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 TO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 TO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 TO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 TO 0)
	);
END COMPONENT;

SIGNAL	sh1_dv_in_a :  STD_LOGIC;
SIGNAL	sh1_dv_in_b :  STD_LOGIC;
SIGNAL	sh1_dv_in_c :  STD_LOGIC;
SIGNAL	sh1_dv_out_a :  STD_LOGIC;
SIGNAL	sh1_dv_out_b :  STD_LOGIC;
SIGNAL	sh1_dv_out_c :  STD_LOGIC;
SIGNAL	sh2_dv_in_a :  STD_LOGIC;
SIGNAL	sh2_dv_in_b :  STD_LOGIC;
SIGNAL	sh2_dv_in_c :  STD_LOGIC;
SIGNAL	sh2_dv_out_a :  STD_LOGIC;
SIGNAL	sh2_dv_out_b :  STD_LOGIC;
SIGNAL	sh2_dv_out_c :  STD_LOGIC;
SIGNAL	sh3_dv_in_a :  STD_LOGIC;
SIGNAL	sh3_dv_in_b :  STD_LOGIC;
SIGNAL	sh3_dv_in_c :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC;


BEGIN 
SYNTHESIZED_WIRE_0 <= '0';
SYNTHESIZED_WIRE_1 <= '0';
SYNTHESIZED_WIRE_2 <= '0';






b2v_SH1_MUX_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh1_load(0),
		 data0(0) => SYNTHESIZED_WIRE_0,
		 data1(0) => sh1_dv_p_in_a,
		 result(0) => sh1_dv_in_a);


b2v_SH1_MUX_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh1_load(1),
		 data0(0) => SYNTHESIZED_WIRE_1,
		 data1(0) => sh1_dv_p_in_b,
		 result(0) => sh1_dv_in_b);


b2v_SH1_MUX_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh1_load(2),
		 data0(0) => SYNTHESIZED_WIRE_2,
		 data1(0) => sh1_dv_p_in_c,
		 result(0) => sh1_dv_in_c);


b2v_SH1_REG : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => sh1_dv_in_a,
		 data_b_in(0) => sh1_dv_in_b,
		 data_c_in(0) => sh1_dv_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => sh1_dv_out_a,
		 data_b_out(0) => sh1_dv_out_b,
		 data_c_out(0) => sh1_dv_out_c);


b2v_SH2_MUX : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => sh2_dv_in_a,
		 data_b_in(0) => sh2_dv_in_b,
		 data_c_in(0) => sh2_dv_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => sh2_dv_out_a,
		 data_b_out(0) => sh2_dv_out_b,
		 data_c_out(0) => sh2_dv_out_c);


b2v_SH2_MUX_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh2_load(0),
		 data0(0) => sh1_dv_out_a,
		 data1(0) => sh2_dv_p_in_a,
		 result(0) => sh2_dv_in_a);


b2v_SH2_MUX_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh2_load(1),
		 data0(0) => sh1_dv_out_b,
		 data1(0) => sh2_dv_p_in_b,
		 result(0) => sh2_dv_in_b);


b2v_SH2_MUX_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh2_load(2),
		 data0(0) => sh1_dv_out_c,
		 data1(0) => sh2_dv_p_in_c,
		 result(0) => sh2_dv_in_c);


b2v_SH3_MUX : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => sh3_dv_in_a,
		 data_b_in(0) => sh3_dv_in_b,
		 data_c_in(0) => sh3_dv_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => sh_data_out_a,
		 data_b_out(0) => sh_data_out_b,
		 data_c_out(0) => sh_data_out_c);


b2v_SH3_MUX_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh3_load(0),
		 data0(0) => sh2_dv_out_a,
		 data1(0) => sh3_dv_p_in_a,
		 result(0) => sh3_dv_in_a);


b2v_SH3_MUX_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh3_load(1),
		 data0(0) => sh2_dv_out_b,
		 data1(0) => sh3_dv_p_in_b,
		 result(0) => sh3_dv_in_b);


b2v_SH3_MUX_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => sh3_load(2),
		 data0(0) => sh2_dv_out_c,
		 data1(0) => sh3_dv_p_in_c,
		 result(0) => sh3_dv_in_c);


END bdf_type;