-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:29:37 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY shr_elem IS 
	PORT
	(
		load_a :  IN  STD_LOGIC;
		load_b :  IN  STD_LOGIC;
		load_c :  IN  STD_LOGIC;
		sin_a :  IN  STD_LOGIC;
		sin_c :  IN  STD_LOGIC;
		sin_b :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		pin_a :  IN  STD_LOGIC;
		pin_b :  IN  STD_LOGIC;
		pin_c :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sout_a :  OUT  STD_LOGIC;
		sout_b :  OUT  STD_LOGIC;
		sout_c :  OUT  STD_LOGIC
	);
END shr_elem;

ARCHITECTURE bdf_type OF shr_elem IS 

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	shr_in_a :  STD_LOGIC;
SIGNAL	shr_in_b :  STD_LOGIC;
SIGNAL	shr_in_c :  STD_LOGIC;


BEGIN 



b2v_SHR_M_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => load_a,
		 data0(0) => sin_a,
		 data1(0) => pin_a,
		 result(0) => shr_in_a);


b2v_SHR_M_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => load_b,
		 data0(0) => sin_b,
		 data1(0) => pin_b,
		 result(0) => shr_in_b);


b2v_SHR_M_C : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => load_c,
		 data0(0) => sin_c,
		 data1(0) => pin_c,
		 result(0) => shr_in_c);


b2v_SHR_R : reg_n_secdecset
GENERIC MAP(n => 1
			)
PORT MAP(clk => clk,
		 data_a_in(0) => shr_in_a,
		 data_b_in(0) => shr_in_b,
		 data_c_in(0) => shr_in_c,
		 enable => enable,
		 reset => reset,
		 data_a_out(0) => sout_a,
		 data_b_out(0) => sout_b,
		 data_c_out(0) => sout_c);


END bdf_type;