-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Jan 07 18:31:35 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY shr_l IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		load :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		pin_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		pin_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		pin_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		sin :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		pout_a :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		pout_b :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		pout_c :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		sout :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END shr_l;

ARCHITECTURE bdf_type OF shr_l IS 

COMPONENT shr_elem
	PORT(clk : IN STD_LOGIC;
		 load_a : IN STD_LOGIC;
		 load_b : IN STD_LOGIC;
		 load_c : IN STD_LOGIC;
		 sin_a : IN STD_LOGIC;
		 sin_b : IN STD_LOGIC;
		 sin_c : IN STD_LOGIC;
		 pin_a : IN STD_LOGIC;
		 pin_b : IN STD_LOGIC;
		 pin_c : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sout_a : OUT STD_LOGIC;
		 sout_b : OUT STD_LOGIC;
		 sout_c : OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	pout_a_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	pout_b_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	pout_c_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	sout_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 


sout_ALTERA_SYNTHESIZED(0) <= pout_a_ALTERA_SYNTHESIZED(7);


sout_ALTERA_SYNTHESIZED(1) <= pout_b_ALTERA_SYNTHESIZED(7);


sout_ALTERA_SYNTHESIZED(2) <= pout_c_ALTERA_SYNTHESIZED(7);



b2v_SHR_0 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => sin(0),
		 sin_b => sin(1),
		 sin_c => sin(2),
		 pin_a => pin_a(0),
		 pin_b => pin_b(0),
		 pin_c => pin_c(0),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(0),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(0),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(0));


b2v_SHR_1 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(0),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(0),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(0),
		 pin_a => pin_a(1),
		 pin_b => pin_b(1),
		 pin_c => pin_c(1),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(1),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(1),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(1));


b2v_SHR_2 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(1),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(1),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(1),
		 pin_a => pin_a(2),
		 pin_b => pin_b(2),
		 pin_c => pin_c(2),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(2),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(2),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(2));


b2v_SHR_3 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(2),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(2),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(2),
		 pin_a => pin_a(3),
		 pin_b => pin_b(3),
		 pin_c => pin_c(3),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(3),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(3),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(3));


b2v_SHR_4 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(3),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(3),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(3),
		 pin_a => pin_a(4),
		 pin_b => pin_b(4),
		 pin_c => pin_c(4),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(4),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(4),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(4));


b2v_SHR_5 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(4),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(4),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(4),
		 pin_a => pin_a(5),
		 pin_b => pin_b(5),
		 pin_c => pin_c(5),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(5),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(5),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(5));


b2v_SHR_6 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(5),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(5),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(5),
		 pin_a => pin_a(6),
		 pin_b => pin_b(6),
		 pin_c => pin_c(6),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(6),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(6),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(6));


b2v_SHR_7 : shr_elem
PORT MAP(clk => clk,
		 load_a => load(0),
		 load_b => load(1),
		 load_c => load(2),
		 sin_a => pout_a_ALTERA_SYNTHESIZED(6),
		 sin_b => pout_b_ALTERA_SYNTHESIZED(6),
		 sin_c => pout_c_ALTERA_SYNTHESIZED(6),
		 pin_a => pin_a(7),
		 pin_b => pin_b(7),
		 pin_c => pin_c(7),
		 enable => enable,
		 reset => reset,
		 sout_a => pout_a_ALTERA_SYNTHESIZED(7),
		 sout_b => pout_b_ALTERA_SYNTHESIZED(7),
		 sout_c => pout_c_ALTERA_SYNTHESIZED(7));

pout_a <= pout_a_ALTERA_SYNTHESIZED;
pout_b <= pout_b_ALTERA_SYNTHESIZED;
pout_c <= pout_c_ALTERA_SYNTHESIZED;
sout <= sout_ALTERA_SYNTHESIZED;

END bdf_type;