-- NAME: voter logic
--
-- DESCRiPTiON: n-bit voter logic

LIBRARY ieee;
use IEEE.STD_LOGIC_UNSIGNED.all;
USE iEEE.std_logic_arith.all;
USE ieee.std_logic_1164.all;


ENTiTY vl_n iS
GENERiC (
  n: integer range 1 to 64 := 1 -- number of bits
);
PORT (
  data_a_in : iN STD_LOGiC_VECTOR(n-1 downto 0);
  data_b_in : iN STD_LOGiC_VECTOR(n-1 downto 0);
  data_c_in : iN STD_LOGiC_VECTOR(n-1 downto 0);
  data_out : OUT STD_LOGiC_VECTOR(n-1 downto 0)
);
	
end vl_n;


ARCHiTECTURE vl_n_architecture OF vl_n iS

begin

voter_logic: process (data_a_in, data_b_in, data_c_in)

variable i : integer;
type array_nx3 is array (n-1 downto 0) of std_logic_vector(2 downto 0);
variable status : array_nx3;

begin
  
	for i in 0 to n-1 loop
	
--		status(i) := data_a_in(i) & data_b_in(i) & data_c_in(i);		

--		case (status(i)) is

 		-- data(i) = 0 
if ((data_a_in(i) = '0') and (data_b_in(i) = '0') and (data_c_in(i) = '0')) then		
		data_out(i) <= '0';
elsif ((data_a_in(i) = '1') and (data_b_in(i) = '0') and (data_c_in(i) = '0')) then		
	 	data_out(i) <= '0'; 
elsif ((data_a_in(i) = '0') and (data_b_in(i) = '1') and (data_c_in(i) = '0')) then		
		data_out(i) <= '0'; 
elsif ((data_a_in(i) = '0') and (data_b_in(i) = '0') and (data_c_in(i) = '1')) then		
		data_out(i) <= '0';
                             
		-- data(i) = 1     
elsif ((data_a_in(i) = '1') and (data_b_in(i) = '1') and (data_c_in(i) = '1')) then		
		data_out(i) <= '1'; 
elsif ((data_a_in(i) = '0') and (data_b_in(i) = '1') and (data_c_in(i) = '1')) then		
		data_out(i) <= '1'; 
elsif ((data_a_in(i) = '1') and (data_b_in(i) = '0') and (data_c_in(i) = '1')) then		
		data_out(i) <= '1'; 
else		
		data_out(i) <= '1'; 
end if;                                  

 
	end loop;
  
end process;
  	      
END vl_n_architecture;
