-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Feb 04 01:59:43 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY vlf_dec_rh IS 
	PORT
	(
		clk :  IN  STD_LOGIC;
		vlf_data_valid :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		init :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reg_init_a :  IN  STD_LOGIC_VECTOR(8 DOWNTO 0);
		reg_init_b :  IN  STD_LOGIC_VECTOR(8 DOWNTO 0);
		reg_init_c :  IN  STD_LOGIC_VECTOR(8 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		vlf_data :  IN  STD_LOGIC_VECTOR(15 DOWNTO 0);
		e1_out :  OUT  STD_LOGIC;
		e2_out :  OUT  STD_LOGIC;
		e3_out :  OUT  STD_LOGIC;
		e4_out :  OUT  STD_LOGIC;
		e5_out :  OUT  STD_LOGIC;
		e6_out :  OUT  STD_LOGIC;
		ta1_out :  OUT  STD_LOGIC;
		ta2_out :  OUT  STD_LOGIC;
		ta3_out :  OUT  STD_LOGIC;
		tb1_out :  OUT  STD_LOGIC;
		tb2_out :  OUT  STD_LOGIC
	);
END vlf_dec_rh;

ARCHITECTURE bdf_type OF vlf_dec_rh IS 

COMPONENT hamming_dec
	PORT(ham_dec_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 ham_dec_out : OUT STD_LOGIC_VECTOR(10 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_n_secdecset_init
GENERIC (n : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_a_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_a_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_init : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_reset : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 init : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	ham_dec_a_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ham_dec_b_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ham_dec_c_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_a :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_a_init :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_a_reset :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_b :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_b_init :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_b_reset :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_c :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_c_init :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_in_c_reset :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_out_a :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_out_b :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	reg_out_c :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	vl_out :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC_VECTOR(0 TO 3);
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC_VECTOR(0 TO 4);
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_6 :  STD_LOGIC_VECTOR(0 TO 3);
SIGNAL	SYNTHESIZED_WIRE_7 :  STD_LOGIC_VECTOR(0 TO 4);
SIGNAL	SYNTHESIZED_WIRE_8 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_9 :  STD_LOGIC_VECTOR(0 TO 1);
SIGNAL	SYNTHESIZED_WIRE_10 :  STD_LOGIC_VECTOR(0 TO 3);
SIGNAL	SYNTHESIZED_WIRE_11 :  STD_LOGIC_VECTOR(0 TO 4);


BEGIN 
SYNTHESIZED_WIRE_0 <= "11";
SYNTHESIZED_WIRE_1 <= "11";
SYNTHESIZED_WIRE_2 <= "0000";
SYNTHESIZED_WIRE_3 <= "00000";
SYNTHESIZED_WIRE_4 <= "11";
SYNTHESIZED_WIRE_5 <= "11";
SYNTHESIZED_WIRE_6 <= "0000";
SYNTHESIZED_WIRE_7 <= "00000";
SYNTHESIZED_WIRE_8 <= "11";
SYNTHESIZED_WIRE_9 <= "11";
SYNTHESIZED_WIRE_10 <= "0000";
SYNTHESIZED_WIRE_11 <= "00000";



b2v_H_DEC_A : hamming_dec
PORT MAP(ham_dec_in => vlf_data,
		 ham_dec_out => ham_dec_a_out);


b2v_H_DEC_B : hamming_dec
PORT MAP(ham_dec_in => vlf_data,
		 ham_dec_out => ham_dec_b_out);


b2v_H_DEC_C : hamming_dec
PORT MAP(ham_dec_in => vlf_data,
		 ham_dec_out => ham_dec_c_out);

e1_out <= vl_out(0);


e2_out <= vl_out(1);


e3_out <= vl_out(2);


e4_out <= vl_out(3);


e5_out <= vl_out(4);


e6_out <= vl_out(5);











b2v_REG : reg_n_secdecset_init
GENERIC MAP(n => 11
			)
PORT MAP(clk => clk,
		 data_a_in => reg_in_a,
		 data_a_init => reg_in_a_init,
		 data_a_reset => reg_in_a_reset,
		 data_b_in => reg_in_b,
		 data_b_init => reg_in_b_init,
		 data_b_reset => reg_in_b_reset,
		 data_c_in => reg_in_c,
		 data_c_init => reg_in_c_init,
		 data_c_reset => reg_in_c_reset,
		 enable => enable,
		 init => init,
		 reset => reset,
		 data_a_out => reg_out_a,
		 data_b_out => reg_out_b,
		 data_c_out => reg_out_c);




ta1_out <= vl_out(6);


ta2_out <= vl_out(7);


ta3_out <= vl_out(8);


tb1_out <= vl_out(9);


tb2_out <= vl_out(10);



reg_in_a_init(5 DOWNTO 4) <= SYNTHESIZED_WIRE_0;


reg_in_a_init(3 DOWNTO 0) <= reg_init_a(3 DOWNTO 0);


reg_in_a_init(10 DOWNTO 6) <= reg_init_a(8 DOWNTO 4);


reg_in_a_reset(5 DOWNTO 4) <= SYNTHESIZED_WIRE_1;


reg_in_a_reset(3 DOWNTO 0) <= SYNTHESIZED_WIRE_2;


reg_in_a_reset(10 DOWNTO 6) <= SYNTHESIZED_WIRE_3;



reg_in_b_init(5 DOWNTO 4) <= SYNTHESIZED_WIRE_4;


reg_in_b_init(3 DOWNTO 0) <= reg_init_b(3 DOWNTO 0);


reg_in_b_init(10 DOWNTO 6) <= reg_init_b(8 DOWNTO 4);


reg_in_b_reset(5 DOWNTO 4) <= SYNTHESIZED_WIRE_5;


reg_in_b_reset(3 DOWNTO 0) <= SYNTHESIZED_WIRE_6;


reg_in_b_reset(10 DOWNTO 6) <= SYNTHESIZED_WIRE_7;



reg_in_c_init(5 DOWNTO 4) <= SYNTHESIZED_WIRE_8;


reg_in_c_init(3 DOWNTO 0) <= reg_init_c(3 DOWNTO 0);


reg_in_c_init(10 DOWNTO 6) <= reg_init_c(8 DOWNTO 4);


reg_in_c_reset(5 DOWNTO 4) <= SYNTHESIZED_WIRE_9;


reg_in_c_reset(3 DOWNTO 0) <= SYNTHESIZED_WIRE_10;


reg_in_c_reset(10 DOWNTO 6) <= SYNTHESIZED_WIRE_11;




b2v_MUX_A : mux_2xn
GENERIC MAP(n => 11
			)
PORT MAP(sel => vlf_data_valid,
		 data0 => reg_out_a,
		 data1 => ham_dec_a_out,
		 result => reg_in_a);


b2v_MUX_B : mux_2xn
GENERIC MAP(n => 11
			)
PORT MAP(sel => vlf_data_valid,
		 data0 => reg_out_b,
		 data1 => ham_dec_b_out,
		 result => reg_in_b);


b2v_MUX_C : mux_2xn
GENERIC MAP(n => 11
			)
PORT MAP(sel => vlf_data_valid,
		 data0 => reg_out_c,
		 data1 => ham_dec_c_out,
		 result => reg_in_c);


b2v_VL : vl_n
GENERIC MAP(n => 11
			)
PORT MAP(data_a_in => reg_out_a,
		 data_b_in => reg_out_b,
		 data_c_in => reg_out_c,
		 data_out => vl_out);


END bdf_type;