-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Thu Jan 06 15:16:40 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY vlf_enc_rh IS 
	PORT
	(
		e1_in :  IN  STD_LOGIC;
		e2_in :  IN  STD_LOGIC;
		tb1_in :  IN  STD_LOGIC;
		tb2_in :  IN  STD_LOGIC;
		ta2_in :  IN  STD_LOGIC;
		ta3_in :  IN  STD_LOGIC;
		e3_in :  IN  STD_LOGIC;
		e4_in :  IN  STD_LOGIC;
		e5_in :  IN  STD_LOGIC;
		e6_in :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		ta1_in :  IN  STD_LOGIC;
		enable :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		reset :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		ta_delay_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ta_delay_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		ta_delay_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tb_delay_a :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tb_delay_b :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		tb_delay_c :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
		vlf_data_valid :  OUT  STD_LOGIC;
		vlf_data :  OUT  STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END vlf_enc_rh;

ARCHITECTURE bdf_type OF vlf_enc_rh IS 

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT reg_1r_secdecset
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC;
		 data_b_in : IN STD_LOGIC;
		 data_c_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC;
		 data_b_out : OUT STD_LOGIC;
		 data_c_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT reg_1s_secdecset
	PORT(clk : IN STD_LOGIC;
		 data_a_in : IN STD_LOGIC;
		 data_b_in : IN STD_LOGIC;
		 data_c_in : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 data_a_out : OUT STD_LOGIC;
		 data_b_out : OUT STD_LOGIC;
		 data_c_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT edge_detector
	PORT(data : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 edge : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT and_3x2
	PORT(dina : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dinb : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 dout : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

COMPONENT hamming_enc
	PORT(ham_enc_in : IN STD_LOGIC_VECTOR(10 DOWNTO 0);
		 ham_enc_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT delay_cnt
	PORT(clk : IN STD_LOGIC;
		 cnt_en : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_res : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_a_out : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt_b_out : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt_c_out : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
	);
END COMPONENT;

COMPONENT delay_manager
	PORT(clk : IN STD_LOGIC;
		 cnt_a_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt_b_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 cnt_c_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 delay_a : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 delay_b : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 delay_c : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 edge : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 enable : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_en : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 cnt_res : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		 sample : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	data_valid :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e1_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e2_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e3_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e3_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e3_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e4_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e4_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e4_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e5_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e5_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e5_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e6_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e6_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	e6_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ham_enc_a_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ham_enc_a_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	ham_enc_b_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ham_enc_b_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	ham_enc_c_in :  STD_LOGIC_VECTOR(10 DOWNTO 0);
SIGNAL	ham_enc_c_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	reg_data_valid :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta1_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta2_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta3_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta_cnt_a_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ta_cnt_b_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ta_cnt_c_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	ta_cnt_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta_cnt_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	ta_sample :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb1_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb2_value :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb_cnt_a_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_cnt_b_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_cnt_c_out :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_cnt_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb_cnt_res :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb_edge :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb_reg_en :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tb_sample :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC_VECTOR(2 DOWNTO 0);


BEGIN 



b2v_DATA_VL : vl_n
GENERIC MAP(n => 16
			)
PORT MAP(data_a_in => ham_enc_a_out,
		 data_b_in => ham_enc_b_out,
		 data_c_in => ham_enc_c_out,
		 data_out => vlf_data);


b2v_DV_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => data_valid(0),
		 data_b_in => data_valid(1),
		 data_c_in => data_valid(2),
		 enable => enable,
		 reset => reset,
		 data_a_out => reg_data_valid(0),
		 data_b_out => reg_data_valid(1),
		 data_c_out => reg_data_valid(2));


b2v_DV_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => reg_data_valid(0),
		 data_b_in(0) => reg_data_valid(1),
		 data_c_in(0) => reg_data_valid(2),
		 data_out(0) => vlf_data_valid);


b2v_E1_ED : edge_detector
PORT MAP(data => e1_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e1_edge);


b2v_E1_ED_EN : and_3x2
PORT MAP(dina => e1_edge,
		 dinb => enable,
		 dout => e1_reg_en);


b2v_E1_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => e1_in,
		 data_b_in => e1_in,
		 data_c_in => e1_in,
		 enable => e1_reg_en,
		 reset => reset,
		 data_a_out => e1_value(0),
		 data_b_out => e1_value(1),
		 data_c_out => e1_value(2));


b2v_E2_ED_EN : and_3x2
PORT MAP(dina => e2_edge,
		 dinb => enable,
		 dout => e2_reg_en);


b2v_E2_EN : edge_detector
PORT MAP(data => e2_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e2_edge);


b2v_E2_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => e2_in,
		 data_b_in => e2_in,
		 data_c_in => e2_in,
		 enable => e2_reg_en,
		 reset => reset,
		 data_a_out => e2_value(0),
		 data_b_out => e2_value(1),
		 data_c_out => e2_value(2));


b2v_E3_ED : edge_detector
PORT MAP(data => e3_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e3_edge);


b2v_E3_ED_EN : and_3x2
PORT MAP(dina => e3_edge,
		 dinb => enable,
		 dout => e3_reg_en);


b2v_E3_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => e3_in,
		 data_b_in => e3_in,
		 data_c_in => e3_in,
		 enable => e3_reg_en,
		 reset => reset,
		 data_a_out => e3_value(0),
		 data_b_out => e3_value(1),
		 data_c_out => e3_value(2));


b2v_E4_ED : edge_detector
PORT MAP(data => e4_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e4_edge);


b2v_E4_ED_EN : and_3x2
PORT MAP(dina => e4_edge,
		 dinb => enable,
		 dout => e4_reg_en);


b2v_E4_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => e4_in,
		 data_b_in => e4_in,
		 data_c_in => e4_in,
		 enable => e4_reg_en,
		 reset => reset,
		 data_a_out => e4_value(0),
		 data_b_out => e4_value(1),
		 data_c_out => e4_value(2));


b2v_E5_ED : edge_detector
PORT MAP(data => e5_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e5_edge);


b2v_E5_ED_EN : and_3x2
PORT MAP(dina => e5_edge,
		 dinb => enable);


b2v_E5_REG : reg_1s_secdecset
PORT MAP(clk => clk,
		 data_a_in => e5_in,
		 data_b_in => e5_in,
		 data_c_in => e5_in,
		 enable => e5_edge,
		 reset => reset,
		 data_a_out => e5_value(0),
		 data_b_out => e5_value(1),
		 data_c_out => e5_value(2));


b2v_E6_ED : edge_detector
PORT MAP(data => e6_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => e6_edge);


b2v_E6_ED_EN : and_3x2
PORT MAP(dina => e6_edge,
		 dinb => enable,
		 dout => e6_reg_en);


b2v_E6_REG : reg_1s_secdecset
PORT MAP(clk => clk,
		 data_a_in => e6_in,
		 data_b_in => e6_in,
		 data_c_in => e6_in,
		 enable => e6_reg_en,
		 reset => reset,
		 data_a_out => e6_value(0),
		 data_b_out => e6_value(1),
		 data_c_out => e6_value(2));


b2v_H_ENC_A : hamming_enc
PORT MAP(ham_enc_in => ham_enc_a_in,
		 ham_enc_out => ham_enc_a_out);


b2v_H_ENC_B : hamming_enc
PORT MAP(ham_enc_in => ham_enc_b_in,
		 ham_enc_out => ham_enc_b_out);


b2v_H_ENC_C : hamming_enc
PORT MAP(ham_enc_in => ham_enc_c_in,
		 ham_enc_out => ham_enc_c_out);




data_valid(0) <= e1_edge(0) OR e3_edge(0) OR e2_edge(0) OR e4_edge(0) OR e6_edge(0) OR e5_edge(0) OR ta_sample(0) OR tb_sample(0);
data_valid(1) <= e1_edge(1) OR e3_edge(1) OR e2_edge(1) OR e4_edge(1) OR e6_edge(1) OR e5_edge(1) OR ta_sample(1) OR tb_sample(1);
data_valid(2) <= e1_edge(2) OR e3_edge(2) OR e2_edge(2) OR e4_edge(2) OR e6_edge(2) OR e5_edge(2) OR ta_sample(2) OR tb_sample(2);

ham_enc_a_in(0) <= e1_value(0);
ham_enc_a_in(1) <= e2_value(0);
ham_enc_a_in(2) <= e3_value(0);
ham_enc_a_in(3) <= e4_value(0);
ham_enc_a_in(4) <= e5_value(0);
ham_enc_a_in(5) <= e6_value(0);
ham_enc_a_in(6) <= ta1_value(0);
ham_enc_a_in(7) <= ta2_value(0);
ham_enc_a_in(8) <= ta3_value(0);
ham_enc_a_in(9) <= tb1_value(0);
ham_enc_a_in(10) <= tb2_value(0);

ham_enc_b_in(0) <= e1_value(1);
ham_enc_b_in(1) <= e2_value(1);
ham_enc_b_in(2) <= e3_value(1);
ham_enc_b_in(3) <= e4_value(1);
ham_enc_b_in(4) <= e5_value(1);
ham_enc_b_in(5) <= e6_value(1);
ham_enc_b_in(6) <= ta1_value(1);
ham_enc_b_in(7) <= ta2_value(1);
ham_enc_b_in(8) <= ta3_value(1);
ham_enc_b_in(9) <= tb1_value(1);
ham_enc_b_in(10) <= tb2_value(1);

ham_enc_c_in(0) <= e1_value(2);
ham_enc_c_in(1) <= e2_value(2);
ham_enc_c_in(2) <= e3_value(2);
ham_enc_c_in(3) <= e4_value(2);
ham_enc_c_in(4) <= e5_value(2);
ham_enc_c_in(5) <= e6_value(2);
ham_enc_c_in(6) <= ta1_value(2);
ham_enc_c_in(7) <= ta2_value(2);
ham_enc_c_in(8) <= ta3_value(2);
ham_enc_c_in(9) <= tb1_value(2);
ham_enc_c_in(10) <= tb2_value(2);







b2v_TA1_ED : edge_detector
PORT MAP(data => ta1_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => ta_edge);


b2v_TA1_ED_EN : and_3x2
PORT MAP(dina => ta_sample,
		 dinb => enable,
		 dout => ta_reg_en);


b2v_TA1_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => ta1_in,
		 data_b_in => ta1_in,
		 data_c_in => ta1_in,
		 enable => ta_reg_en,
		 reset => reset,
		 data_a_out => ta1_value(0),
		 data_b_out => ta1_value(1),
		 data_c_out => ta1_value(2));


b2v_TA2_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => ta2_in,
		 data_b_in => ta2_in,
		 data_c_in => ta2_in,
		 enable => ta_reg_en,
		 reset => reset,
		 data_a_out => ta2_value(0),
		 data_b_out => ta2_value(1),
		 data_c_out => ta2_value(2));


b2v_TA3_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => ta3_in,
		 data_b_in => ta3_in,
		 data_c_in => ta3_in,
		 enable => ta_reg_en,
		 reset => reset,
		 data_a_out => ta3_value(0),
		 data_b_out => ta3_value(1),
		 data_c_out => ta3_value(2));


b2v_TA_CNT : delay_cnt
PORT MAP(clk => clk,
		 cnt_en => ta_cnt_en,
		 cnt_res => ta_cnt_res,
		 cnt_a_out => ta_cnt_a_out,
		 cnt_b_out => ta_cnt_b_out,
		 cnt_c_out => ta_cnt_c_out);


b2v_TA_CNTEN : and_3x2
PORT MAP(dina => SYNTHESIZED_WIRE_0,
		 dinb => enable,
		 dout => ta_cnt_en);


b2v_TA_DM : delay_manager
PORT MAP(clk => clk,
		 cnt_a_out => ta_cnt_a_out,
		 cnt_b_out => ta_cnt_b_out,
		 cnt_c_out => ta_cnt_c_out,
		 delay_a => ta_delay_a,
		 delay_b => ta_delay_b,
		 delay_c => ta_delay_c,
		 edge => ta_edge,
		 enable => enable,
		 reset => reset,
		 cnt_en => SYNTHESIZED_WIRE_0,
		 cnt_res => ta_cnt_res,
		 sample => ta_sample);


b2v_TB1_ED_EN : and_3x2
PORT MAP(dina => tb_sample,
		 dinb => enable,
		 dout => tb_reg_en);


b2v_TB1_EN : edge_detector
PORT MAP(data => tb1_in,
		 clk => clk,
		 enable => enable,
		 reset => reset,
		 edge => tb_edge);


b2v_TB1_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => tb1_in,
		 data_b_in => tb1_in,
		 data_c_in => tb1_in,
		 enable => tb_reg_en,
		 reset => reset,
		 data_a_out => tb1_value(0),
		 data_b_out => tb1_value(1),
		 data_c_out => tb1_value(2));


b2v_TB2_REG : reg_1r_secdecset
PORT MAP(clk => clk,
		 data_a_in => tb2_in,
		 data_b_in => tb2_in,
		 data_c_in => tb2_in,
		 enable => tb_reg_en,
		 reset => reset,
		 data_a_out => tb2_value(0),
		 data_b_out => tb2_value(1),
		 data_c_out => tb2_value(2));


b2v_TB_CNT : delay_cnt
PORT MAP(clk => clk,
		 cnt_en => tb_cnt_en,
		 cnt_res => tb_cnt_res,
		 cnt_a_out => tb_cnt_a_out,
		 cnt_b_out => tb_cnt_b_out,
		 cnt_c_out => tb_cnt_c_out);


b2v_TB_CNTEN : and_3x2
PORT MAP(dina => SYNTHESIZED_WIRE_1,
		 dinb => enable,
		 dout => tb_cnt_en);


b2v_TB_DM : delay_manager
PORT MAP(clk => clk,
		 cnt_a_out => tb_cnt_a_out,
		 cnt_b_out => tb_cnt_b_out,
		 cnt_c_out => tb_cnt_c_out,
		 delay_a => tb_delay_a,
		 delay_b => tb_delay_b,
		 delay_c => tb_delay_c,
		 edge => tb_edge,
		 enable => enable,
		 reset => reset,
		 cnt_en => SYNTHESIZED_WIRE_1,
		 cnt_res => tb_cnt_res,
		 sample => tb_sample);


END bdf_type;