module CDN_flop_1 (clk, d, sena, aclr, apre, srl, srd, q);
  input clk, d, sena, aclr, apre, srl, srd;
  output q;
  wire clk, d, sena, aclr, apre, srl, srd;
  wire q;
  reg  qi;
  assign #1 q = qi;
  always 
    @(posedge clk or posedge apre or posedge aclr) 
      if (aclr) 
        qi = 0;
      else if (apre) 
          qi = 1;
        else if (srl) 
            qi = srd;
          else begin
            if (sena) 
              qi = d;
          end
  initial 
    qi = 1'b0;
endmodule



module hdl_1(D_OUT, CLK, D_IN, EN, RST_L);
  input CLK, D_IN, EN, RST_L;
  output D_OUT;
  wire CLK, D_IN, EN, RST_L;
  wire D_OUT;
  wire n_6, n_11;
  and g1 (n_6, RST_L, n_11);
  or g8 (n_11, wc, wc1);
  and gc1 (wc1, D_IN, EN);
  and gc0 (wc, wc0, D_OUT);
  not gc (wc0, EN);
  CDN_flop_1 DFF_E0(.clk (CLK), .d (n_6), .sena (1'b1), .aclr (1'b0),
       .apre (1'b0), .srl (1'b0), .srd (1'b0), .q (D_OUT));
endmodule
// Generated by Cadence Encounter(R) RTL Compiler v07.20-s009_1

module array_4x2(OUT_M, CLK, EN, IN_W0, IN_W1, IN_W2, IN_W3, RST_L,
     W_ADDR);
  input CLK, RST_L;
  input [3:0] EN;
  input [1:0] IN_W0, IN_W1, IN_W2, IN_W3, W_ADDR;
  output [1:0] OUT_M;
  wire CLK, RST_L;
  wire [3:0] EN;
  wire [1:0] IN_W0, IN_W1, IN_W2, IN_W3, W_ADDR;
  wire [1:0] OUT_M;
  wire \OUT_W0[0] , \OUT_W0[1] , \OUT_W1[0] , \OUT_W1[1] , \OUT_W2[0] ,
       \OUT_W2[1] , \OUT_W3[0] , \OUT_W3[1] ;
  wire n_358, n_378;
  hdl_1 W3_B0(.D_OUT (\OUT_W3[0] ), .CLK (CLK), .D_IN (IN_W3[0]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W2_B0(.D_OUT (\OUT_W2[0] ), .CLK (CLK), .D_IN (IN_W2[0]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W1_B0(.D_OUT (\OUT_W1[0] ), .CLK (CLK), .D_IN (IN_W1[0]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W0_B0(.D_OUT (\OUT_W0[0] ), .CLK (CLK), .D_IN (IN_W0[0]), .EN
       (EN[0]), .RST_L (RST_L));
  hdl_1 W3_B1(.D_OUT (\OUT_W3[1] ), .CLK (CLK), .D_IN (IN_W3[1]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W2_B1(.D_OUT (\OUT_W2[1] ), .CLK (CLK), .D_IN (IN_W2[1]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W1_B1(.D_OUT (\OUT_W1[1] ), .CLK (CLK), .D_IN (IN_W1[1]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W0_B1(.D_OUT (\OUT_W0[1] ), .CLK (CLK), .D_IN (IN_W0[1]), .EN
       (EN[0]), .RST_L (RST_L));
  or g128 (n_358, wc, wc1);
  and gc1 (wc1, \OUT_W3[1] , W_ADDR[1], W_ADDR[0]);
  and gc0 (wc, wc0, \OUT_W1[1] , W_ADDR[0]);
  not gc (wc0, W_ADDR[1]);
  or g129 (OUT_M[1], n_358, wc2, wc5);
  and gc6 (wc5, wc6, \OUT_W2[1] , W_ADDR[1]);
  not gc5 (wc6, W_ADDR[0]);
  and gc4 (wc2, wc3, wc4, \OUT_W0[1] );
  not gc3 (wc4, W_ADDR[1]);
  not gc2 (wc3, W_ADDR[0]);
  or g149 (n_378, wc7, wc9);
  and gc9 (wc9, \OUT_W3[0] , W_ADDR[1], W_ADDR[0]);
  and gc8 (wc7, wc8, \OUT_W1[0] , W_ADDR[0]);
  not gc7 (wc8, W_ADDR[1]);
  or g150 (OUT_M[0], n_378, wc10, wc13);
  and gc14 (wc13, wc14, \OUT_W2[0] , W_ADDR[1]);
  not gc13 (wc14, W_ADDR[0]);
  and gc12 (wc10, wc11, wc12, \OUT_W0[0] );
  not gc11 (wc12, W_ADDR[1]);
  not gc10 (wc11, W_ADDR[0]);
endmodule

module array_4x4(OUT_M, CLK, EN, IN_W0, IN_W1, IN_W2, IN_W3, RST_L,
     W_ADDR);
  input CLK, RST_L;
  input [3:0] EN, IN_W0, IN_W1, IN_W2, IN_W3;
  input [1:0] W_ADDR;
  output [3:0] OUT_M;
  wire CLK, RST_L;
  wire [3:0] EN, IN_W0, IN_W1, IN_W2, IN_W3;
  wire [1:0] W_ADDR;
  wire [3:0] OUT_M;
  wire \OUT_W0[0] , \OUT_W0[1] , \OUT_W0[2] , \OUT_W0[3] , \OUT_W1[0] ,
       \OUT_W1[1] , \OUT_W1[2] , \OUT_W1[3] ;
  wire \OUT_W2[0] , \OUT_W2[1] , \OUT_W2[2] , \OUT_W2[3] , \OUT_W3[0] ,
       \OUT_W3[1] , \OUT_W3[2] , \OUT_W3[3] ;
  wire n_800, n_820, n_840, n_860;
  hdl_1 W1_B1(.D_OUT (\OUT_W1[1] ), .CLK (CLK), .D_IN (IN_W1[1]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W2_B1(.D_OUT (\OUT_W2[1] ), .CLK (CLK), .D_IN (IN_W2[1]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W3_B1(.D_OUT (\OUT_W3[1] ), .CLK (CLK), .D_IN (IN_W3[1]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W1_B0(.D_OUT (\OUT_W1[0] ), .CLK (CLK), .D_IN (IN_W1[0]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W0_B0(.D_OUT (\OUT_W0[0] ), .CLK (CLK), .D_IN (IN_W0[0]), .EN
       (EN[0]), .RST_L (RST_L));
  hdl_1 W3_B0(.D_OUT (\OUT_W3[0] ), .CLK (CLK), .D_IN (IN_W3[0]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W0_B1(.D_OUT (\OUT_W0[1] ), .CLK (CLK), .D_IN (IN_W0[1]), .EN
       (EN[0]), .RST_L (RST_L));
  hdl_1 W2_B0(.D_OUT (\OUT_W2[0] ), .CLK (CLK), .D_IN (IN_W2[0]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W3_B2(.D_OUT (\OUT_W3[2] ), .CLK (CLK), .D_IN (IN_W3[2]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W0_B2(.D_OUT (\OUT_W0[2] ), .CLK (CLK), .D_IN (IN_W0[2]), .EN
       (EN[0]), .RST_L (RST_L));
  hdl_1 W1_B2(.D_OUT (\OUT_W1[2] ), .CLK (CLK), .D_IN (IN_W1[2]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W2_B2(.D_OUT (\OUT_W2[2] ), .CLK (CLK), .D_IN (IN_W2[2]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W1_B3(.D_OUT (\OUT_W1[3] ), .CLK (CLK), .D_IN (IN_W1[3]), .EN
       (EN[1]), .RST_L (RST_L));
  hdl_1 W3_B3(.D_OUT (\OUT_W3[3] ), .CLK (CLK), .D_IN (IN_W3[3]), .EN
       (EN[3]), .RST_L (RST_L));
  hdl_1 W2_B3(.D_OUT (\OUT_W2[3] ), .CLK (CLK), .D_IN (IN_W2[3]), .EN
       (EN[2]), .RST_L (RST_L));
  hdl_1 W0_B3(.D_OUT (\OUT_W0[3] ), .CLK (CLK), .D_IN (IN_W0[3]), .EN
       (EN[0]), .RST_L (RST_L));
  or g303 (n_800, wc15, wc17);
  and gc17 (wc17, \OUT_W3[3] , W_ADDR[1], W_ADDR[0]);
  and gc16 (wc15, wc16, \OUT_W1[3] , W_ADDR[0]);
  not gc15 (wc16, W_ADDR[1]);
  or g304 (OUT_M[3], n_800, wc18, wc21);
  and gc22 (wc21, wc22, \OUT_W2[3] , W_ADDR[1]);
  not gc21 (wc22, W_ADDR[0]);
  and gc20 (wc18, wc19, wc20, \OUT_W0[3] );
  not gc19 (wc20, W_ADDR[1]);
  not gc18 (wc19, W_ADDR[0]);
  or g324 (n_820, wc23, wc25);
  and gc25 (wc25, \OUT_W3[2] , W_ADDR[1], W_ADDR[0]);
  and gc24 (wc23, wc24, \OUT_W1[2] , W_ADDR[0]);
  not gc23 (wc24, W_ADDR[1]);
  or g325 (OUT_M[2], n_820, wc26, wc29);
  and gc30 (wc29, wc30, \OUT_W2[2] , W_ADDR[1]);
  not gc29 (wc30, W_ADDR[0]);
  and gc28 (wc26, wc27, wc28, \OUT_W0[2] );
  not gc27 (wc28, W_ADDR[1]);
  not gc26 (wc27, W_ADDR[0]);
  or g345 (n_840, wc31, wc33);
  and gc33 (wc33, \OUT_W3[1] , W_ADDR[1], W_ADDR[0]);
  and gc32 (wc31, wc32, \OUT_W1[1] , W_ADDR[0]);
  not gc31 (wc32, W_ADDR[1]);
  or g346 (OUT_M[1], n_840, wc34, wc37);
  and gc38 (wc37, wc38, \OUT_W2[1] , W_ADDR[1]);
  not gc37 (wc38, W_ADDR[0]);
  and gc36 (wc34, wc35, wc36, \OUT_W0[1] );
  not gc35 (wc36, W_ADDR[1]);
  not gc34 (wc35, W_ADDR[0]);
  or g366 (n_860, wc39, wc41);
  and gc41 (wc41, \OUT_W3[0] , W_ADDR[1], W_ADDR[0]);
  and gc40 (wc39, wc40, \OUT_W1[0] , W_ADDR[0]);
  not gc39 (wc40, W_ADDR[1]);
  or g367 (OUT_M[0], n_860, wc42, wc45);
  and gc46 (wc45, wc46, \OUT_W2[0] , W_ADDR[1]);
  not gc45 (wc46, W_ADDR[0]);
  and gc44 (wc42, wc43, wc44, \OUT_W0[0] );
  not gc43 (wc44, W_ADDR[1]);
  not gc42 (wc43, W_ADDR[0]);
endmodule






// Library - FIFO64X22_13OCT, Cell - array_32x14, View - schematic
// LAST TIME SAVED: Oct 31 21:16:52 2010
// NETLIST TIME: Nov  4 12:55:34 2010
`timescale 1ns / 1ns 

module array_32x14 ( OUTB_3_0, OUTB_7_4, OUTB_11_8, OUTB_15_12,
     OUTB_19_16, OUTB_23_20, OUTB_27_24, OUTB_31_28, CLK, EN, IN_W0, RST_L,
     W_ADDR_3_0, W_ADDR_7_4, W_ADDR_11_8, W_ADDR_15_12, W_ADDR_19_16,
     W_ADDR_23_20, W_ADDR_27_24, W_ADDR_31_28);



input  CLK, RST_L;

output [13:0]  OUTB_31_28;
output [13:0]  OUTB_27_24;
output [13:0]  OUTB_7_4;
output [13:0]  OUTB_3_0;
output [13:0]  OUTB_19_16;
output [13:0]  OUTB_23_20;
output [13:0]  OUTB_15_12;
output [13:0]  OUTB_11_8;

input [1:0]  W_ADDR_31_28;
input [1:0]  W_ADDR_27_24;
input [1:0]  W_ADDR_23_20;
input [1:0]  W_ADDR_19_16;
input [1:0]  W_ADDR_15_12;
input [1:0]  W_ADDR_11_8;
input [1:0]  W_ADDR_3_0;
input [1:0]  W_ADDR_7_4;
input [31:0]  EN;
input [13:0]  IN_W0;




array_4x2  I15 ( .W_ADDR(W_ADDR_23_20[1:0]),
     .OUT_M(OUTB_23_20[13:12]), .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]),
     .IN_W2(IN_W0[13:12]), .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I18 ( .W_ADDR(W_ADDR_19_16[1:0]),
     .OUT_M(OUTB_19_16[13:12]), .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]),
     .IN_W2(IN_W0[13:12]), .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I46 ( .W_ADDR(W_ADDR_27_24[1:0]),
     .OUT_M(OUTB_27_24[13:12]), .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]),
     .IN_W2(IN_W0[13:12]), .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I40 ( .W_ADDR(W_ADDR_31_28[1:0]),
     .OUT_M(OUTB_31_28[13:12]), .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]),
     .IN_W2(IN_W0[13:12]), .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I22 ( .W_ADDR(W_ADDR_15_12[1:0]),
     .OUT_M(OUTB_15_12[13:12]), .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]),
     .IN_W2(IN_W0[13:12]), .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I7 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[13:12]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]), .IN_W2(IN_W0[13:12]),
     .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I4 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[13:12]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W0(IN_W0[13:12]), .IN_W1(IN_W0[13:12]), .IN_W2(IN_W0[13:12]),
     .IN_W3(IN_W0[13:12]), .CLK(CLK));
array_4x2  I97 ( .IN_W1(IN_W0[13:12]), .IN_W2(IN_W0[13:12]),
     .IN_W0(IN_W0[13:12]), .CLK(CLK), .IN_W3(IN_W0[13:12]),
     .OUT_M(OUTB_3_0[13:12]), .EN(EN[3:0]), .RST_L(RST_L),  .W_ADDR(W_ADDR_3_0[1:0]));
array_4x4  I21 ( .OUT_M(OUTB_23_20[3:0]), .W_ADDR(W_ADDR_23_20[1:0]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I13 ( .OUT_M(OUTB_19_16[3:0]), .W_ADDR(W_ADDR_19_16[1:0]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I37 ( .OUT_M(OUTB_27_24[3:0]), .W_ADDR(W_ADDR_27_24[1:0]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I17 ( .OUT_M(OUTB_23_20[7:4]), .W_ADDR(W_ADDR_23_20[1:0]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I23 ( .OUT_M(OUTB_19_16[7:4]), .W_ADDR(W_ADDR_19_16[1:0]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I34 ( .OUT_M(OUTB_27_24[7:4]), .W_ADDR(W_ADDR_27_24[1:0]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I19 ( .OUT_M(OUTB_23_20[11:8]), .W_ADDR(W_ADDR_23_20[1:0]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I20 ( .OUT_M(OUTB_19_16[11:8]), .W_ADDR(W_ADDR_19_16[1:0]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I31 ( .OUT_M(OUTB_27_24[11:8]), .W_ADDR(W_ADDR_27_24[1:0]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I43 ( .OUT_M(OUTB_31_28[11:8]), .W_ADDR(W_ADDR_31_28[1:0]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I47 ( .OUT_M(OUTB_31_28[7:4]), .W_ADDR(W_ADDR_31_28[1:0]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I32 ( .OUT_M(OUTB_31_28[3:0]), .W_ADDR(W_ADDR_31_28[1:0]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I16 ( .OUT_M(OUTB_15_12[3:0]), .W_ADDR(W_ADDR_15_12[1:0]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I10 ( .OUT_M(OUTB_11_8[3:0]), .W_ADDR(W_ADDR_11_8[1:0]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I14 ( .OUT_M(OUTB_15_12[7:4]), .W_ADDR(W_ADDR_15_12[1:0]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I9 ( .OUT_M(OUTB_11_8[7:4]), .W_ADDR(W_ADDR_11_8[1:0]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I12 ( .OUT_M(OUTB_15_12[11:8]), .W_ADDR(W_ADDR_15_12[1:0]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I8 ( .OUT_M(OUTB_11_8[11:8]), .W_ADDR(W_ADDR_11_8[1:0]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I6 ( .OUT_M(OUTB_7_4[3:0]), .W_ADDR(W_ADDR_7_4[1:0]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I11 ( .OUT_M(OUTB_7_4[7:4]), .W_ADDR(W_ADDR_7_4[1:0]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I3 ( .OUT_M(OUTB_7_4[11:8]), .W_ADDR(W_ADDR_7_4[1:0]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I1 ( .OUT_M(OUTB_3_0[7:4]), .W_ADDR(W_ADDR_3_0[1:0]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I2 ( .OUT_M(OUTB_3_0[3:0]), .W_ADDR(W_ADDR_3_0[1:0]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I0 ( .OUT_M(OUTB_3_0[11:8]), .W_ADDR(W_ADDR_3_0[1:0]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));

endmodule
