module array_32x18 ( OUTB_3_0, OUTB_7_4, OUTB_11_8, OUTB_15_12,
     OUTB_19_16, OUTB_23_20, OUTB_27_24, OUTB_31_28, CLK, EN, IN_W0, RST_L,
     W_ADDR_3_0, W_ADDR_7_4, W_ADDR_11_8, W_ADDR_15_12, W_ADDR_19_16,
     W_ADDR_23_20, W_ADDR_27_24, W_ADDR_31_28);




input  CLK, RST_L;


output [17:0]  OUTB_11_8;
output [17:0]  OUTB_7_4;
output [17:0]  OUTB_31_28;
output [17:0]  OUTB_23_20;
output [17:0]  OUTB_3_0;
output [17:0]  OUTB_15_12;
output [17:0]  OUTB_27_24;
output [17:0]  OUTB_19_16;


input [1:0]  W_ADDR_31_28;
input [1:0]  W_ADDR_27_24;
input [1:0]  W_ADDR_23_20;
input [1:0]  W_ADDR_19_16;
input [1:0]  W_ADDR_15_12;
input [1:0]  W_ADDR_11_8;
input [1:0]  W_ADDR_3_0;
input [1:0]  W_ADDR_7_4;
input [17:0]  IN_W0;
input [31:0]  EN;






array_4x2  I31 ( .W_ADDR(W_ADDR_23_20[1:0]),
     .OUT_M(OUTB_23_20[17:16]),  .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]),
     .IN_W2(IN_W0[17:16]), .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I15 ( .W_ADDR(W_ADDR_19_16[1:0]),
     .OUT_M(OUTB_19_16[17:16]),  .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]),
     .IN_W2(IN_W0[17:16]), .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I47 ( .W_ADDR(W_ADDR_27_24[1:0]),
     .OUT_M(OUTB_27_24[17:16]),  .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]),
     .IN_W2(IN_W0[17:16]), .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I44 ( .W_ADDR(W_ADDR_31_28[1:0]),
     .OUT_M(OUTB_31_28[17:16]),  .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]),
     .IN_W2(IN_W0[17:16]), .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I16 ( .W_ADDR(W_ADDR_15_12[1:0]),
     .OUT_M(OUTB_15_12[17:16]),  .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]),
     .IN_W2(IN_W0[17:16]), .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I9 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[17:16]),
      .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]), .IN_W2(IN_W0[17:16]),
     .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I3 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[17:16]),
      .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W0(IN_W0[17:16]), .IN_W1(IN_W0[17:16]), .IN_W2(IN_W0[17:16]),
     .IN_W3(IN_W0[17:16]), .CLK(CLK));
array_4x2  I97  ( .IN_W1(IN_W0[17:16]), .IN_W2(IN_W0[17:16]),
     .IN_W0(IN_W0[17:16]), .CLK(CLK), .IN_W3(IN_W0[17:16]),
     .OUT_M(OUTB_3_0[17:16]), .EN(EN[3:0]), .RST_L(RST_L),  .W_ADDR(W_ADDR_3_0[1:0]));
array_4x4  I43 ( .OUT_M(OUTB_23_20[3:0]), .W_ADDR(W_ADDR_23_20[1:0]),
      .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I46 ( .OUT_M(OUTB_19_16[3:0]), .W_ADDR(W_ADDR_19_16[1:0]),
      .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I41 ( .OUT_M(OUTB_27_24[3:0]), .W_ADDR(W_ADDR_27_24[1:0]),
      .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I40 ( .OUT_M(OUTB_23_20[7:4]), .W_ADDR(W_ADDR_23_20[1:0]),
      .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I21 ( .OUT_M(OUTB_19_16[7:4]), .W_ADDR(W_ADDR_19_16[1:0]),
      .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I38 ( .OUT_M(OUTB_27_24[7:4]), .W_ADDR(W_ADDR_27_24[1:0]),
      .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4   I37 ( .OUT_M(OUTB_23_20[11:8]), .W_ADDR(W_ADDR_23_20[1:0]),
      .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I17 ( .OUT_M(OUTB_19_16[11:8]), .W_ADDR(W_ADDR_19_16[1:0]),
      .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I35 ( .OUT_M(OUTB_27_24[11:8]), .W_ADDR(W_ADDR_27_24[1:0]),
      .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I34 ( .OUT_M(OUTB_23_20[15:12]),
     .W_ADDR(W_ADDR_23_20[1:0]),  .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I19 ( .OUT_M(OUTB_19_16[15:12]),
     .W_ADDR(W_ADDR_19_16[1:0]),  .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I32 ( .OUT_M(OUTB_27_24[15:12]),
     .W_ADDR(W_ADDR_27_24[1:0]),  .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I45 ( .OUT_M(OUTB_31_28[15:12]),
     .W_ADDR(W_ADDR_31_28[1:0]),  .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I30 ( .OUT_M(OUTB_31_28[11:8]), .W_ADDR(W_ADDR_31_28[1:0]),
      .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I33 ( .OUT_M(OUTB_31_28[7:4]), .W_ADDR(W_ADDR_31_28[1:0]),
      .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I36 ( .OUT_M(OUTB_31_28[3:0]), .W_ADDR(W_ADDR_31_28[1:0]),
      .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I13 ( .OUT_M(OUTB_15_12[3:0]), .W_ADDR(W_ADDR_15_12[1:0]),
      .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I14 ( .OUT_M(OUTB_11_8[3:0]), .W_ADDR(W_ADDR_11_8[1:0]),
      .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I23 ( .OUT_M(OUTB_15_12[7:4]), .W_ADDR(W_ADDR_15_12[1:0]),
      .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I12 ( .OUT_M(OUTB_11_8[7:4]), .W_ADDR(W_ADDR_11_8[1:0]),
      .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I20 ( .OUT_M(OUTB_15_12[11:8]), .W_ADDR(W_ADDR_15_12[1:0]),
      .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I22 ( .OUT_M(OUTB_11_8[11:8]), .W_ADDR(W_ADDR_11_8[1:0]),
      .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4   I18 ( .OUT_M(OUTB_15_12[15:12]),
     .W_ADDR(W_ADDR_15_12[1:0]),  .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I10 ( .OUT_M(OUTB_11_8[15:12]), .W_ADDR(W_ADDR_11_8[1:0]),
      .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I8 ( .OUT_M(OUTB_7_4[3:0]), .W_ADDR(W_ADDR_7_4[1:0]),
      .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I7 ( .OUT_M(OUTB_7_4[7:4]), .W_ADDR(W_ADDR_7_4[1:0]),
      .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I6 ( .OUT_M(OUTB_7_4[11:8]), .W_ADDR(W_ADDR_7_4[1:0]),
      .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I11 ( .OUT_M(OUTB_7_4[15:12]), .W_ADDR(W_ADDR_7_4[1:0]),
      .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I2 ( .OUT_M(OUTB_3_0[7:4]), .W_ADDR(W_ADDR_3_0[1:0]),
      .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I4 ( .OUT_M(OUTB_3_0[3:0]), .W_ADDR(W_ADDR_3_0[1:0]),
      .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I1 ( .OUT_M(OUTB_3_0[11:8]), .W_ADDR(W_ADDR_3_0[1:0]),
      .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I0 ( .OUT_M(OUTB_3_0[15:12]), .W_ADDR(W_ADDR_3_0[1:0]),
      .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));

endmodule
