module array_32x22 ( OUTB_3_0, OUTB_7_4, OUTB_11_8, OUTB_15_12,
     OUTB_19_16, OUTB_23_20, OUTB_27_24, OUTB_31_28, CLK, EN, IN_W0, RST_L,
     W_ADDR_3_0, W_ADDR_7_4, W_ADDR_11_8, W_ADDR_15_12, W_ADDR_19_16,
     W_ADDR_23_20, W_ADDR_27_24, W_ADDR_31_28 );



input  CLK, RST_L;

output [21:0]  OUTB_15_12;
output [21:0]  OUTB_11_8;
output [21:0]  OUTB_23_20;
output [21:0]  OUTB_27_24;
output [21:0]  OUTB_3_0;
output [21:0]  OUTB_7_4;
output [21:0]  OUTB_31_28;
output [21:0]  OUTB_19_16;

input [1:0]  W_ADDR_31_28;
input [1:0]  W_ADDR_27_24;
input [1:0]  W_ADDR_23_20;
input [1:0]  W_ADDR_19_16;
input [1:0]  W_ADDR_15_12;
input [1:0]  W_ADDR_11_8;
input [1:0]  W_ADDR_3_0;
input [1:0]  W_ADDR_7_4;
input [31:0]  EN;
input [21:0]  IN_W0;





array_4x2  I47 ( .W_ADDR(W_ADDR_23_20[1:0]),
     .OUT_M(OUTB_23_20[21:20]), .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W2(IN_W0[21:20]), .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I46 ( .W_ADDR(W_ADDR_19_16[1:0]),
     .OUT_M(OUTB_19_16[21:20]), .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W2(IN_W0[21:20]), .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I45 ( .W_ADDR(W_ADDR_27_24[1:0]),
     .OUT_M(OUTB_27_24[21:20]), .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W2(IN_W0[21:20]), .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I29 ( .W_ADDR(W_ADDR_31_28[1:0]),
     .OUT_M(OUTB_31_28[21:20]), .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W2(IN_W0[21:20]), .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I23 ( .W_ADDR(W_ADDR_15_12[1:0]),
     .OUT_M(OUTB_15_12[21:20]), .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W2(IN_W0[21:20]), .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I22 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[21:20]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]), .IN_W2(IN_W0[21:20]),
     .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I11 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[21:20]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W0(IN_W0[21:20]), .IN_W1(IN_W0[21:20]), .IN_W2(IN_W0[21:20]),
     .IN_W3(IN_W0[21:20]), .CLK(CLK));
array_4x2  I97 ( .W_ADDR(W_ADDR_3_0[1:0]), .EN(EN[3:0]),
     .RST_L(RST_L), .OUT_M(OUTB_3_0[21:20]),
     .IN_W3(IN_W0[21:20]), .IN_W2(IN_W0[21:20]), .IN_W1(IN_W0[21:20]),
     .IN_W0(IN_W0[21:20]), .CLK(CLK));
array_4x4  I44 ( .W_ADDR(W_ADDR_23_20[1:0]), .OUT_M(OUTB_23_20[3:0]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I43 ( .W_ADDR(W_ADDR_19_16[1:0]), .OUT_M(OUTB_19_16[3:0]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I42 ( .W_ADDR(W_ADDR_27_24[1:0]), .OUT_M(OUTB_27_24[3:0]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I41 ( .W_ADDR(W_ADDR_23_20[1:0]), .OUT_M(OUTB_23_20[7:4]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I40 ( .W_ADDR(W_ADDR_19_16[1:0]), .OUT_M(OUTB_19_16[7:4]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I39 ( .W_ADDR(W_ADDR_27_24[1:0]), .OUT_M(OUTB_27_24[7:4]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I38 ( .W_ADDR(W_ADDR_23_20[1:0]), .OUT_M(OUTB_23_20[11:8]),
     .EN(EN[23:20]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I37 ( .W_ADDR(W_ADDR_19_16[1:0]), .OUT_M(OUTB_19_16[11:8]),
     .EN(EN[19:16]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I36 ( .W_ADDR(W_ADDR_27_24[1:0]), .OUT_M(OUTB_27_24[11:8]),
     .EN(EN[27:24]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I35 ( .W_ADDR(W_ADDR_23_20[1:0]),
     .OUT_M(OUTB_23_20[15:12]), .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I34 ( .W_ADDR(W_ADDR_19_16[1:0]),
     .OUT_M(OUTB_19_16[15:12]), .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I33 ( .W_ADDR(W_ADDR_27_24[1:0]),
     .OUT_M(OUTB_27_24[15:12]), .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I32 ( .W_ADDR(W_ADDR_23_20[1:0]),
     .OUT_M(OUTB_23_20[19:16]), .EN(EN[23:20]),
     .RST_L(RST_L), .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]),
     .IN_W1(IN_W0[19:16]), .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I31 ( .W_ADDR(W_ADDR_19_16[1:0]),
     .OUT_M(OUTB_19_16[19:16]), .EN(EN[19:16]),
     .RST_L(RST_L), .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]),
     .IN_W1(IN_W0[19:16]), .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I30 ( .W_ADDR(W_ADDR_27_24[1:0]),
     .OUT_M(OUTB_27_24[19:16]), .EN(EN[27:24]),
     .RST_L(RST_L), .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]),
     .IN_W1(IN_W0[19:16]), .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I28 ( .W_ADDR(W_ADDR_31_28[1:0]),
     .OUT_M(OUTB_31_28[15:12]), .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I27 ( .W_ADDR(W_ADDR_31_28[1:0]), .OUT_M(OUTB_31_28[11:8]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I26 ( .W_ADDR(W_ADDR_31_28[1:0]), .OUT_M(OUTB_31_28[7:4]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I25 ( .W_ADDR(W_ADDR_31_28[1:0]), .OUT_M(OUTB_31_28[3:0]),
     .EN(EN[31:28]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I24 ( .W_ADDR(W_ADDR_31_28[1:0]),
     .OUT_M(OUTB_31_28[19:16]), .EN(EN[31:28]),
     .RST_L(RST_L), .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]),
     .IN_W1(IN_W0[19:16]), .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I21 ( .W_ADDR(W_ADDR_15_12[1:0]), .OUT_M(OUTB_15_12[3:0]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I20 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[3:0]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I19 ( .W_ADDR(W_ADDR_15_12[1:0]), .OUT_M(OUTB_15_12[7:4]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I18 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[7:4]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I17 ( .W_ADDR(W_ADDR_15_12[1:0]), .OUT_M(OUTB_15_12[11:8]),
     .EN(EN[15:12]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I16 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[11:8]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I15 ( .W_ADDR(W_ADDR_15_12[1:0]),
     .OUT_M(OUTB_15_12[15:12]), .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]),
     .IN_W1(IN_W0[15:12]), .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I14 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[15:12]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I13 ( .W_ADDR(W_ADDR_15_12[1:0]),
     .OUT_M(OUTB_15_12[19:16]), .EN(EN[15:12]),
     .RST_L(RST_L), .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]),
     .IN_W1(IN_W0[19:16]), .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I12 ( .W_ADDR(W_ADDR_11_8[1:0]), .OUT_M(OUTB_11_8[19:16]),
     .EN(EN[11:8]), .RST_L(RST_L),
     .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]), .IN_W1(IN_W0[19:16]),
     .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I10 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[3:0]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I9 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[7:4]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I8 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[11:8]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I7 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[15:12]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I6 ( .W_ADDR(W_ADDR_7_4[1:0]), .OUT_M(OUTB_7_4[19:16]),
     .EN(EN[7:4]), .RST_L(RST_L),
     .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]), .IN_W1(IN_W0[19:16]),
     .IN_W0(IN_W0[19:16]), .CLK(CLK));
array_4x4  I4 ( .W_ADDR(W_ADDR_3_0[1:0]), .OUT_M(OUTB_3_0[7:4]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[7:4]), .IN_W2(IN_W0[7:4]), .IN_W1(IN_W0[7:4]),
     .IN_W0(IN_W0[7:4]), .CLK(CLK));
array_4x4  I3 ( .W_ADDR(W_ADDR_3_0[1:0]), .OUT_M(OUTB_3_0[3:0]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[3:0]), .IN_W2(IN_W0[3:0]), .IN_W1(IN_W0[3:0]),
     .IN_W0(IN_W0[3:0]), .CLK(CLK));
array_4x4  I2 ( .W_ADDR(W_ADDR_3_0[1:0]), .OUT_M(OUTB_3_0[11:8]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[11:8]), .IN_W2(IN_W0[11:8]), .IN_W1(IN_W0[11:8]),
     .IN_W0(IN_W0[11:8]), .CLK(CLK));
array_4x4  I1 ( .W_ADDR(W_ADDR_3_0[1:0]), .OUT_M(OUTB_3_0[15:12]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[15:12]), .IN_W2(IN_W0[15:12]), .IN_W1(IN_W0[15:12]),
     .IN_W0(IN_W0[15:12]), .CLK(CLK));
array_4x4  I0 ( .W_ADDR(W_ADDR_3_0[1:0]), .OUT_M(OUTB_3_0[19:16]),
     .EN(EN[3:0]), .RST_L(RST_L),
     .IN_W3(IN_W0[19:16]), .IN_W2(IN_W0[19:16]), .IN_W1(IN_W0[19:16]),
     .IN_W0(IN_W0[19:16]), .CLK(CLK));

endmodule
