-------------------------------------------------------------------------------
--
-- Title       : No Title
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--
-------------------------------------------------------------------------------
--
-- File        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\compile\Des_Control.vhd
-- Generated   : 07/04/10 20:43:08
-- From        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\src\Des_Control.asf
-- By          : FSM2VHDL ver. 5.0.7.2
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use work.interfaces_pkg.all;
entity Des_Control_RHSEU is 
	port (
		clk: in STD_LOGIC;
		countB: in STD_LOGIC_VECTOR (N_WORD_b-1 downto 0);
		HDR: in STD_LOGIC;
		rst_L: in STD_LOGIC;
		FDC_rcv: out STD_LOGIC;
		rst_BCNT_L: out STD_LOGIC;
		sel_shr: out STD_LOGIC;
		seu : out STD_LOGIC
		);
end Des_Control_RHSEU;

architecture Des_Control1 of Des_Control_RHSEU is

-- diagram signals declarations
signal FDC_END: BOOLEAN;
signal W_END: BOOLEAN;

-- BINARY ENCODED state machine: DES_CTRL_Sreg0
subtype DES_CTRL_Sreg0_type is STD_LOGIC_VECTOR (0 to 2);
constant IDLE: DES_CTRL_Sreg0_type := "000";
constant WORD1: DES_CTRL_Sreg0_type := "001";
constant FDC0: DES_CTRL_Sreg0_type := "010";
constant FDC1: DES_CTRL_Sreg0_type := "011";
constant WORD0: DES_CTRL_Sreg0_type := "100";
-- attribute enum_encoding of DES_CTRL_Sreg0_type: type is ... -- enum_encoding attribute is not supported for state register defined by using subtype keyword

signal next_state, current_state_a, current_state_b, current_state_c, current_state_corr: DES_CTRL_Sreg0_type;
signal status :  STD_LOGIC_VECTOR(2 downto 0);
signal FDC_rcv_int : STD_LOGIC;
signal FDC_rcv_sig:  STD_LOGIC_VECTOR(0 to 2); 
signal sel_shr_int : STD_LOGIC;
signal sel_shr_sig:  STD_LOGIC_VECTOR(0 to 2);
signal corr_data_FDC_rcv : STD_LOGIC;
signal corr_data_sel_shr : STD_LOGIC;
signal a_eq_b: std_logic;
signal b_eq_c : std_logic; 
signal a_eq_c : std_logic;	
signal seu_states : std_logic;	
signal seu_FDC_rcv : std_logic;	 
signal seu_sel_shr : std_logic;

begin

-- concurrent signals assignments

FDC_END <= (countB = CONV_STD_LOGIC_VECTOR(N_FDC-1, N_WORD_b));
W_END <= (countB = CONV_STD_LOGIC_VECTOR(N_WORD-1, N_WORD_b));

----------------------------------------------------------------------
-- Machine: DES_CTRL_Sreg0
----------------------------------------------------------------------
fsm_state: process (clk)
begin
	if rising_edge(clk) then 
		if rst_L = '0' then	
			current_state_a <= IDLE;
			current_state_b <= IDLE;
			current_state_c <= IDLE;
		
		for i in 0 to 2 loop
			FDC_rcv_sig(i) <= '0';	  
			sel_shr_sig(i) <= '0';
		end loop; 
		
		else	 
			current_state_a <= next_state;
			current_state_b <= next_state;
			current_state_c <= next_state;
			
		for i in 0 to 2 loop
			FDC_rcv_sig(i) <= FDC_rcv_int; 
			sel_shr_sig(i) <= sel_shr_int;

		end loop;
			
		end if;
	end if;
end process; 

fsm_comb_logic: process (current_state_corr, HDR, W_END, FDC_END )
begin
			case current_state_corr is
				when IDLE =>
					if HDR = '1' then	
						next_state <= FDC0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '1';
					else	
						next_state  <= IDLE;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
					end if;
				when WORD1 =>
					if (W_END) AND (HDR = '0') then	
						next_state <= WORD0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
					elsif HDR = '1' then	
						next_state <= FDC1;
						sel_shr_int <= '1';
						FDC_rcv_int <= '1';
					else
						next_state <= WORD1;
						sel_shr_int <= '1';
						FDC_rcv_int <= '0';
					end if;
                    
				when FDC0 =>
					if FDC_END then	
						next_state <= WORD1;
						sel_shr_int <= '1';
						FDC_rcv_int <= '0';
					else
						next_state <= FDC0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '1';
					end if;
                    
				when FDC1 =>
					if NOT(FDC_END) then	
						next_state <= FDC1;
						sel_shr_int <= '1';
						FDC_rcv_int <= '1';
					else
						next_state <= WORD0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
					end if;
                    
				when WORD0 =>
					if (W_END) AND (HDR = '0') then	
						next_state <= WORD1;
						sel_shr_int <= '1';
						FDC_rcv_int <= '0';
					elsif HDR = '1' then	
						next_state <= FDC0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
					else
						next_state <= WORD0;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
					end if;
--vhdl_cover_off
				when others =>
						next_state  <= IDLE;
						sel_shr_int <= '0';
						FDC_rcv_int <= '0';
--vhdl_cover_on
			end case;
		
end process;   



  process (current_state_a, current_state_b, current_state_c)
	begin
        
		if (current_state_a = current_state_b) then
			a_eq_b <= '1';
		else
			a_eq_b <= '0';
		end if;
			
		if (current_state_a = current_state_c) then
			a_eq_c <= '1';
		else
			a_eq_c <= '0';
		end if;
				
		if (current_state_b = current_state_c) then
			b_eq_c <= '1';
		else
			b_eq_c <= '0';
		end if;
  end process;
  
  status <= a_eq_b & a_eq_c & b_eq_c;
  
  process (status, current_state_a, current_state_b)
    begin
		case (status) is 
			when "111" =>     			--All equal
				current_state_corr <= current_state_a; 
				seu_states <= '0'; 
			when "100" =>    			--c different
				current_state_corr <= current_state_a; 
				seu_states <= '1'; 
			when "010" => 				--b different
				current_state_corr <= current_state_a;
				seu_states <= '1'; 
			when "001" => 				--a different
				current_state_corr <= current_state_b;
				seu_states <= '1'; 
			when others => 			  -- errors in majority logic	
				current_state_corr <= IDLE;
				seu_states <= '1'; 
		end case;
	end process;
    
majority_logic_FDC_rcv: process (FDC_rcv_sig)
	begin
		case (FDC_rcv_sig) is

			-- data = 0 - NO SEU
			when "000" => 	corr_data_FDC_rcv <= '0';  
							seu_FDC_rcv <= '0';	
			
			-- data = 1 - NO SEU
			when "111" => 	corr_data_FDC_rcv <= '1';  
							seu_FDC_rcv <= '0';
			
			-- data = 0 - SEU
			when "100" => 	corr_data_FDC_rcv <= '0';
							seu_FDC_rcv <= '1';	
			when "010" =>	corr_data_FDC_rcv <= '0';
							seu_FDC_rcv <= '1';
			when "001" => 	corr_data_FDC_rcv <= '0';
							seu_FDC_rcv <= '1';
                  
			-- data = 1 - SEU            
			when "110" => 	corr_data_FDC_rcv <= '1';
							seu_FDC_rcv <= '1';
			when "101" => 	corr_data_FDC_rcv <= '1';
							seu_FDC_rcv <= '1';
			when "011" => 	corr_data_FDC_rcv <= '1'; 
							seu_FDC_rcv <= '1';	
			
			when others => 	corr_data_FDC_rcv <= '0';
							seu_FDC_rcv <= '0';
		end case;	                                     
	end process;
	
majority_logic_sel_shr: process (sel_shr_sig)
	begin
		case (sel_shr_sig) is

			-- data = 0 - NO SEU
			when "000" => 	corr_data_sel_shr <= '0';  
							seu_sel_shr <= '0';	
			
			-- data = 1 - NO SEU
			when "111" => 	corr_data_sel_shr <= '1';  
							seu_sel_shr <= '0';
			
			-- data = 0 - SEU
			when "100" => 	corr_data_sel_shr <= '0';
							seu_sel_shr <= '1';	
			when "010" =>	corr_data_sel_shr <= '0';
							seu_sel_shr <= '1';
			when "001" => 	corr_data_sel_shr <= '0';
							seu_sel_shr <= '1';
                  
			-- data = 1 - SEU            
			when "110" => 	corr_data_sel_shr <= '1';
							seu_sel_shr <= '1';
			when "101" => 	corr_data_sel_shr <= '1';
							seu_sel_shr <= '1';
			when "011" => 	corr_data_sel_shr <= '1'; 
							seu_sel_shr <= '1';	
			
			when others => 	corr_data_sel_shr <= '0';
							seu_sel_shr <= '0';
		end case;	                                     
	end process;
	
-- signal assignment statements for combinatorial outputs
rst_BCNT_L_assignment:
rst_BCNT_L <= '1' when (current_state_corr = IDLE and HDR = '1') else
              '0' when (current_state_corr = IDLE and (HDR = '0' and not (HDR = '1'))) else
              '0' when (current_state_corr = IDLE) else
              '1' when (current_state_corr = WORD1 and ((W_END) AND (HDR = '0'))) else
              '0' when (current_state_corr = WORD1 and (HDR = '1' and not ((W_END) AND (HDR = '0')))) else
              '1' when (current_state_corr = WORD1 and ((NOT(W_END)) AND (HDR = '0') and not ((W_END) AND (HDR = '0')) and not (HDR = '1'))) else
              '0' when (current_state_corr = FDC0 and FDC_END) else
              '1' when (current_state_corr = FDC0 and (NOT(FDC_END) and not (FDC_END))) else
              '1' when (current_state_corr = FDC1 and NOT(FDC_END)) else
              '0' when (current_state_corr = FDC1 and (FDC_END and not (NOT(FDC_END)))) else
              '1' when (current_state_corr = WORD0 and ((W_END) AND (HDR = '0'))) else
              '0' when (current_state_corr = WORD0 and (HDR = '1' and not ((W_END) AND (HDR = '0')))) else
              '1' when (current_state_corr = WORD0 and ((NOT(W_END)) AND (HDR = '0') and not ((W_END) AND (HDR = '0')) and not (HDR = '1'))) else
              '0';
			  
seu <= seu_states OR seu_FDC_rcv OR seu_sel_shr; 

sel_shr <= corr_data_sel_shr;
FDC_rcv <= corr_data_FDC_rcv;

end Des_Control1;
