-- FIFO_2216_Encoder

-- Encoder for the FIFO 64*16 bit -- single word


LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE work.fifo_pkg.all;

entity FIFO_09to14_Encoder is
	generic(
      N_BIT_COD : positive ;
      N_BIT_DEC : positive ;
	  N_BIT_PAR : positive 
	  );
	port(
		 FIFO_din : in std_logic_vector(N_BIT_DEC-1 downto 0);
		 FIFO_dout : out STD_LOGIC_VECTOR(N_BIT_COD-1 downto 0)
	     );
end FIFO_09to14_Encoder;


architecture H09_14 of FIFO_09to14_Encoder is	

	signal x : std_logic_vector(1 to N_BIT_DEC); -- message vector 
	signal p : std_logic_vector(1 to N_BIT_PAR); -- vector of parity bits
	
begin  
		
	x(1 to N_BIT_DEC) <= FIFO_din (N_BIT_DEC-1 downto 0);
	
	p(1) <= x(1) XOR x(2) XOR x(4) XOR x(5) XOR x(7) XOR x(9);	
	p(2) <= x(1) XOR x(3) XOR x(4) XOR x(6) XOR x(7);
	p(3) <= x(2) XOR x(3) XOR x(4) XOR x(8) XOR x(9);
	p(4) <= x(5) XOR x(6) XOR x(7) XOR x(8) XOR x(9);
    -- additional overall parity bit
	p(5) <= x(1) XOR x(2) XOR x(3) XOR x(5) XOR x(6) XOR x(8);
	
	
	FIFO_dout(N_BIT_COD - 1 downto N_BIT_PAR) <=  x(1 to N_BIT_DEC);
	FIFO_dout(N_BIT_PAR-1 downto 0) <=  p(1 to N_BIT_PAR);

end H09_14;
