-- Description: Majority Voter

library IEEE;
use IEEE.std_logic_1164.all;


entity maj_voter is	
	port (
		a : in std_logic;
		b : in std_logic;
		c : in std_logic;
		q : out std_logic;
		seu: out std_logic
	);
end entity;

architecture maj_voter_arch of maj_voter is
begin

	process (a,b,c)
	begin
		if (a = b) and (b = c)  then
			q <= a; 
			seu <= '0';
		elsif (a = b) and (c /= b) then
			q <= a; 
			seu <= '1';
		elsif (b = c) and (a /= b) then
			q <= b; 
			seu <= '1'; 
		elsif (a = c) and (b /= a) then
			q <= a; 
			seu <= '1'; 
		else 
			q <= a; 
			seu <= '0';            
		end if;
	end process;

end architecture;
