-------------------------------------------------------------------------------
--
-- Title       : THS_Scheduler
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--
-------------------------------------------------------------------------------
--
-- File        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\compile\THS_Scheduler.vhd
-- Generated   : Sun Jul  4 19:34:21 2010
-- From        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\src\THS_Scheduler.bde
-- By          : Bde2Vhdl ver. 2.6
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------
-- Design unit header --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.math_real.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


-- active library clause
 

entity THS_Scheduler_RHSEU is
  port(
       HDR_in : in STD_LOGIC;
       TRG_in : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       HDR_out : out STD_LOGIC;
       TRG_out : out STD_LOGIC;
	   seu_out : out STD_LOGIC 
  );
end THS_Scheduler_RHSEU;

architecture THS_Scheduler1 of THS_Scheduler_RHSEU is

---- Component declarations -----

component HDR_manager_RHSEU
  port (
       HDR_block : in STD_LOGIC;
       HDR_in : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       HDR_wait : out STD_LOGIC;
	   seu : out STD_LOGIC 
  );
end component;
component TRG_manager_RHSEU
  port (
       TRG_in : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       HDR_block : out STD_LOGIC;
       TRG_out : out STD_LOGIC;
	   seu: out STD_LOGIC
  );
end component;

---- Signal declarations used on the diagram ----

signal HDR1 : STD_LOGIC;
signal HDR_block : STD_LOGIC;
signal HDR_out_int : STD_LOGIC;
signal HDR_wait : STD_LOGIC;
signal TRG_out_int : STD_LOGIC;
signal seu_out_TRG, seu_out_HDR  : STD_LOGIC;  

begin

----  Component instantiations  ----

HDR_MAN : HDR_manager_RHSEU
  port map(
       HDR_block => HDR_block,
       HDR_in => HDR_in,
       HDR_wait => HDR_wait,
       clk => clk,
       rst_L => rst_L,
	   seu => seu_out_HDR
  );

TRG_MAN : TRG_manager_RHSEU
  port map(
       HDR_block => HDR_block,
       TRG_in => TRG_in,
       TRG_out => TRG_out_int,
       clk => clk,
       rst_L => rst_L,
	   seu => seu_out_TRG

  );

HDR_out_int <= not(HDR_block) and HDR1;

HDR1 <= HDR_wait or HDR_in;


---- Terminal assignment ----

    -- Output\buffer terminals
	HDR_out <= HDR_out_int;
	TRG_out <= TRG_out_int;
	seu_out <= seu_out_TRG or seu_out_HDR;

end THS_Scheduler1;
