
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


entity THS_enable_gen_RHSEU is
  port(
       THS : in STD_LOGIC;
       THS_valid : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       THS_enable : out STD_LOGIC;
       seu : out STD_LOGIC
  );
end THS_enable_gen_RHSEU;

architecture THS_enable_gen1 of THS_enable_gen_RHSEU is

---- Component declarations -----

component ffd_RHSEU
  port (
       CLR : in STD_LOGIC;
       D : in STD_LOGIC;
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       Q : out STD_LOGIC;
       QN : out STD_LOGIC;
       seu : out STD_LOGIC
  );
end component;

----     Constants     -----
constant VCC_CONSTANT   : STD_LOGIC := '1';

---- Signal declarations used on the diagram ----

signal FF1_Q : STD_LOGIC;
signal FF2_Q : STD_LOGIC;
signal FF3_QN : STD_LOGIC;
signal NET1322 : STD_LOGIC;
signal NET1635 : STD_LOGIC;
signal NET1645 : STD_LOGIC;
signal VCC : STD_LOGIC;
signal seu_FF1, seu_FF2, seu_FF3 : STD_LOGIC;

begin

----  Component instantiations  ----

FF1 : ffd_RHSEU
  port map(
       CLR => NET1322,
       D => VCC,
       Q => FF1_Q,
       QN => THS_enable,
       clk => clk,
       en => THS,
       seu => seu_FF1
  );

FF2 : ffd_RHSEU
  port map(
       CLR => NET1635,
       D => FF1_Q,
       Q => FF2_Q,
       clk => clk,
       en => THS_valid,
       seu => seu_FF2
  );

FF3 : ffd_RHSEU
  port map(
       CLR => NET1645,
       D => FF2_Q,
       QN => FF3_QN,
       clk => clk,
       en => THS_valid,
       seu => seu_FF3
  );

NET1322 <= FF3_QN and rst_L;

NET1635 <= FF3_QN and rst_L;

NET1645 <= FF3_QN and rst_L;


---- Power , ground assignment ----

VCC <= VCC_CONSTANT;

    seu <= seu_FF1 or seu_FF2 or seu_FF3;

end THS_enable_gen1;
