-------------------------------------------------------------------------------
--
-- Title       : prova
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--
-------------------------------------------------------------------------------
--
-- File        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\compile\THS_load_ctrl.vhd
-- Generated   : Sun Jul  4 19:34:21 2010
-- From        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\src\THS_load_ctrl.bde
-- By          : Bde2Vhdl ver. 2.6
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------
-- Design unit header --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.math_real.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


-- active library clause
 

entity THS_load_ctrl_RHSEU is
  port(
       THS_cmd : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       sel_THS : in STD_LOGIC;
       THS_busy : out STD_LOGIC;
       load_THS : out STD_LOGIC;
	   seu_out : out STD_LOGIC
  );
end THS_load_ctrl_RHSEU;

architecture THS_load_ctrl1 of THS_load_ctrl_RHSEU is

---- Component declarations -----

component Counter_N_RHSEU
  generic(
       N : INTEGER;
       modul : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       count : out STD_LOGIC_VECTOR(N-1 downto 0);
	   seu : out STD_LOGIC
  );
end component;
component ffd_RHSEU
  port (
       CLR : in STD_LOGIC;
       D : in STD_LOGIC;
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       Q : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;

----     Constants     -----
constant VCC_CONSTANT   : STD_LOGIC := '1';

---- Signal declarations used on the diagram ----

signal cnt_en : STD_LOGIC;
signal finish : STD_LOGIC;
signal NET77 : STD_LOGIC;
signal NET96 : STD_LOGIC;
signal THS_busy_int : STD_LOGIC;
signal VCC : STD_LOGIC;
signal count : STD_LOGIC_VECTOR (N_THS_b-1 downto 0);
signal seu_out_CNT , seu_out_DFF : STD_LOGIC;


begin

---- User Signal Assignments ----
finish <= '0' when count = CONV_STD_LOGIC_VECTOR(N_THS-1, N_THS_b) else '1';

----  Component instantiations  ----

CNT : Counter_N_RHSEU
  generic map (
       N => N_THS_b,
       modul => N_THS
  )
  port map(
       clk => clk,
       count => count( N_THS_b-1 downto 0 ),
       en => cnt_en,
       rst_L => NET96,
	   seu => seu_out_CNT
  );

DFF : ffd_RHSEU
  port map(
       CLR => NET77,
       D => VCC,
       Q => THS_busy_int,
       clk => clk,
       en => THS_cmd,
	   seu => seu_out_DFF
  );

cnt_en <= sel_THS and THS_busy_int;

load_THS <= not(THS_busy_int) and THS_cmd;

NET77 <= rst_L and finish;

NET96 <= rst_L and finish;


---- Power , ground assignment ----

VCC <= VCC_CONSTANT;

---- Terminal assignment ----

    -- Output\buffer terminals
	THS_busy <= THS_busy_int;
	
	seu_out <= seu_out_DFF OR seu_out_CNT;


end THS_load_ctrl1;
