-------------------------------------------------------------------------------
-- des_timing_4b_6b_8x_RHSEU
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;


entity des_timing_4b_6b_8x_RHSEU is
  port(
       clk : in STD_LOGIC; -- 8x clk
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       sel_THS : in STD_LOGIC;
       pause_BCNT : out STD_LOGIC; -- pause signal for the Bit Counter
       shift_en_SHR : out STD_LOGIC; -- shift enable for SHR0 and SHR1
	   seu_out : out STD_LOGIC
  );
end des_timing_4b_6b_8x_RHSEU;

architecture des_timing_4b_6b_8x_RHSEU_1 of des_timing_4b_6b_8x_RHSEU is

component Counter_N_RHSEU
  generic(
       N : INTEGER;
       modul : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       count : out STD_LOGIC_VECTOR(N-1 downto 0);
	   seu : out STD_LOGIC
  );
end component;

signal CNT_rst_L : STD_LOGIC;
signal count : STD_LOGIC_VECTOR (2 downto 0);

signal seu_out_CNT : STD_LOGIC;


begin
    
  CNT_rst_L <= NOT sel_THS;
   
  CNT : Counter_N_RHSEU
    generic map (
         N => 3,
         modul => 0
    )
    port map(
         clk => clk,
         count => count,
         en => '1',
         rst_L => CNT_rst_L,
         seu => seu_out_CNT
    );
  
  pause_BCNT <= '1' when ((count = "000") OR (count = "001")) else '0';
  shift_en_SHR <= '1' when ((count = "000") AND (sel_THS = '1')) else '0';
  
  seu_out <= seu_out_CNT;

end des_timing_4b_6b_8x_RHSEU_1;
