
library IEEE;
use IEEE.std_logic_1164.all;

entity ffd_RHSEU is
	port (
		CLR : in std_logic; -- active low reset
		en : in std_logic; -- en command
		clk : in std_logic;
		D : in std_logic;
		Q : out std_logic;
		QN : out std_logic;
		seu: out std_logic
	);
end entity;

architecture ffd1 of ffd_RHSEU is
	signal reg : std_logic_vector(2 downto 0);
	signal maj_out : std_logic;  

	component maj_voter 
		port (  a : in std_logic;
				b : in std_logic;
				c : in std_logic;
				q : out std_logic;
				seu: out std_logic
				);  
	end component;

begin 
	
    process (clk)
	begin
			if rising_edge(clk) then
				if (CLR = '0') then
					reg <= (others => '0');
				else
                  if (en = '1') then
                      reg <= (others => D);
                  else
                      reg <= (others => maj_out);
                  end if;
				end if;
			end if;
	end process;
	      
	maj_vot: maj_voter PORT MAP (reg(0), reg(1), reg(2), maj_out, seu);		
	
    Q <= maj_out;					 
	QN <= not maj_out;
    
end ffd1;
