-- Hamming (7,3) encoder (SECDED)
--
--


LIBRARY IEEE;
USE IEEE.std_logic_1164.all;


entity hamming_7_3_encoder is
	 port(
		 word_in  : in std_logic_vector(2 downto 0);
		 word_enc : out std_logic_vector(6 downto 0)
	     );
end hamming_7_3_encoder;


architecture arch1 of hamming_7_3_encoder is 

	signal x : std_logic_vector(1 to 3); -- message vector
	signal p : std_logic_vector(1 to 4); -- vector of parity bits
	
begin  
		
	x(1 to 3) <= word_in(2 downto 0);
	
	p(1) <= x(1) XOR x(2);	
	p(2) <= x(1) XOR x(3);
	p(3) <= x(2) XOR x(3);
	p(4) <= x(1) XOR x(2) XOR x(3);
	
	word_enc(6 downto 4) <=  x(1 to 3);
	word_enc(3 downto 0) <=  p(1 to 4);

end arch1;
