-- package of types and functions for interfaces_project

LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

package interfaces_pkg is 
	
	type in_mode_type is (s,p);
	type THS_type is (TRG, HDR, SYN, '0'); -- type used to visualize the content of the THS channel
	
	constant N_DL_TX : positive:= 16;  -- n of bits of DL_TX input data (one word)
	constant N_THS : positive := 6; -- number of bits of THS sequences
	constant N_THS_b : positive := 3; -- must be equal or greater than the base 2 logaritm of N_THS
	constant N_WORD : positive := 16; -- number of bits of one word = num. of FRM bits in the shift registers of the serializer/deserializer
	constant N_WORD_b : positive := 4; -- must be equal or greater than the base 2 logaritm of N_WORD
	constant N_FDC : positive := 12; -- number of bits of coded FD
	constant N_FD : positive := 7; -- number of bits of FD field
	constant N_FL : positive := 4; -- number of bits of FL field
	constant N_FLpwr : positive := 16; -- = 2^N_FL
	
	constant clk40_period: time := 25 ns; 
	constant clk160_period: time := 6.25 ns;
	constant clk320_period: time := 3.125 ns;
	constant clk640_period: time := 1.5625 ns;
	constant clk100_period: time := 10 ns;
	
	constant clk_period: time := 6.25 ns;
	constant prop_delay: time := clk320_period/10; -- propagation delay of flip-flops
	constant pulse_length : time := clk_period/10; -- duration of flag set/reset pulses
		 
	
END interfaces_pkg;

package body interfaces_pkg is

	
END interfaces_pkg;