-- mux4_Nbit
--
-- 4-input, N-bit multiplexer

library IEEE;
use IEEE.std_logic_1164.all;


entity mux4_Nbit is	
	generic (N : integer);
	port (
		x0 : in std_logic_vector (N-1 downto 0);
		x1 : in std_logic_vector (N-1 downto 0);
		x2 : in std_logic_vector (N-1 downto 0);
		x3 : in std_logic_vector (N-1 downto 0);
		sel : in std_logic_vector (1 downto 0);
		z : out std_logic_vector (N-1 downto 0)
	);
end entity;

architecture mux4_Nbit_arch of mux4_Nbit is
begin

	process (sel, x0, x1, x2, x3)
	begin 
		case sel is
			when "00" => z <= x0;
			when "01" => z <= x1;
			when "10" => z <= x2;
			when "11" => z <= x3;
			when others => NULL;
		end case;
	end process;

end architecture;
