-------------------------------------------------------------------------------
--
-- Title       : prova
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.math_real.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


entity pulse_shrk_strch_RHSEU is
  generic(
       N_wakeup_b : integer RANGE 1 to 8 := 3 -- numer of bits of N_wakeup
  );
  port(
       clk : in STD_LOGIC;
       pulse_in : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       N_wakeup : in STD_LOGIC_VECTOR(N_wakeup_b-1 downto 0);
       shrk_pulse : out STD_LOGIC;
       strtch_pulse : out STD_LOGIC;
	   seu_out : out STD_LOGIC
  );
end pulse_shrk_strch_RHSEU;

architecture pulse_shrk_strch1 of pulse_shrk_strch_RHSEU is

---- Component declarations -----

component Counter_N_RHSEU
  generic(
       N : INTEGER;
       modul : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       count : out STD_LOGIC_VECTOR(N-1 downto 0);
	   seu : out STD_LOGIC
  );
end component;

---- Signal declarations used on the diagram ----

signal finish : STD_LOGIC;
signal NET1393 : STD_LOGIC;
signal NET96 : STD_LOGIC;
signal sleep : STD_LOGIC;
signal count : STD_LOGIC_VECTOR (N_wakeup_b-1 downto 0);

begin

---- User Signal Assignments ----
finish <= '0' when count = N_wakeup else '1';
sleep <= OR_REDUCE(count);

----  Component instantiations  ----

CNT : Counter_N_RHSEU
  generic map (
       N => N_wakeup_b,
       modul => 0
  )
  port map(
       clk => clk,
       count => count,
       en => NET1393,
       rst_L => NET96,
	   seu => seu_out
  );

NET1393 <= pulse_in or sleep;

shrk_pulse <= not(sleep) and pulse_in;

strtch_pulse <= sleep or pulse_in;

NET96 <= rst_L and finish;


end pulse_shrk_strch1;
