-------------------------------------------------------------------------------
--
-- Title       : sel_FRM_gen
-- Design      : Interfaces
-- Author      : Cla
-- Company     : Casa
--
-------------------------------------------------------------------------------
--
-- File        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\compile\sel_THS_gen_TX.vhd
-- Generated   : Sun Jul  4 19:34:22 2010
-- From        : C:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_2010_07_03(4x)\src\sel_THS_gen_TX.bde
-- By          : Bde2Vhdl ver. 2.6
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------
-- Design unit header --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.math_real.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


-- active library clause
 

entity sel_THS_gen_TX_RHSEU is
  port(
       clk40 : in STD_LOGIC;
       clk_tx : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       sel_THS : out STD_LOGIC;
	   seu_out : out STD_LOGIC
  );
end sel_THS_gen_TX_RHSEU;

architecture sel_THS_gen_TX_1 of sel_THS_gen_TX_RHSEU is

---- Component declarations -----

component Counter_N_RHSEU
  generic(
       N : INTEGER;
       modul : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       count : out STD_LOGIC_VECTOR(N-1 downto 0);	 
	   seu : out STD_LOGIC
  );
end component;
component ffd_ar_RHSEU
  port (
       ACLR : in STD_LOGIC;
       D : in STD_LOGIC;
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       Q : out STD_LOGIC;
       QN : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;

----     Constants     -----
constant VCC_CONSTANT   : STD_LOGIC := '1';

---- Signal declarations used on the diagram ----

signal CNT_rst_L : STD_LOGIC;
signal FF_aclr_L : STD_LOGIC;
signal FF_out : STD_LOGIC;
signal reset_FF : STD_LOGIC;
signal VCC : STD_LOGIC;
signal count : STD_LOGIC_VECTOR (1 downto 0);
signal seu_out_Counter, seu_out_ffd_ar  : STD_LOGIC;  

begin

---- User Signal Assignments ----
sel_THS <= '1' when (count = "01") OR (count = "10")
			else '0';
reset_FF <= '0' when (count = "10") else '1';

----  Component instantiations  ----

CNT : Counter_N_RHSEU
  generic map (
       N => 2,
       modul => 4
  )
  port map(
       clk => clk_tx,
       count => count( 1 downto 0 ),
       en => VCC,
       rst_L => CNT_rst_L,
	   seu => seu_out_Counter
  );

FF : ffd_ar_RHSEU
  port map(
       ACLR => FF_aclr_L,
       D => VCC,
       Q => FF_out,
       clk => clk40,
       en => VCC,
	   seu => seu_out_ffd_ar
  );

CNT_rst_L <= rst_L and FF_out;

FF_aclr_L <= reset_FF and rst_L;

seu_out <= seu_out_Counter OR seu_out_ffd_ar;
---- Power , ground assignment ----

VCC <= VCC_CONSTANT;

end sel_THS_gen_TX_1;
