-------------------------------------------------------------------------------
--
-- Title       : serial
-- Design      : Interfaces
-- Author      : VLSI Lab
-- Company     : VLSI Lab
--
-------------------------------------------------------------------------------
--
-- File        : c:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_v2_8x_20100708\compile\serializer.vhd
-- Generated   : Fri Jul  9 00:44:31 2010
-- From        : c:\Work\FF-LYNX\FF-Interfaces\Active-HDL Projects\Interfaces_v2_8x_20100708\src\serializer.bde
-- By          : Bde2Vhdl ver. 2.6
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------
-- Design unit header --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_misc.all;
use IEEE.math_real.all;
use IEEE.numeric_std.all;
use work.interfaces_pkg.all;


-- active library clause
 

entity serializer_RHSEU is
  generic(
       N_FRM : integer; -- number of FRMbits in each clk40 cycle
       N_CYC : integer; -- number of clk_tx cycles in each clk40 cycle
       N_CYC_b : integer -- = must be equal or greater than base 2 log of N_CYC
  );
  port(
       FLF_going : in STD_LOGIC;
       HDR_cmd : in STD_LOGIC;
       SYN_cmd : in STD_LOGIC;
       TRG_cmd : in STD_LOGIC;
       clk : in STD_LOGIC;
       read_TX_Buf : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       sel_THS : in STD_LOGIC;
       stop_in : in STD_LOGIC;
       FDC_in : in STD_LOGIC_VECTOR(N_FDC-1 downto 0);
       FLF_data_in : in STD_LOGIC_VECTOR(N_FRM-1 downto 0);
       word_in : in STD_LOGIC_VECTOR(N_WORD-1 downto 0);
       DAT_out : out STD_LOGIC;
       delay_HDR : out STD_LOGIC;
       sel_shr : out STD_LOGIC;
	   seu_out : out STD_LOGIC
  );
end serializer_RHSEU;

architecture serializer1 of serializer_RHSEU is

---- Component declarations -----

component pulse_shrinker_RHSEU
  generic(
       N_wakeup : INTEGER;
       N_wakeup_b : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       pulse_in : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       shrk_pulse : out STD_LOGIC;
	   seu_out : out STD_LOGIC

  );
end component;
component Counter_N_RHSEU
  generic(
       N : INTEGER;
       modul : INTEGER
  );
  port (
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       count : out STD_LOGIC_VECTOR(N-1 downto 0);
	   seu : out STD_LOGIC

  );
end component;
component ffd_RHSEU
  port (
       CLR : in STD_LOGIC;
       D : in STD_LOGIC;
       clk : in STD_LOGIC;
       en : in STD_LOGIC;
       Q : out STD_LOGIC;
       QN : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;
component mux2_Nbit
  generic(
       N : INTEGER
  );
  port (
       sel : in STD_LOGIC;
       x0 : in STD_LOGIC_VECTOR(N-1 downto 0);
       x1 : in STD_LOGIC_VECTOR(N-1 downto 0);
       z : out STD_LOGIC_VECTOR(N-1 downto 0)
  );
end component;
component PISO_reg_n_RHSEU
  generic(
       N : INTEGER
  );
  port (
       P_in : in STD_LOGIC_VECTOR(N-1 downto 0);
       clk : in STD_LOGIC;
       load : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       shift_en : in STD_LOGIC;
       S_out : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;
component ser_control_RHSEU
  port (
       HDR_cmd : in STD_LOGIC;
       clk : in STD_LOGIC;
       countB : in STD_LOGIC_VECTOR(N_WORD_b-1 downto 0);
       rst_L : in STD_LOGIC;
       stop : in STD_LOGIC;
       rst_BCNT_L : out STD_LOGIC;
       sel_shr : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;
component SIPISO_reg_N_RHSEU
  generic(
       N : INTEGER
  );
  port (
       P_in : in STD_LOGIC_VECTOR(N-1 downto 0);
       S_in : in STD_LOGIC;
       clk : in STD_LOGIC;
       load : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       shift_en : in STD_LOGIC;
       S_out : out STD_LOGIC;
	   seu : out STD_LOGIC
  );
end component;
component THS_cmd_selector
  port (
       HDR : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
       HDR_cmd : in STD_LOGIC;
       SYN : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
       SYN_cmd : in STD_LOGIC;
       TRG : in STD_LOGIC_VECTOR(N_THS-1 downto 0);
       TRG_cmd : in STD_LOGIC;
       THS_seq : out STD_LOGIC_VECTOR(N_THS-1 downto 0)
  );
end component;
component THS_load_ctrl_RHSEU
  port (
       THS_cmd : in STD_LOGIC;
       clk : in STD_LOGIC;
       rst_L : in STD_LOGIC;
       sel_THS : in STD_LOGIC;
       THS_busy : out STD_LOGIC;
       load_THS : out STD_LOGIC;
	   seu_out : out STD_LOGIC

  );
end component;

----     Constants     -----
constant VCC_CONSTANT   : STD_LOGIC := '1';

---- Signal declarations used on the diagram ----

signal delay_HDR_0 : STD_LOGIC;
signal FLF_going_del : STD_LOGIC;
signal FLF_stream : STD_LOGIC;
signal FRM_stream : STD_LOGIC;
signal HDR_cmd_shrk : STD_LOGIC;
signal load_FLF : STD_LOGIC;
signal load_shr : STD_LOGIC;
signal load_shr0 : STD_LOGIC;
signal load_shr0_pre : STD_LOGIC;
signal load_shr1 : STD_LOGIC;
signal load_shr1_pre : STD_LOGIC;
signal load_THS : STD_LOGIC;
signal NET354 : STD_LOGIC;
signal rst_BCNT_L : STD_LOGIC;
signal rst_DH_FF_L : STD_LOGIC;
signal sel_shr_int : STD_LOGIC;
signal shift_en_shr0 : STD_LOGIC;
signal shift_en_shr1 : STD_LOGIC;
signal shift_FLF : STD_LOGIC;
signal shift_VLF : STD_LOGIC;
signal shr0_out : STD_LOGIC;
signal shr1_out : STD_LOGIC;
signal stop : STD_LOGIC;
signal STP_FF_rst_L : STD_LOGIC;
signal THS_busy : STD_LOGIC;
signal THS_cmd : STD_LOGIC;
signal THS_stream : STD_LOGIC;
signal VCC : STD_LOGIC;
signal VLF_stream : STD_LOGIC;
signal countB : STD_LOGIC_VECTOR (N_WORD_b-1 downto 0);
signal HDR : STD_LOGIC_VECTOR (N_THS-1 downto 0);
signal M1_input0 : STD_LOGIC_VECTOR (N_WORD-1 downto 0);
signal shr0_input : STD_LOGIC_VECTOR (N_WORD-1 downto 0);
signal SYN : STD_LOGIC_VECTOR (N_THS-1 downto 0);
signal THS_seq : STD_LOGIC_VECTOR (N_THS-1 downto 0);
signal TRG : STD_LOGIC_VECTOR (N_THS-1 downto 0);
signal seu_out_BIT_CNT , seu_out_DH_FF , seu_out_NOP_FF , seu_out_PLS_SHRK , seu_out_SER_CTRL , seu_out_SHR0 , seu_out_SHR1 ,
	   seu_out_SHR_FLF , seu_out_STP_FF , seu_out_THS_SHR , seu_out_TLC , seu_out_U5 : STD_LOGIC;

begin

---- User Signal Assignments ----
M1_input0(N_WORD-1 downto N_FDC) <= (others => '0'); 
M1_input0(N_FDC-1 downto 0) <= FDC_in;
rst_DH_FF_L <= '0' when (((stop = '1' OR stop_in = '1') AND countB = CONV_STD_LOGIC_VECTOR(N_WORD-3, N_WORD_b)) OR rst_L = '0') else '1';
-- THS sequences written in reverse order
TRG <= "110001"; 
HDR <= "001101";
SYN <= "001111";

----  Component instantiations  ----

BIT_CNT : Counter_N_RHSEU
  generic map (
       N => N_WORD_b,
       modul => N_WORD
  )
  port map(
       clk => clk,
       count => countB( N_WORD_b-1 downto 0 ),
       en => shift_VLF,
       rst_L => rst_BCNT_L,
	   seu => seu_out_BIT_CNT
  );

DH_FF : ffd_RHSEU
  port map(
       CLR => rst_DH_FF_L,
       D => VCC,
       Q => delay_HDR_0,
       clk => clk,
       en => HDR_cmd,
	   seu => seu_out_DH_FF
  );

M1 : mux2_Nbit
  generic map (
       N => N_WORD
  )
  port map(
       sel => HDR_cmd,
       x0 => word_in( N_WORD-1 downto 0 ),
       x1 => M1_input0( N_WORD-1 downto 0 ),
       z => shr0_input( N_WORD-1 downto 0 )
  );

NOP_FF : ffd_RHSEU
  port map(
       CLR => sel_THS,
       D => VCC,
       Q => NET354,
       clk => clk,
       en => VCC,
	   seu => seu_out_NOP_FF
  );

PLS_SHRK : pulse_shrinker_RHSEU
  generic map (
       N_wakeup => N_CYC,
       N_wakeup_b => N_CYC_b
  )
  port map(
       clk => clk,
       pulse_in => read_TX_Buf,
       rst_L => rst_L,
       shrk_pulse => load_shr,
	   seu_out => seu_out_PLS_SHRK
  );

SER_CTRL : ser_control_RHSEU
  port map(
       HDR_cmd => HDR_cmd_shrk,
       clk => clk,
       countB => countB( N_WORD_b-1 downto 0 ),
       rst_BCNT_L => rst_BCNT_L,
       rst_L => rst_L,
       sel_shr => sel_shr_int,
       stop => stop,
	   seu => seu_out_SER_CTRL
  );

SHR0 : PISO_reg_n_RHSEU
  generic map (
       N => N_WORD
  )
  port map(
       P_in => shr0_input( N_WORD-1 downto 0 ),
       S_out => shr0_out,
       clk => clk,
       load => load_shr0,
       rst_L => rst_L,
       shift_en => shift_en_shr0,
	   seu => seu_out_SHR0
  );

SHR1 : PISO_reg_n_RHSEU
  generic map (
       N => N_WORD
  )
  port map(
       P_in => word_in( N_WORD-1 downto 0 ),
       S_out => shr1_out,
       clk => clk,
       load => load_shr1,
       rst_L => rst_L,
       shift_en => shift_en_shr1,
	   seu => seu_out_SHR1
  );

SHR_FLF : PISO_reg_n_RHSEU
  generic map (
       N => N_FRM
  )
  port map(
       P_in => FLF_data_in( N_FRM-1 downto 0 ),
       S_out => FLF_stream,
       clk => clk,
       load => load_FLF,
       rst_L => rst_L,
       shift_en => shift_FLF,  
	   seu => seu_out_SHR_FLF
  );

STP_FF : ffd_RHSEU
  port map(
       CLR => STP_FF_rst_L,
       D => VCC,
       Q => stop,
       clk => clk,
       en => stop_in,
	   seu => seu_out_STP_FF
  );

TCS : THS_cmd_selector
  port map(
       HDR => HDR( N_THS-1 downto 0 ),
       HDR_cmd => HDR_cmd,
       SYN => SYN( N_THS-1 downto 0 ),
       SYN_cmd => SYN_cmd,
       THS_seq => THS_seq( N_THS-1 downto 0 ),
       TRG => TRG( N_THS-1 downto 0 ),
       TRG_cmd => TRG_cmd
  );

THS_SHR : SIPISO_reg_N_RHSEU
  generic map (
       N => N_THS
  )
  port map(
       P_in => THS_seq( N_THS-1 downto 0 ),
       S_in => NET354,
       S_out => THS_stream,
       clk => clk,
       load => load_THS,
       rst_L => rst_L,
       shift_en => sel_THS, 
	   seu => seu_out_THS_SHR
  );

TLC : THS_load_ctrl_RHSEU
  port map(
       THS_busy => THS_busy,
       THS_cmd => THS_cmd,
       clk => clk,
       load_THS => load_THS,
       rst_L => rst_L,
       sel_THS => sel_THS,
	   seu_out => seu_out_TLC
  );

VLF_stream <= (shr0_out and not sel_shr_int) or (shr1_out and sel_shr_int);

shift_VLF <= not(sel_THS) and not(FLF_going_del);

load_shr0 <= HDR_cmd_shrk or load_shr0_pre;

load_shr1_pre <= not(sel_shr_int) and load_shr;

load_shr0_pre <= sel_shr_int and load_shr;

HDR_cmd_shrk <= not(THS_busy) and HDR_cmd;

delay_HDR <= delay_HDR_0 or THS_busy;

load_shr1 <= HDR_cmd_shrk or load_shr1_pre;

shift_FLF <= not(sel_THS) and FLF_going_del;

DAT_out <= (FRM_stream and not sel_THS) or (THS_stream and sel_THS);

FRM_stream <= (VLF_stream and not FLF_going_del) or (FLF_stream and FLF_going_del);

load_FLF <= FLF_going_del and sel_THS;

U5 : ffd_RHSEU
  port map(
       CLR => rst_L,
       D => FLF_going,
       Q => FLF_going_del,
       clk => clk,
       en => VCC,
	   seu => seu_out_U5
  );

shift_en_shr0 <= not(sel_shr_int) and shift_VLF;

shift_en_shr1 <= sel_shr_int and shift_VLF;

THS_cmd <= SYN_cmd or HDR_cmd or TRG_cmd;

STP_FF_rst_L <= not(HDR_cmd) and rst_L;


---- Power , ground assignment ----

VCC <= VCC_CONSTANT;

---- Terminal assignment ----

    -- Output\buffer terminals
	sel_shr <= sel_shr_int;

	seu_out <= seu_out_BIT_CNT OR seu_out_DH_FF OR seu_out_NOP_FF OR seu_out_PLS_SHRK OR seu_out_SER_CTRL OR seu_out_SHR0 OR seu_out_SHR1 
	   OR seu_out_SHR_FLF OR seu_out_STP_FF OR seu_out_THS_SHR OR seu_out_TLC OR seu_out_U5;
end serializer1;
