-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Mon Nov 08 04:14:56 2010"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY tx_gd_sel_logic IS 
	PORT
	(
		tx_4x_gd :  IN  STD_LOGIC;
		tx_8x_gd :  IN  STD_LOGIC;
		tx_16x_gd :  IN  STD_LOGIC;
		ded_en :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_16x_ded_gd :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_4x_ded_gd :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_8x_ded_gd :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_gd_en :  IN  STD_LOGIC_VECTOR(2 DOWNTO 0);
		tx_sel_a :  IN  STD_LOGIC_VECTOR(1 DOWNTO 0);
		tx_sel_b :  IN  STD_LOGIC_VECTOR(1 DOWNTO 0);
		tx_sel_c :  IN  STD_LOGIC_VECTOR(1 DOWNTO 0);
		tx_gd_out :  OUT  STD_LOGIC;
		tx_gd :  OUT  STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END tx_gd_sel_logic;

ARCHITECTURE bdf_type OF tx_gd_sel_logic IS 

COMPONENT mux_4xn
GENERIC (n : INTEGER
			);
	PORT(data0 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data2 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data3 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 TO 0)
	);
END COMPONENT;

COMPONENT mux_2xn
GENERIC (n : INTEGER
			);
	PORT(sel : IN STD_LOGIC;
		 data0 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data1 : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 result : OUT STD_LOGIC_VECTOR(n-1 TO 0)
	);
END COMPONENT;

COMPONENT vl_n
GENERIC (n : INTEGER
			);
	PORT(data_a_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data_b_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data_c_in : IN STD_LOGIC_VECTOR(n-1 TO 0);
		 data_out : OUT STD_LOGIC_VECTOR(n-1 TO 0)
	);
END COMPONENT;

SIGNAL	en_tx_gd :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	sel_tx_ded_gd :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	sel_tx_gd :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	tx_gd_ALTERA_SYNTHESIZED :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_0 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_1 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_2 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_3 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_4 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_5 :  STD_LOGIC;


BEGIN 
SYNTHESIZED_WIRE_0 <= '0';
SYNTHESIZED_WIRE_1 <= '0';
SYNTHESIZED_WIRE_2 <= '0';
SYNTHESIZED_WIRE_3 <= '0';
SYNTHESIZED_WIRE_4 <= '0';
SYNTHESIZED_WIRE_5 <= '0';



en_tx_gd(0) <= tx_gd_ALTERA_SYNTHESIZED(0) AND tx_gd_en(0);


en_tx_gd(1) <= tx_gd_ALTERA_SYNTHESIZED(1) AND tx_gd_en(1);


en_tx_gd(2) <= tx_gd_ALTERA_SYNTHESIZED(2) AND tx_gd_en(2);








b2v_TX_DED_GD_M4_A : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_0,
		 data1(0) => tx_4x_ded_gd(0),
		 data2(0) => tx_8x_ded_gd(0),
		 data3(0) => tx_16x_ded_gd(0),
		 sel => tx_sel_a,
		 result(0) => sel_tx_ded_gd(0));


b2v_TX_DED_GD_M4_B : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_1,
		 data1(0) => tx_4x_ded_gd(1),
		 data2(0) => tx_8x_ded_gd(1),
		 data3(0) => tx_16x_ded_gd(1),
		 sel => tx_sel_b,
		 result(0) => sel_tx_ded_gd(1));


b2v_TX_DED_GD_M4_C : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_2,
		 data1(0) => tx_4x_ded_gd(2),
		 data2(0) => tx_8x_ded_gd(2),
		 data3(0) => tx_16x_ded_gd(2),
		 sel => tx_sel_c,
		 result(0) => sel_tx_ded_gd(2));


b2v_TX_GD_M2_A : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ded_en(0),
		 data0(0) => sel_tx_gd(0),
		 data1(0) => sel_tx_ded_gd(0),
		 result(0) => tx_gd_ALTERA_SYNTHESIZED(0));


b2v_TX_GD_M2_B : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ded_en(1),
		 data0(0) => sel_tx_gd(1),
		 data1(0) => sel_tx_ded_gd(1),
		 result(0) => tx_gd_ALTERA_SYNTHESIZED(1));


b2v_TX_GD_M2_B3 : mux_2xn
GENERIC MAP(n => 1
			)
PORT MAP(sel => ded_en(2),
		 data0(0) => sel_tx_gd(2),
		 data1(0) => sel_tx_ded_gd(2),
		 result(0) => tx_gd_ALTERA_SYNTHESIZED(2));


b2v_TX_GD_M4_A : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_3,
		 data1(0) => tx_4x_gd,
		 data2(0) => tx_8x_gd,
		 data3(0) => tx_16x_gd,
		 sel => tx_sel_a,
		 result(0) => sel_tx_gd(0));


b2v_TX_GD_M4_B : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_4,
		 data1(0) => tx_4x_gd,
		 data2(0) => tx_8x_gd,
		 data3(0) => tx_16x_gd,
		 sel => tx_sel_b,
		 result(0) => sel_tx_gd(1));


b2v_TX_GD_M4_C : mux_4xn
GENERIC MAP(n => 1
			)
PORT MAP(data0(0) => SYNTHESIZED_WIRE_5,
		 data1(0) => tx_4x_gd,
		 data2(0) => tx_8x_gd,
		 data3(0) => tx_16x_gd,
		 sel => tx_sel_c,
		 result(0) => sel_tx_gd(2));


b2v_TX_GD_VL : vl_n
GENERIC MAP(n => 1
			)
PORT MAP(data_a_in(0) => en_tx_gd(0),
		 data_b_in(0) => en_tx_gd(1),
		 data_c_in(0) => en_tx_gd(2),
		 data_out(0) => tx_gd_out);

tx_gd <= tx_gd_ALTERA_SYNTHESIZED;

END bdf_type;