-- Copyright (C) 1991-2008 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II"
-- VERSION		"Version 8.1 Build 163 10/28/2008 SJ Full Version"
-- CREATED ON		"Fri Feb 04 06:24:34 2011"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY ff_emu IS 
	PORT
	(
		flf_p1_in :  IN  STD_LOGIC;
		flf_p2_in :  IN  STD_LOGIC;
		flf_e1_in :  IN  STD_LOGIC;
		flf_e2_in :  IN  STD_LOGIC;
		vlf_e1_in :  IN  STD_LOGIC;
		vlf_e2_in :  IN  STD_LOGIC;
		vlf_e3_in :  IN  STD_LOGIC;
		vlf_ta1_in :  IN  STD_LOGIC;
		vlf_ta2_in :  IN  STD_LOGIC;
		vlf_ta3_in :  IN  STD_LOGIC;
		vlf_tb1_in :  IN  STD_LOGIC;
		vlf_tb2_in :  IN  STD_LOGIC;
		flf_p1_out :  OUT  STD_LOGIC;
		flf_p2_out :  OUT  STD_LOGIC;
		flf_e1_out :  OUT  STD_LOGIC;
		flf_e2_out :  OUT  STD_LOGIC;
		vlf_e1_out :  OUT  STD_LOGIC;
		vlf_e2_out :  OUT  STD_LOGIC;
		vlf_e3_out :  OUT  STD_LOGIC;
		vlf_ta1_out :  OUT  STD_LOGIC;
		vlf_ta2_out :  OUT  STD_LOGIC;
		vlf_ta3_out :  OUT  STD_LOGIC;
		vlf_tb1_out :  OUT  STD_LOGIC;
		vlf_tb2_out :  OUT  STD_LOGIC;
		clk_ref :  IN  STD_LOGIC;
		rx_clk :  IN  STD_LOGIC;
		rx_dat :  IN  STD_LOGIC;
		tx_dat :  OUT  STD_LOGIC;
		msel0 :  IN  STD_LOGIC;
		msel1 :  IN  STD_LOGIC;
		msel2 :  IN  STD_LOGIC;
		reset :  IN  STD_LOGIC;
		token :  OUT  STD_LOGIC;
		ic0_tp :  OUT  STD_LOGIC_VECTOR(11 downto 0);
		clk_cmos :  OUT  STD_LOGIC
	);
END ff_emu;

ARCHITECTURE bdf_type OF ff_emu IS 

COMPONENT ff_rx_enable_gen
GENERIC (speed_ind : INTEGER
			);
	PORT(clk_rx : IN STD_LOGIC;
		 clk_ref_rx_rec : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 ff_rx_enable : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT ff_emu_core
	PORT(clk : IN STD_LOGIC;
		 flf_p1_in : IN STD_LOGIC;
		 flf_p2_in : IN STD_LOGIC;
		 flf_e1_in : IN STD_LOGIC;
		 flf_e2_in : IN STD_LOGIC;
		 vlf_e1_in : IN STD_LOGIC;
		 vlf_e2_in : IN STD_LOGIC;
		 vlf_e3_in : IN STD_LOGIC;
		 vlf_ta1_in : IN STD_LOGIC;
		 vlf_ta2_in : IN STD_LOGIC;
		 vlf_ta3_in : IN STD_LOGIC;
		 vlf_tb1_in : IN STD_LOGIC;
		 vlf_tb2_in : IN STD_LOGIC;
		 tx_seu : IN STD_LOGIC;
		 tx_fs_seu : IN STD_LOGIC;
		 tx_dwf_seu : IN STD_LOGIC;
		 tx_dwf_deu : IN STD_LOGIC;
		 tx_fdf_seu : IN STD_LOGIC;
		 tx_fdf_deu : IN STD_LOGIC;
		 rx_seu : IN STD_LOGIC;
		 rx_fs_seu : IN STD_LOGIC;
		 rx_dwf_seu : IN STD_LOGIC;
		 rx_dwf_deu : IN STD_LOGIC;
		 rx_fdf_seu : IN STD_LOGIC;
		 rx_fdf_deu : IN STD_LOGIC;
		 rx_ths_seu : IN STD_LOGIC;
		 rx_fd_seu : IN STD_LOGIC;
		 rx_fd_deu : IN STD_LOGIC;
		 rx_sl : IN STD_LOGIC;
		 rx_flf_dv_out : IN STD_LOGIC;
		 rx_vlf_dv_out : IN STD_LOGIC;
		 clk_ref : IN STD_LOGIC;
		 clk_en : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 mode_sel : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 reset : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		 rx_dw_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_fd_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_flf_data_out : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 rx_vlf_data_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_dw_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_fd_fifo_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 flf_p1_out : OUT STD_LOGIC;
		 flf_p2_out : OUT STD_LOGIC;
		 flf_e1_out : OUT STD_LOGIC;
		 flf_e2_out : OUT STD_LOGIC;
		 vlf_e1_out : OUT STD_LOGIC;
		 vlf_e2_out : OUT STD_LOGIC;
		 vlf_e3_out : OUT STD_LOGIC;
		 vlf_ta1_out : OUT STD_LOGIC;
		 vlf_ta2_out : OUT STD_LOGIC;
		 vlf_ta3_out : OUT STD_LOGIC;
		 vlf_tb1_out : OUT STD_LOGIC;
		 vlf_tb2_out : OUT STD_LOGIC;
		 tx_vlf_dv_in : OUT STD_LOGIC;
		 tx_flf_dv_in : OUT STD_LOGIC;
		 tx_fd_fifo_test_en : OUT STD_LOGIC;
		 tx_fd_fifo_test_wr : OUT STD_LOGIC;
		 tx_fd_fifo_test_rd : OUT STD_LOGIC;
		 tx_dw_fifo_test_rd : OUT STD_LOGIC;
		 tx_dw_fifo_test_wr : OUT STD_LOGIC;
		 tx_dw_fifo_test_en : OUT STD_LOGIC;
		 rx_dw_fifo_test_en : OUT STD_LOGIC;
		 rx_dw_fifo_test_wr : OUT STD_LOGIC;
		 rx_dw_fifo_test_rd : OUT STD_LOGIC;
		 rx_fd_fifo_test_en : OUT STD_LOGIC;
		 rx_fd_fifo_test_wr : OUT STD_LOGIC;
		 rx_fd_fifo_test_rd : OUT STD_LOGIC;
		 token_out : OUT STD_LOGIC;
		 scl : OUT STD_LOGIC;
		 sdaout : OUT STD_LOGIC;
		 sdaouten : OUT STD_LOGIC;
		 sdain : OUT STD_LOGIC;
		 rx_dw_fifo_test_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 rx_fd_fifo_test_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_dw_fifo_test_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_fd_fifo_test_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		 tx_flf_data_in : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 tx_vlf_data_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

-- COMPONENT rx_8x_rhseu
COMPONENT RX_8x_4b_6b_RHSEU
GENERIC (FLF_param_b : INTEGER;
			N_CYC : INTEGER;
			N_CYC_b : INTEGER;
			N_FRM : INTEGER
			);
	PORT(DAT_in : IN STD_LOGIC;
		 FLF_on : IN STD_LOGIC;
		 Get_Data : IN STD_LOGIC;
		 clk_enable : IN STD_LOGIC;
		 clk_tx : IN STD_LOGIC;
		 rst_L : IN STD_LOGIC;
		 FD_FIFO_empty : IN STD_LOGIC;
		 FD_FIFO_out : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 FLF_param : IN STD_LOGIC_VECTOR(FLF_param_b-1 DOWNTO 0);
		 write_RX_BUF : OUT STD_LOGIC;
		 read_RX_BUF : OUT STD_LOGIC;
		 Data_Type : OUT STD_LOGIC;
		 Data_Valid : OUT STD_LOGIC;
		 Frame_Lost : OUT STD_LOGIC;
		 Label_On : OUT STD_LOGIC;
		 Last_Frame : OUT STD_LOGIC;
		 TRG_out : OUT STD_LOGIC;
		 clk_out : OUT STD_LOGIC;
		 write_FD_FIFO : OUT STD_LOGIC;
		 read_FD_FIFO : OUT STD_LOGIC;
		 sync : OUT STD_LOGIC;
		 resync : OUT STD_LOGIC;
		 seu_out : OUT STD_LOGIC;
		 THS_seu : OUT STD_LOGIC;
		 FD_SEU : OUT STD_LOGIC;
		 FD_DEU : OUT STD_LOGIC;
		 FD_FIFO_in : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 FLF_data_out : OUT STD_LOGIC_VECTOR(N_FRM-1 DOWNTO 0);
		 RX_BUF_in : OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x22
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(21 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(21 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x22_cl_en
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 enable : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(N_WORD-1 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(N_WORD_ADDR-1 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x14
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(13 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(13 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x14_cl_en
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 enable : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(N_WORD-1 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(N_WORD_ADDR-1 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0)
	);
END COMPONENT;

-- COMPONENT tx_rhseu
COMPONENT TX_8x_4b_6b_RHSEU
GENERIC (FLF_param_b : INTEGER;
			N_CYC : INTEGER;
			N_CYC_b : INTEGER;
			N_FRM : INTEGER
			);
	PORT(Data_Type : IN STD_LOGIC;
		 Data_Valid : IN STD_LOGIC;
		 FLF_on : IN STD_LOGIC;
		 Label_On : IN STD_LOGIC;
		 TRG : IN STD_LOGIC;
		 TX_BUF_full : IN STD_LOGIC;
		 clk40 : IN STD_LOGIC;
		 clk_tx : IN STD_LOGIC;
		 rst_L : IN STD_LOGIC;
		 FDC_FIFO_empty : IN STD_LOGIC;
		 FDC_FIFO_full : IN STD_LOGIC;
		 FDC_FIFO_out : IN STD_LOGIC_VECTOR(11 DOWNTO 0);
		 FLF_data_in : IN STD_LOGIC_VECTOR(N_FRM-1 DOWNTO 0);
		 FLF_param : IN STD_LOGIC_VECTOR(FLF_param_b-1 DOWNTO 0);
		 TX_BUF_out : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
		 read_TX_Buf : OUT STD_LOGIC;
		 read_FDC_FIFO : OUT STD_LOGIC;
		 write_FDC_FIFO : OUT STD_LOGIC;
		 DAT_out : OUT STD_LOGIC;
		 Get_Data : OUT STD_LOGIC;
		 seu_out : OUT STD_LOGIC;
		 FDC_FIFO_in : OUT STD_LOGIC_VECTOR(11 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x22_cl
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(N_WORD-1 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(N_WORD_ADDR-1 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0)
	);
END COMPONENT;

COMPONENT array_32x18
	PORT(CLK : IN STD_LOGIC;
		 RST_L : IN STD_LOGIC;
		 EN : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		 IN_W0 : IN STD_LOGIC_VECTOR(17 DOWNTO 0);
		 W_ADDR_11_8 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_15_12 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_19_16 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_23_20 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_27_24 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_31_28 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_3_0 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 W_ADDR_7_4 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_15_12 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_19_16 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_23_20 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_27_24 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_31_28 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_3_0 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		 OUTB_7_4 : OUT STD_LOGIC_VECTOR(17 DOWNTO 0)
	);
END COMPONENT;

COMPONENT new_fifo_32x18_cl
GENERIC (N_ADDR : INTEGER;
			N_BIT_COD : INTEGER;
			N_BIT_DEC : INTEGER;
			N_BIT_PAR : INTEGER;
			N_MUX_WORD : INTEGER;
			N_WORD : INTEGER;
			N_WORD_ADDR : INTEGER
			);
	PORT(clk : IN STD_LOGIC;
		 fifo_ded_en : IN STD_LOGIC;
		 fifo_test_en : IN STD_LOGIC;
		 rst_l : IN STD_LOGIC;
		 test_read : IN STD_LOGIC;
		 test_write : IN STD_LOGIC;
		 ded_16x_read : IN STD_LOGIC;
		 ded_16x_write : IN STD_LOGIC;
		 ded_4x_read : IN STD_LOGIC;
		 ded_4x_write : IN STD_LOGIC;
		 ded_8x_read : IN STD_LOGIC;
		 ded_8x_write : IN STD_LOGIC;
		 seu_16x_read : IN STD_LOGIC;
		 seu_16x_write : IN STD_LOGIC;
		 seu_4x_read : IN STD_LOGIC;
		 seu_4x_write : IN STD_LOGIC;
		 seu_8x_read : IN STD_LOGIC;
		 seu_8x_write : IN STD_LOGIC;
		 ded_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 ded_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 fifo_sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		 OUTB_11_8 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_15_12 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_19_16 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_23_20 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_27_24 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_31_28 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_3_0 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 OUTB_7_3 : IN STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 seu_16x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_4x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 seu_8x_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 test_word_in : IN STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0);
		 deu : OUT STD_LOGIC;
		 empty : OUT STD_LOGIC;
		 full : OUT STD_LOGIC;
		 seu : OUT STD_LOGIC;
		 en_int : OUT STD_LOGIC_VECTOR(N_WORD-1 DOWNTO 0);
		 word_addr : OUT STD_LOGIC_VECTOR(N_WORD_ADDR-1 DOWNTO 0);
		 word_in_int : OUT STD_LOGIC_VECTOR(N_BIT_COD-1 DOWNTO 0);
		 word_out : OUT STD_LOGIC_VECTOR(N_BIT_DEC-1 DOWNTO 0)
	);
END COMPONENT;

SIGNAL	bus_enable :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	bus_reset :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	fifo_rx_ded_en :  STD_LOGIC;
SIGNAL	fifo_rx_sel :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	fifo_tx_ded_en :  STD_LOGIC;
SIGNAL	fifo_tx_sel :  STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL	flf_data_in :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	flf_data_out :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	flf_data_valid_in :  STD_LOGIC;
SIGNAL	flf_data_valid_out :  STD_LOGIC;
SIGNAL	flf_rx_size :  STD_LOGIC_VECTOR(6 DOWNTO 0);
SIGNAL	flf_tx_size :  STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL	if_reset_b :  STD_LOGIC;
SIGNAL	mode_sel :  STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL	rx_8x_data_flf :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	rx_8x_dt :  STD_LOGIC;
SIGNAL	rx_8x_dv :  STD_LOGIC;
SIGNAL	rx_8x_dw_fifo_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_8x_dw_fifo_rd :  STD_LOGIC;
SIGNAL	rx_8x_dw_fifo_wr :  STD_LOGIC;
SIGNAL	rx_8x_fd_fifo_in :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	rx_8x_fd_fifo_rd :  STD_LOGIC;
SIGNAL	rx_8x_fd_fifo_wr :  STD_LOGIC;
SIGNAL	rx_8x_fl :  STD_LOGIC;
SIGNAL	rx_8x_lf :  STD_LOGIC;
SIGNAL	rx_8x_lo :  STD_LOGIC;
SIGNAL	rx_8x_recovered_clk :  STD_LOGIC;
SIGNAL	rx_8x_trg :  STD_LOGIC;
SIGNAL	rx_clk_en :  STD_LOGIC;
SIGNAL	rx_dw_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	rx_dw_fifo_deu :  STD_LOGIC;
SIGNAL	rx_dw_fifo_empty :  STD_LOGIC;
SIGNAL	rx_dw_fifo_full :  STD_LOGIC;
SIGNAL	rx_dw_fifo_in :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	rx_dw_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_dw_fifo_seu :  STD_LOGIC;
SIGNAL	rx_dw_fifo_test_en :  STD_LOGIC;
SIGNAL	rx_dw_fifo_test_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_dw_fifo_test_rd :  STD_LOGIC;
SIGNAL	rx_dw_fifo_test_wr :  STD_LOGIC;
SIGNAL	rx_dw_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_fd_deu :  STD_LOGIC;
SIGNAL	rx_fd_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	rx_fd_fifo_deu :  STD_LOGIC;
SIGNAL	rx_fd_fifo_empty :  STD_LOGIC;
SIGNAL	rx_fd_fifo_full :  STD_LOGIC;
SIGNAL	rx_fd_fifo_in :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	rx_fd_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_fd_fifo_seu :  STD_LOGIC;
SIGNAL	rx_fd_fifo_test_en :  STD_LOGIC;
SIGNAL	rx_fd_fifo_test_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_fd_fifo_test_rd :  STD_LOGIC;
SIGNAL	rx_fd_fifo_test_wr :  STD_LOGIC;
SIGNAL	rx_fd_seu :  STD_LOGIC;
SIGNAL	rx_fd_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rx_resync :  STD_LOGIC;
SIGNAL	rx_seu :  STD_LOGIC;
SIGNAL	rx_sync :  STD_LOGIC;
SIGNAL	rx_ths_seu :  STD_LOGIC;
SIGNAL	scl :  STD_LOGIC;
SIGNAL	sdain :  STD_LOGIC;
SIGNAL	sdaout :  STD_LOGIC;
SIGNAL	sdaouten :  STD_LOGIC;
SIGNAL	token_out :  STD_LOGIC;
SIGNAL	tx_8x_data_flf :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	tx_8x_dv :  STD_LOGIC;
SIGNAL	tx_8x_dw_fifo_rd :  STD_LOGIC;
SIGNAL	tx_8x_fd_fifo_in :  STD_LOGIC_VECTOR(11 DOWNTO 0);
SIGNAL	tx_8x_fd_fifo_rd :  STD_LOGIC;
SIGNAL	tx_8x_fd_fifo_wr :  STD_LOGIC;
SIGNAL	tx_8x_trg :  STD_LOGIC;
SIGNAL	tx_data :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_dw_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	tx_dw_fifo_deu :  STD_LOGIC;
SIGNAL	tx_dw_fifo_empty :  STD_LOGIC;
SIGNAL	tx_dw_fifo_full :  STD_LOGIC;
SIGNAL	tx_dw_fifo_in :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	tx_dw_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_dw_fifo_seu :  STD_LOGIC;
SIGNAL	tx_dw_fifo_test_en :  STD_LOGIC;
SIGNAL	tx_dw_fifo_test_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_dw_fifo_test_rd :  STD_LOGIC;
SIGNAL	tx_dw_fifo_test_wr :  STD_LOGIC;
SIGNAL	tx_dw_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_fd_enable :  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	tx_fd_fifo_deu :  STD_LOGIC;
SIGNAL	tx_fd_fifo_empty :  STD_LOGIC;
SIGNAL	tx_fd_fifo_full :  STD_LOGIC;
SIGNAL	tx_fd_fifo_in :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	tx_fd_fifo_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_fd_fifo_seu :  STD_LOGIC;
SIGNAL	tx_fd_fifo_test_en :  STD_LOGIC;
SIGNAL	tx_fd_fifo_test_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_fd_fifo_test_rd :  STD_LOGIC;
SIGNAL	tx_fd_fifo_test_wr :  STD_LOGIC;
SIGNAL	tx_fd_waddr :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	tx_gd :  STD_LOGIC;
SIGNAL	tx_seu :  STD_LOGIC;
SIGNAL	vlf_data_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	vlf_data_out :  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	vlf_data_valid_in :  STD_LOGIC;
SIGNAL	vlf_data_valid_out :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_186 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_187 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_188 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_6 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_189 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_9 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_190 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_191 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_14 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_192 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_193 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_19 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_194 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_195 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_24 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_196 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_197 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_29 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_198 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_32 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_199 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_35 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_200 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_38 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_201 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_41 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_202 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_44 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_203 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_204 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_205 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_51 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_206 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_207 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_56 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_208 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_209 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_61 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_210 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_211 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_66 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_212 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_213 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_71 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_214 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_215 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_76 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_216 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_217 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_81 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_218 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_219 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_86 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_220 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_221 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_222 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_223 :  STD_LOGIC_VECTOR(0 TO 15);
SIGNAL	SYNTHESIZED_WIRE_104 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_105 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_106 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_107 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_108 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_109 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_110 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_111 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_224 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_225 :  STD_LOGIC_VECTOR(0 TO 8);
SIGNAL	SYNTHESIZED_WIRE_127 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_128 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_129 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_130 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_131 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_132 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_133 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_134 :  STD_LOGIC_VECTOR(13 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_226 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_138 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_227 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_228 :  STD_LOGIC_VECTOR(0 TO 15);
SIGNAL	SYNTHESIZED_WIRE_153 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_154 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_155 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_156 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_157 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_158 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_159 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_160 :  STD_LOGIC_VECTOR(21 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_229 :  STD_LOGIC;
SIGNAL	SYNTHESIZED_WIRE_230 :  STD_LOGIC_VECTOR(0 TO 11);
SIGNAL	SYNTHESIZED_WIRE_176 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_177 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_178 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_179 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_180 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_181 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_182 :  STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL	SYNTHESIZED_WIRE_183 :  STD_LOGIC_VECTOR(17 DOWNTO 0);

SIGNAL int_vlf_ta3_out :  STD_LOGIC;
SIGNAL int_vlf_ta2_out :  STD_LOGIC;
SIGNAL int_vlf_ta1_out :  STD_LOGIC;
SIGNAL int_vlf_e3_out :  STD_LOGIC;
SIGNAL int_vlf_e2_out :  STD_LOGIC;
SIGNAL int_vlf_e1_out :  STD_LOGIC;

BEGIN 
SYNTHESIZED_WIRE_186 <= '0';
SYNTHESIZED_WIRE_187 <= '1';
SYNTHESIZED_WIRE_188 <= '1';
SYNTHESIZED_WIRE_6 <= '0';
SYNTHESIZED_WIRE_189 <= '1';
SYNTHESIZED_WIRE_9 <= '0';
SYNTHESIZED_WIRE_190 <= '1';
SYNTHESIZED_WIRE_191 <= '1';
SYNTHESIZED_WIRE_14 <= '0';
SYNTHESIZED_WIRE_192 <= '1';
SYNTHESIZED_WIRE_193 <= '1';
SYNTHESIZED_WIRE_19 <= '0';
SYNTHESIZED_WIRE_194 <= '1';
SYNTHESIZED_WIRE_195 <= '1';
SYNTHESIZED_WIRE_24 <= '0';
SYNTHESIZED_WIRE_196 <= '1';
SYNTHESIZED_WIRE_197 <= '1';
SYNTHESIZED_WIRE_29 <= '0';
SYNTHESIZED_WIRE_198 <= '1';
SYNTHESIZED_WIRE_32 <= '0';
SYNTHESIZED_WIRE_199 <= '1';
SYNTHESIZED_WIRE_35 <= '0';
SYNTHESIZED_WIRE_200 <= '1';
SYNTHESIZED_WIRE_38 <= '0';
SYNTHESIZED_WIRE_201 <= '1';
SYNTHESIZED_WIRE_41 <= '0';
SYNTHESIZED_WIRE_202 <= '1';
SYNTHESIZED_WIRE_44 <= '0';
SYNTHESIZED_WIRE_203 <= '1';
SYNTHESIZED_WIRE_204 <= '1';
SYNTHESIZED_WIRE_205 <= '1';
SYNTHESIZED_WIRE_51 <= '0';
SYNTHESIZED_WIRE_206 <= '1';
SYNTHESIZED_WIRE_207 <= '1';
SYNTHESIZED_WIRE_56 <= '0';
SYNTHESIZED_WIRE_208 <= '1';
SYNTHESIZED_WIRE_209 <= '1';
SYNTHESIZED_WIRE_61 <= '0';
SYNTHESIZED_WIRE_210 <= '1';
SYNTHESIZED_WIRE_211 <= '1';
SYNTHESIZED_WIRE_66 <= '0';
SYNTHESIZED_WIRE_212 <= '1';
SYNTHESIZED_WIRE_213 <= '1';
SYNTHESIZED_WIRE_71 <= '0';
SYNTHESIZED_WIRE_214 <= '1';
SYNTHESIZED_WIRE_215 <= '1';
SYNTHESIZED_WIRE_76 <= '0';
SYNTHESIZED_WIRE_216 <= '1';
SYNTHESIZED_WIRE_217 <= '1';
SYNTHESIZED_WIRE_81 <= '0';
SYNTHESIZED_WIRE_218 <= '1';
SYNTHESIZED_WIRE_219 <= '1';
SYNTHESIZED_WIRE_86 <= '0';
SYNTHESIZED_WIRE_220 <= '1';
SYNTHESIZED_WIRE_221 <= '1';
SYNTHESIZED_WIRE_222 <= '0';
SYNTHESIZED_WIRE_223 <= "0000000000000000";
SYNTHESIZED_WIRE_224 <= '0';
SYNTHESIZED_WIRE_225 <= "000000000";
SYNTHESIZED_WIRE_226 <= '0';
SYNTHESIZED_WIRE_138 <= '1';
SYNTHESIZED_WIRE_227 <= '0';
SYNTHESIZED_WIRE_228 <= "0000000000000000";
SYNTHESIZED_WIRE_229 <= '0';
SYNTHESIZED_WIRE_230 <= "000000000000";

ic0_tp(11) <= rx_8x_recovered_clk;
ic0_tp(10) <= rx_clk_en;
ic0_tp(9) <= rx_resync;
ic0_tp(8) <= rx_sync;
ic0_tp(7) <= rx_8x_trg;
ic0_tp(6) <= rx_8x_dv;
ic0_tp(5) <= rx_clk; -- int_vlf_ta3_out;
ic0_tp(4) <= rx_dat; -- int_vlf_ta2_out;
ic0_tp(3) <= int_vlf_ta1_out;
ic0_tp(2) <= int_vlf_e3_out;
ic0_tp(1) <= int_vlf_e2_out;
ic0_tp(0) <= int_vlf_e1_out;

vlf_ta3_out <= int_vlf_ta3_out;
vlf_ta2_out <= int_vlf_ta2_out;
vlf_ta1_out <= int_vlf_ta1_out;
vlf_e3_out <= int_vlf_e3_out;
vlf_e2_out <= int_vlf_e2_out;
vlf_e1_out <= int_vlf_e1_out;
token <= token_out; -- bgb

b2v_EG : ff_rx_enable_gen
GENERIC MAP(speed_ind => 3
			)
PORT MAP(clk_rx => rx_clk,
		 clk_ref_rx_rec => rx_8x_recovered_clk,
		 reset => reset,
		 ff_rx_enable => rx_clk_en);



b2v_inst1 : ff_emu_core
PORT MAP(clk => rx_clk,
		 flf_p1_in => flf_p1_in,
		 flf_p2_in => flf_p2_in,
		 flf_e1_in => flf_e1_in,
		 flf_e2_in => flf_e2_in,
		 vlf_e1_in => vlf_e1_in,
		 vlf_e2_in => vlf_e2_in,
		 vlf_e3_in => vlf_e3_in,
		 vlf_ta1_in => vlf_ta1_in,
		 vlf_ta2_in => vlf_ta2_in,
		 vlf_ta3_in => vlf_ta3_in,
		 vlf_tb1_in => vlf_tb1_in,
		 vlf_tb2_in => vlf_tb2_in,
		 tx_seu => tx_seu,
		 tx_fs_seu => SYNTHESIZED_WIRE_186,
		 tx_dwf_seu => tx_dw_fifo_seu,
		 tx_dwf_deu => tx_dw_fifo_deu,
		 tx_fdf_seu => tx_fd_fifo_seu,
		 tx_fdf_deu => tx_fd_fifo_deu,
		 rx_seu => rx_seu,
		 rx_fs_seu => SYNTHESIZED_WIRE_186,
		 rx_dwf_seu => rx_dw_fifo_seu,
		 rx_dwf_deu => rx_dw_fifo_deu,
		 rx_fdf_seu => rx_fd_fifo_seu,
		 rx_fdf_deu => rx_fd_fifo_deu,
		 rx_ths_seu => rx_ths_seu,
		 rx_fd_seu => rx_fd_seu,
		 rx_fd_deu => rx_fd_deu,
		 rx_sl => rx_resync,
		 rx_flf_dv_out => flf_data_valid_in,
		 rx_vlf_dv_out => vlf_data_valid_in,
		 clk_ref => clk_ref,
		 clk_en => bus_enable,
		 mode_sel => mode_sel,
		 reset => bus_reset,
		 rx_dw_fifo_out => rx_dw_fifo_out,
		 rx_fd_fifo_out => rx_fd_fifo_out,
		 rx_flf_data_out => flf_data_in,
		 rx_vlf_data_out => vlf_data_in,
		 tx_dw_fifo_out => tx_dw_fifo_out,
		 tx_fd_fifo_out => tx_fd_fifo_out,
		 flf_p1_out => flf_p1_out,
		 flf_p2_out => flf_p2_out,
		 flf_e1_out => flf_e1_out,
		 flf_e2_out => flf_e2_out,
		 vlf_e1_out => int_vlf_e1_out,
		 vlf_e2_out => int_vlf_e2_out,
		 vlf_e3_out => int_vlf_e3_out,
		 vlf_ta1_out => int_vlf_ta1_out,
		 vlf_ta2_out => int_vlf_ta2_out,
		 vlf_ta3_out => int_vlf_ta3_out,
		 vlf_tb1_out => vlf_tb1_out,
		 vlf_tb2_out => vlf_tb2_out,
		 tx_vlf_dv_in => vlf_data_valid_out,
		 tx_flf_dv_in => flf_data_valid_out,
		 tx_fd_fifo_test_en => tx_fd_fifo_test_en,
		 tx_fd_fifo_test_wr => tx_fd_fifo_test_wr,
		 tx_fd_fifo_test_rd => tx_fd_fifo_test_rd,
		 tx_dw_fifo_test_rd => tx_dw_fifo_test_rd,
		 tx_dw_fifo_test_wr => tx_dw_fifo_test_wr,
		 tx_dw_fifo_test_en => tx_dw_fifo_test_en,
		 rx_dw_fifo_test_en => rx_dw_fifo_test_en,
		 rx_dw_fifo_test_wr => rx_dw_fifo_test_wr,
		 rx_dw_fifo_test_rd => rx_dw_fifo_test_rd,
		 rx_fd_fifo_test_en => rx_fd_fifo_test_en,
		 rx_fd_fifo_test_wr => rx_fd_fifo_test_wr,
		 rx_fd_fifo_test_rd => rx_fd_fifo_test_rd,
		 token_out => token_out,
		 rx_dw_fifo_test_in => rx_dw_fifo_test_in,
		 rx_fd_fifo_test_in => rx_fd_fifo_test_in,
		 tx_dw_fifo_test_in => tx_dw_fifo_test_in,
		 tx_fd_fifo_test_in => tx_fd_fifo_test_in,
		 tx_flf_data_in => flf_data_out,
		 tx_vlf_data_in => vlf_data_out);
























flf_data_valid_in <= rx_8x_trg;



vlf_data_valid_in <= rx_8x_dv;









flf_data_in <= rx_8x_data_flf;









vlf_data_in <= rx_dw_fifo_out;









tx_8x_dv <= vlf_data_valid_out;


tx_8x_trg <= flf_data_valid_out;


tx_8x_data_flf <= flf_data_out;


tx_data <= vlf_data_out;



if_reset_b <= NOT(reset);





bus_reset(0) <= reset;


bus_reset(1) <= reset;


bus_reset(2) <= reset;


bus_enable(0) <= rx_clk_en;


bus_enable(1) <= rx_clk_en;


bus_enable(2) <= rx_clk_en;


b2v_RX_8x : RX_8x_4b_6b_RHSEU
GENERIC MAP(FLF_param_b => 7,
			N_CYC => 8,
			N_CYC_b => 3,
			N_FRM => 6
			)
PORT MAP(DAT_in => rx_dat,
		 FLF_on => SYNTHESIZED_WIRE_221,
		 Get_Data => SYNTHESIZED_WIRE_221,
		 clk_enable => rx_clk_en,
		 clk_tx => rx_clk,
		 rst_L => if_reset_b,
		 FD_FIFO_empty => rx_fd_fifo_empty,
		 FD_FIFO_out => rx_fd_fifo_out(7 DOWNTO 0),
		 FLF_param => flf_rx_size,
		 write_RX_BUF => rx_8x_dw_fifo_wr,
		 read_RX_BUF => rx_8x_dw_fifo_rd,
		 Data_Valid => rx_8x_dv,
		 TRG_out => rx_8x_trg,
		 clk_out => rx_8x_recovered_clk,
		 write_FD_FIFO => rx_8x_fd_fifo_wr,
		 read_FD_FIFO => rx_8x_fd_fifo_rd,
		 resync => rx_resync,
		 sync => rx_sync,
		 seu_out => rx_seu,
		 THS_seu => rx_ths_seu,
		 FD_SEU => rx_fd_seu,
		 FD_DEU => rx_fd_deu,
		 FD_FIFO_in => rx_8x_fd_fifo_in(7 DOWNTO 0),
		 FLF_data_out => rx_8x_data_flf,
		 RX_BUF_in => rx_8x_dw_fifo_in);

clk_cmos <= rx_8x_recovered_clk;

b2v_RX_DW_FIFO_ARRAY : array_32x22
PORT MAP(CLK => rx_clk,
		 RST_L => if_reset_b,
		 EN => rx_dw_enable,
		 IN_W0 => rx_dw_fifo_in,
		 W_ADDR_11_8 => rx_dw_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => rx_dw_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => rx_dw_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => rx_dw_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => rx_dw_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => rx_dw_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => rx_dw_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => rx_dw_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_104,
		 OUTB_15_12 => SYNTHESIZED_WIRE_105,
		 OUTB_19_16 => SYNTHESIZED_WIRE_106,
		 OUTB_23_20 => SYNTHESIZED_WIRE_107,
		 OUTB_27_24 => SYNTHESIZED_WIRE_108,
		 OUTB_31_28 => SYNTHESIZED_WIRE_109,
		 OUTB_3_0 => SYNTHESIZED_WIRE_110,
		 OUTB_7_4 => SYNTHESIZED_WIRE_111);


b2v_RX_DW_FIFO_CL : new_fifo_32x22_cl_en
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 22,
			N_BIT_DEC => 16,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => rx_clk,
		 fifo_ded_en => fifo_rx_ded_en,
		 fifo_test_en => rx_dw_fifo_test_en,
		 rst_l => if_reset_b,
		 test_read => rx_dw_fifo_test_rd,
		 test_write => rx_dw_fifo_test_wr,
		 ded_16x_read => SYNTHESIZED_WIRE_222,
		 ded_16x_write => SYNTHESIZED_WIRE_222,
		 ded_4x_read => SYNTHESIZED_WIRE_222,
		 ded_4x_write => SYNTHESIZED_WIRE_222,
		 ded_8x_read => SYNTHESIZED_WIRE_222,
		 ded_8x_write => SYNTHESIZED_WIRE_222,
		 seu_16x_read => SYNTHESIZED_WIRE_222,
		 seu_16x_write => SYNTHESIZED_WIRE_222,
		 seu_4x_read => SYNTHESIZED_WIRE_222,
		 seu_4x_write => SYNTHESIZED_WIRE_222,
		 seu_8x_read => rx_8x_dw_fifo_rd,
		 seu_8x_write => rx_8x_dw_fifo_wr,
		 enable => rx_clk_en,
		 ded_16x_word_in => SYNTHESIZED_WIRE_223,
		 ded_4x_word_in => SYNTHESIZED_WIRE_223,
		 ded_8x_word_in => SYNTHESIZED_WIRE_223,
		 fifo_sel => fifo_rx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_104,
		 OUTB_15_12 => SYNTHESIZED_WIRE_105,
		 OUTB_19_16 => SYNTHESIZED_WIRE_106,
		 OUTB_23_20 => SYNTHESIZED_WIRE_107,
		 OUTB_27_24 => SYNTHESIZED_WIRE_108,
		 OUTB_31_28 => SYNTHESIZED_WIRE_109,
		 OUTB_3_0 => SYNTHESIZED_WIRE_110,
		 OUTB_7_3 => SYNTHESIZED_WIRE_111,
		 seu_16x_word_in => SYNTHESIZED_WIRE_223,
		 seu_4x_word_in => SYNTHESIZED_WIRE_223,
		 seu_8x_word_in => rx_8x_dw_fifo_in,
		 test_word_in => rx_dw_fifo_test_in,
		 deu => rx_dw_fifo_deu,
		 seu => rx_dw_fifo_seu,
		 en_int => rx_dw_enable,
		 word_addr => rx_dw_waddr,
		 word_in_int => rx_dw_fifo_in,
		 word_out => rx_dw_fifo_out);


b2v_RX_FD_FIFO_ARRAY : array_32x14
PORT MAP(CLK => rx_clk,
		 RST_L => if_reset_b,
		 EN => rx_fd_enable,
		 IN_W0 => rx_fd_fifo_in,
		 W_ADDR_11_8 => rx_fd_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => rx_fd_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => rx_fd_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => rx_fd_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => rx_fd_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => rx_fd_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => rx_fd_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => rx_fd_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_127,
		 OUTB_15_12 => SYNTHESIZED_WIRE_128,
		 OUTB_19_16 => SYNTHESIZED_WIRE_129,
		 OUTB_23_20 => SYNTHESIZED_WIRE_130,
		 OUTB_27_24 => SYNTHESIZED_WIRE_131,
		 OUTB_31_28 => SYNTHESIZED_WIRE_132,
		 OUTB_3_0 => SYNTHESIZED_WIRE_133,
		 OUTB_7_4 => SYNTHESIZED_WIRE_134);


b2v_RX_FD_FIFO_CL : new_fifo_32x14_cl_en
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 14,
			N_BIT_DEC => 9,
			N_BIT_PAR => 5,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => rx_clk,
		 fifo_ded_en => fifo_rx_ded_en,
		 fifo_test_en => rx_fd_fifo_test_en,
		 rst_l => if_reset_b,
		 test_read => rx_fd_fifo_test_rd,
		 test_write => rx_fd_fifo_test_wr,
		 ded_16x_read => SYNTHESIZED_WIRE_224,
		 ded_16x_write => SYNTHESIZED_WIRE_224,
		 ded_4x_read => SYNTHESIZED_WIRE_224,
		 ded_4x_write => SYNTHESIZED_WIRE_224,
		 ded_8x_read => SYNTHESIZED_WIRE_224,
		 ded_8x_write => SYNTHESIZED_WIRE_224,
		 seu_16x_read => SYNTHESIZED_WIRE_224,
		 seu_16x_write => SYNTHESIZED_WIRE_224,
		 seu_4x_read => SYNTHESIZED_WIRE_224,
		 seu_4x_write => SYNTHESIZED_WIRE_224,
		 seu_8x_read => rx_8x_fd_fifo_rd,
		 seu_8x_write => rx_8x_fd_fifo_wr,
		 enable => rx_clk_en,
		 ded_16x_word_in => SYNTHESIZED_WIRE_225,
		 ded_4x_word_in => SYNTHESIZED_WIRE_225,
		 ded_8x_word_in => SYNTHESIZED_WIRE_225,
		 fifo_sel => fifo_rx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_127,
		 OUTB_15_12 => SYNTHESIZED_WIRE_128,
		 OUTB_19_16 => SYNTHESIZED_WIRE_129,
		 OUTB_23_20 => SYNTHESIZED_WIRE_130,
		 OUTB_27_24 => SYNTHESIZED_WIRE_131,
		 OUTB_31_28 => SYNTHESIZED_WIRE_132,
		 OUTB_3_0 => SYNTHESIZED_WIRE_133,
		 OUTB_7_3 => SYNTHESIZED_WIRE_134,
		 seu_16x_word_in => SYNTHESIZED_WIRE_225,
		 seu_4x_word_in => SYNTHESIZED_WIRE_225,
		 seu_8x_word_in => rx_8x_fd_fifo_in,
		 test_word_in => rx_fd_fifo_test_in(8 DOWNTO 0),
		 deu => rx_fd_fifo_deu,
		 empty => rx_fd_fifo_empty,
		 seu => rx_fd_fifo_seu,
		 en_int => rx_fd_enable,
		 word_addr => rx_fd_waddr,
		 word_in_int => rx_fd_fifo_in,
		 word_out => rx_fd_fifo_out(8 DOWNTO 0));


b2v_TX_8x : TX_8x_4b_6b_RHSEU
GENERIC MAP(FLF_param_b => 4,
			N_CYC => 8,
			N_CYC_b => 3,
			N_FRM => 6
			)
PORT MAP(Data_Type => SYNTHESIZED_WIRE_226,
		 Data_Valid => tx_8x_dv,
		 FLF_on => SYNTHESIZED_WIRE_138,
		 Label_On => SYNTHESIZED_WIRE_226,
		 TRG => tx_8x_trg,
		 TX_BUF_full => tx_dw_fifo_full,
		 clk40 => clk_ref,
		 clk_tx => rx_clk,
		 rst_L => if_reset_b,
		 FDC_FIFO_empty => tx_fd_fifo_empty,
		 FDC_FIFO_full => tx_fd_fifo_full,
		 FDC_FIFO_out => tx_fd_fifo_out(11 DOWNTO 0),
		 FLF_data_in => tx_8x_data_flf,
		 FLF_param => flf_tx_size,
		 TX_BUF_out => tx_dw_fifo_out,
		 read_TX_Buf => tx_8x_dw_fifo_rd,
		 read_FDC_FIFO => tx_8x_fd_fifo_rd,
		 write_FDC_FIFO => tx_8x_fd_fifo_wr,
		 DAT_out => tx_dat,
		 seu_out => tx_seu,
		 FDC_FIFO_in => tx_8x_fd_fifo_in);


b2v_TX_DW_FIFO_ARRAY : array_32x22
PORT MAP(CLK => clk_ref,
		 RST_L => if_reset_b,
		 EN => tx_dw_enable,
		 IN_W0 => tx_dw_fifo_in,
		 W_ADDR_11_8 => tx_dw_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => tx_dw_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => tx_dw_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => tx_dw_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => tx_dw_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => tx_dw_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => tx_dw_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => tx_dw_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_153,
		 OUTB_15_12 => SYNTHESIZED_WIRE_154,
		 OUTB_19_16 => SYNTHESIZED_WIRE_155,
		 OUTB_23_20 => SYNTHESIZED_WIRE_156,
		 OUTB_27_24 => SYNTHESIZED_WIRE_157,
		 OUTB_31_28 => SYNTHESIZED_WIRE_158,
		 OUTB_3_0 => SYNTHESIZED_WIRE_159,
		 OUTB_7_4 => SYNTHESIZED_WIRE_160);


b2v_TX_DW_FIFO_CL : new_fifo_32x22_cl
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 22,
			N_BIT_DEC => 16,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => clk_ref,
		 fifo_ded_en => fifo_tx_ded_en,
		 fifo_test_en => tx_dw_fifo_test_en,
		 rst_l => if_reset_b,
		 test_read => tx_dw_fifo_test_rd,
		 test_write => tx_dw_fifo_test_wr,
		 ded_16x_read => SYNTHESIZED_WIRE_227,
		 ded_16x_write => SYNTHESIZED_WIRE_227,
		 ded_4x_read => SYNTHESIZED_WIRE_227,
		 ded_4x_write => SYNTHESIZED_WIRE_227,
		 ded_8x_read => SYNTHESIZED_WIRE_227,
		 ded_8x_write => SYNTHESIZED_WIRE_227,
		 seu_16x_read => SYNTHESIZED_WIRE_227,
		 seu_16x_write => SYNTHESIZED_WIRE_227,
		 seu_4x_read => SYNTHESIZED_WIRE_227,
		 seu_4x_write => SYNTHESIZED_WIRE_227,
		 seu_8x_read => tx_8x_dw_fifo_rd,
		 seu_8x_write => tx_8x_dv,
		 ded_16x_word_in => SYNTHESIZED_WIRE_228,
		 ded_4x_word_in => SYNTHESIZED_WIRE_228,
		 ded_8x_word_in => SYNTHESIZED_WIRE_228,
		 fifo_sel => fifo_tx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_153,
		 OUTB_15_12 => SYNTHESIZED_WIRE_154,
		 OUTB_19_16 => SYNTHESIZED_WIRE_155,
		 OUTB_23_20 => SYNTHESIZED_WIRE_156,
		 OUTB_27_24 => SYNTHESIZED_WIRE_157,
		 OUTB_31_28 => SYNTHESIZED_WIRE_158,
		 OUTB_3_0 => SYNTHESIZED_WIRE_159,
		 OUTB_7_3 => SYNTHESIZED_WIRE_160,
		 seu_16x_word_in => SYNTHESIZED_WIRE_228,
		 seu_4x_word_in => SYNTHESIZED_WIRE_228,
		 seu_8x_word_in => tx_data,
		 test_word_in => tx_dw_fifo_test_in,
		 deu => tx_dw_fifo_deu,
		 full => tx_dw_fifo_full,
		 seu => tx_dw_fifo_seu,
		 en_int => tx_dw_enable,
		 word_addr => tx_dw_waddr,
		 word_in_int => tx_dw_fifo_in,
		 word_out => tx_dw_fifo_out);


b2v_TX_FD_FIFO_ARRAY : array_32x18
PORT MAP(CLK => clk_ref,
		 RST_L => if_reset_b,
		 EN => tx_fd_enable,
		 IN_W0 => tx_fd_fifo_in,
		 W_ADDR_11_8 => tx_fd_waddr(5 DOWNTO 4),
		 W_ADDR_15_12 => tx_fd_waddr(7 DOWNTO 6),
		 W_ADDR_19_16 => tx_fd_waddr(9 DOWNTO 8),
		 W_ADDR_23_20 => tx_fd_waddr(11 DOWNTO 10),
		 W_ADDR_27_24 => tx_fd_waddr(13 DOWNTO 12),
		 W_ADDR_31_28 => tx_fd_waddr(15 DOWNTO 14),
		 W_ADDR_3_0 => tx_fd_waddr(1 DOWNTO 0),
		 W_ADDR_7_4 => tx_fd_waddr(3 DOWNTO 2),
		 OUTB_11_8 => SYNTHESIZED_WIRE_176,
		 OUTB_15_12 => SYNTHESIZED_WIRE_177,
		 OUTB_19_16 => SYNTHESIZED_WIRE_178,
		 OUTB_23_20 => SYNTHESIZED_WIRE_179,
		 OUTB_27_24 => SYNTHESIZED_WIRE_180,
		 OUTB_31_28 => SYNTHESIZED_WIRE_181,
		 OUTB_3_0 => SYNTHESIZED_WIRE_182,
		 OUTB_7_4 => SYNTHESIZED_WIRE_183);


b2v_TX_FD_FIFO_CL : new_fifo_32x18_cl
GENERIC MAP(N_ADDR => 5,
			N_BIT_COD => 18,
			N_BIT_DEC => 12,
			N_BIT_PAR => 6,
			N_MUX_WORD => 16,
			N_WORD => 32,
			N_WORD_ADDR => 16
			)
PORT MAP(clk => clk_ref,
		 fifo_ded_en => fifo_tx_ded_en,
		 fifo_test_en => tx_fd_fifo_test_en,
		 rst_l => if_reset_b,
		 test_read => tx_fd_fifo_test_rd,
		 test_write => tx_fd_fifo_test_wr,
		 ded_16x_read => SYNTHESIZED_WIRE_229,
		 ded_16x_write => SYNTHESIZED_WIRE_229,
		 ded_4x_read => SYNTHESIZED_WIRE_229,
		 ded_4x_write => SYNTHESIZED_WIRE_229,
		 ded_8x_read => SYNTHESIZED_WIRE_229,
		 ded_8x_write => SYNTHESIZED_WIRE_229,
		 seu_16x_read => SYNTHESIZED_WIRE_229,
		 seu_16x_write => SYNTHESIZED_WIRE_229,
		 seu_4x_read => SYNTHESIZED_WIRE_229,
		 seu_4x_write => SYNTHESIZED_WIRE_229,
		 seu_8x_read => tx_8x_fd_fifo_rd,
		 seu_8x_write => tx_8x_fd_fifo_wr,
		 ded_16x_word_in => SYNTHESIZED_WIRE_230,
		 ded_4x_word_in => SYNTHESIZED_WIRE_230,
		 ded_8x_word_in => SYNTHESIZED_WIRE_230,
		 fifo_sel => fifo_tx_sel,
		 OUTB_11_8 => SYNTHESIZED_WIRE_176,
		 OUTB_15_12 => SYNTHESIZED_WIRE_177,
		 OUTB_19_16 => SYNTHESIZED_WIRE_178,
		 OUTB_23_20 => SYNTHESIZED_WIRE_179,
		 OUTB_27_24 => SYNTHESIZED_WIRE_180,
		 OUTB_31_28 => SYNTHESIZED_WIRE_181,
		 OUTB_3_0 => SYNTHESIZED_WIRE_182,
		 OUTB_7_3 => SYNTHESIZED_WIRE_183,
		 seu_16x_word_in => SYNTHESIZED_WIRE_230,
		 seu_4x_word_in => SYNTHESIZED_WIRE_230,
		 seu_8x_word_in => tx_8x_fd_fifo_in,
		 test_word_in => tx_fd_fifo_test_in(11 DOWNTO 0),
		 deu => tx_fd_fifo_deu,
		 empty => tx_fd_fifo_empty,
		 full => tx_fd_fifo_full,
		 seu => tx_fd_fifo_seu,
		 en_int => tx_fd_enable,
		 word_addr => tx_fd_waddr,
		 word_in_int => tx_fd_fifo_in,
		 word_out => tx_fd_fifo_out(11 DOWNTO 0));


fifo_rx_ded_en <= '0';
fifo_rx_sel(0) <= '0';
fifo_rx_sel(1) <= '1';
fifo_tx_ded_en <= '0';
fifo_tx_sel(0) <= '0';
fifo_tx_sel(1) <= '1';
flf_rx_size(0) <= '0';
flf_rx_size(2) <= '1';
flf_rx_size(3) <= '0';
flf_rx_size(4) <= '1';
flf_rx_size(5) <= '0';
flf_rx_size(6) <= '0';
flf_rx_size(1) <= '1';
flf_tx_size(3) <= '0';
flf_tx_size(2) <= '0';
flf_tx_size(0) <= '0';
flf_tx_size(1) <= '1';
rx_8x_fd_fifo_in(8) <= '0';
rx_fd_fifo_out(15 DOWNTO 9) <= "0000000";
tx_fd_fifo_out(15 DOWNTO 12) <= "0000";
END bdf_type;