LIBRARY IEEE;
USE IEEE.std_logic_1164.all; 
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;
LIBRARY UNISIM;
USE UNISIM.vcomponents.all;
LIBRARY UNIMACRO;
USE UNIMACRO.vcomponents.all;
--LIBRARY work;
--USE work.Latches_Flipflops.all;

ENTITY FF_EMU_PAIR_SIM IS 
	PORT
	(

      clk40 : IN STD_LOGIC;
      clk320 : IN STD_LOGIC;
      tkn_tx_enable : IN STD_LOGIC;

		dmb_flf_p1_in :  IN  STD_LOGIC;
		dmb_flf_p2_in :  IN  STD_LOGIC;
		dmb_flf_e1_in :  IN  STD_LOGIC;
		dmb_flf_e2_in :  IN  STD_LOGIC;
		dmb_vlf_e1_in :  IN  STD_LOGIC;
		dmb_vlf_e2_in :  IN  STD_LOGIC;
		dmb_vlf_e3_in :  IN  STD_LOGIC;
		dmb_vlf_ta1_in :  IN  STD_LOGIC;
		dmb_vlf_ta2_in :  IN  STD_LOGIC;
		dmb_vlf_ta3_in :  IN  STD_LOGIC;
		dmb_vlf_tb1_in :  IN  STD_LOGIC;
		dmb_vlf_tb2_in :  IN  STD_LOGIC;

		ff_emu_flf_p1_in :  IN  STD_LOGIC;
		ff_emu_flf_p2_in :  IN  STD_LOGIC;
		ff_emu_flf_e1_in :  IN  STD_LOGIC;
		ff_emu_flf_e2_in :  IN  STD_LOGIC;
		ff_emu_vlf_e1_in :  IN  STD_LOGIC;
		ff_emu_vlf_e2_in :  IN  STD_LOGIC;
		ff_emu_vlf_e3_in :  IN  STD_LOGIC;
		ff_emu_vlf_ta1_in :  IN  STD_LOGIC;
		ff_emu_vlf_ta2_in :  IN  STD_LOGIC;
		ff_emu_vlf_ta3_in :  IN  STD_LOGIC;
		ff_emu_vlf_tb1_in :  IN  STD_LOGIC;
		ff_emu_vlf_tb2_in :  IN  STD_LOGIC;
		
		dmb_flf_p1_out :  OUT  STD_LOGIC;
		dmb_flf_p2_out :  OUT  STD_LOGIC;
		dmb_flf_e1_out :  OUT  STD_LOGIC;
		dmb_flf_e2_out :  OUT  STD_LOGIC;
		dmb_vlf_e1_out :  OUT  STD_LOGIC;
		dmb_vlf_e2_out :  OUT  STD_LOGIC;
		dmb_vlf_e3_out :  OUT  STD_LOGIC;
		dmb_vlf_ta1_out :  OUT  STD_LOGIC;
		dmb_vlf_ta2_out :  OUT  STD_LOGIC;
		dmb_vlf_ta3_out :  OUT  STD_LOGIC;
		dmb_vlf_tb1_out :  OUT  STD_LOGIC;
		dmb_vlf_tb2_out :  OUT  STD_LOGIC;

		ff_emu_flf_p1_out :  OUT  STD_LOGIC;
		ff_emu_flf_p2_out :  OUT  STD_LOGIC;
		ff_emu_flf_e1_out :  OUT  STD_LOGIC;
		ff_emu_flf_e2_out :  OUT  STD_LOGIC;
		ff_emu_vlf_e1_out :  OUT  STD_LOGIC;
		ff_emu_vlf_e2_out :  OUT  STD_LOGIC;
		ff_emu_vlf_e3_out :  OUT  STD_LOGIC;
		ff_emu_vlf_ta1_out :  OUT  STD_LOGIC;
		ff_emu_vlf_ta2_out :  OUT  STD_LOGIC;
		ff_emu_vlf_ta3_out :  OUT  STD_LOGIC;
		ff_emu_vlf_tb1_out :  OUT  STD_LOGIC;
		ff_emu_vlf_tb2_out :  OUT  STD_LOGIC;
		
	
      ff_emu_rx_token : OUT STD_LOGIC;
      dmb_rx_token : OUT STD_LOGIC;
      vlf_dv : OUT STD_LOGIC;
      flf_dv : OUT STD_LOGIC;
      rx_sync : OUT STD_LOGIC;
      rx_resync : OUT STD_LOGIC;
      clk_cmos : OUT STD_LOGIC;
	
      reset : INOUT STD_LOGIC;
      rx_rec_clk : INOUT STD_LOGIC;
      serial_dat_to_dcfeb : INOUT STD_LOGIC;
      serial_data_from_dcfeb : INOUT STD_LOGIC;
      test_tkn_tx : INOUT STD_LOGIC
	);
END FF_EMU_PAIR_SIM;

ARCHITECTURE ff_emu_sim_arch OF FF_EMU_PAIR_SIM IS 


COMPONENT tkn_tx is 
PORT
	(clk: IN STD_LOGIC;
   	 reset: IN STD_LOGIC;
   	 enable: IN STD_LOGIC;
   	 token_out : OUT STD_LOGIC
   	 );
end COMPONENT;


COMPONENT ff_rx_enable_gen
GENERIC (speed_ind : INTEGER
			);
	PORT(clk_rx : IN STD_LOGIC;
		 clk_ref_rx_rec : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 ff_rx_enable : OUT STD_LOGIC
	);
END COMPONENT;


COMPONENT ff_emu_emu
	PORT(rx_clk : IN STD_LOGIC;
		 tx_clk : IN STD_LOGIC;
		 reset : IN STD_LOGIC;
		 rx_dat : IN STD_LOGIC;
		 clk_ref : IN STD_LOGIC;
		 rx_clk_en : IN STD_LOGIC;
		 vlf_e1_in : IN STD_LOGIC;
		 vlf_e2_in : IN STD_LOGIC;
		 vlf_e3_in : IN STD_LOGIC;
		 vlf_ta1_in : IN STD_LOGIC;
		 vlf_ta2_in : IN STD_LOGIC;
		 vlf_ta3_in : IN STD_LOGIC;
		 vlf_tb1_in : IN STD_LOGIC;
		 vlf_tb2_in : IN STD_LOGIC;
		 flf_p1_in : IN STD_LOGIC;
		 flf_p2_in : IN STD_LOGIC;
		 flf_e1_in : IN STD_LOGIC;
		 flf_e2_in : IN STD_LOGIC;
		 tx_tkn : IN STD_LOGIC;
		 tx_scl : IN STD_LOGIC;
		 tx_sda : IN STD_LOGIC;
		 reg_init : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
		 ta_delay : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tb_delay : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		 tx_dat : OUT STD_LOGIC;
		 rx_rec_clk : OUT STD_LOGIC;
		 rx_sync : OUT STD_LOGIC;
		 rx_resync : OUT STD_LOGIC;
		 vlf_e1_out : OUT STD_LOGIC;
		 vlf_e2_out : OUT STD_LOGIC;
		 vlf_e3_out : OUT STD_LOGIC;
		 vlf_ta1_out : OUT STD_LOGIC;
		 vlf_ta2_out : OUT STD_LOGIC;
		 vlf_ta3_out : OUT STD_LOGIC;
		 vlf_tb1_out : OUT STD_LOGIC;
		 vlf_tb2_out : OUT STD_LOGIC;
		 flf_p1_out : OUT STD_LOGIC;
		 flf_p2_out : OUT STD_LOGIC;
		 flf_e2_out : OUT STD_LOGIC;
		 flf_e1_out : OUT STD_LOGIC;
		 vlf_dv : OUT STD_LOGIC;
		 flf_dv : OUT STD_LOGIC;
		 rx_scl : OUT STD_LOGIC;
		 rx_tkn : OUT STD_LOGIC;
		 rx_sda : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT ff_emu IS 
	PORT
	(
		flf_p1_in :  IN  STD_LOGIC;
		flf_p2_in :  IN  STD_LOGIC;
		flf_e1_in :  IN  STD_LOGIC;
		flf_e2_in :  IN  STD_LOGIC;
		vlf_e1_in :  IN  STD_LOGIC;
		vlf_e2_in :  IN  STD_LOGIC;
		vlf_e3_in :  IN  STD_LOGIC;
		vlf_ta1_in :  IN  STD_LOGIC;
		vlf_ta2_in :  IN  STD_LOGIC;
		vlf_ta3_in :  IN  STD_LOGIC;
		vlf_tb1_in :  IN  STD_LOGIC;
		vlf_tb2_in :  IN  STD_LOGIC;
		flf_p1_out :  OUT  STD_LOGIC;
		flf_p2_out :  OUT  STD_LOGIC;
		flf_e1_out :  OUT  STD_LOGIC;
		flf_e2_out :  OUT  STD_LOGIC;
		vlf_e1_out :  OUT  STD_LOGIC;
		vlf_e2_out :  OUT  STD_LOGIC;
		vlf_e3_out :  OUT  STD_LOGIC;
		vlf_ta1_out :  OUT  STD_LOGIC;
		vlf_ta2_out :  OUT  STD_LOGIC;
		vlf_ta3_out :  OUT  STD_LOGIC;
		vlf_tb1_out :  OUT  STD_LOGIC;
		vlf_tb2_out :  OUT  STD_LOGIC;
		clk_ref :  IN  STD_LOGIC;
		rx_clk :  IN  STD_LOGIC;
		rx_dat :  IN  STD_LOGIC;
		tx_dat :  OUT  STD_LOGIC;
		msel0 :  IN  STD_LOGIC;
		msel1 :  IN  STD_LOGIC;
		msel2 :  IN  STD_LOGIC;
		reset :  IN  STD_LOGIC;
		token :  OUT  STD_LOGIC;
		clk_cmos :  OUT  STD_LOGIC
	);
END COMPONENT;


SIGNAL	reg_init :  STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL	ta_delay :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	tb_delay :  STD_LOGIC_VECTOR(7 DOWNTO 0);


signal   rx_clk_en : STD_LOGIC;
signal   ul_i2c_scl : STD_LOGIC;
signal   ul_i2c_sda : STD_LOGIC;
signal msel0: std_logic := '0';
signal msel1: std_logic := '0';
signal msel2: std_logic := '0';


BEGIN 

--
-- bgb added power on reset
--
   SRL16E_inst : SRL16E
   generic map (
      INIT => X"FFFF")
   port map (
      Q => reset,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => clk40,   -- Clock input
      D => '0'        -- SRL data input
   );




-- FF-LYNX modules

-- Settings
	reg_init <= "000000000";
	ta_delay <= "00000010";
	tb_delay <= "00000010";


-- TKN Test

b2v_tkn_tx : tkn_tx
PORT MAP (
	clk => clk40,
   reset => reset,
   enable => tkn_tx_enable,
   token_out => test_tkn_tx);

b2v_dcfeb1_eg : ff_rx_enable_gen
GENERIC MAP(speed_ind => 3
			)
PORT MAP(
		 clk_rx => clk320,
 		 clk_ref_rx_rec => rx_rec_clk,
		 reset => reset,
		 ff_rx_enable => rx_clk_en);

b2v_dcfeb1_ff : ff_emu_emu
PORT MAP(
		 tx_clk => clk320,
--	bgb	 rx_clk => dcfeb1_clk320_rx,
		 rx_clk => clk320,
		 reset => reset,
		 rx_dat => serial_data_from_dcfeb,
		 clk_ref => clk40,
		 rx_clk_en => rx_clk_en,
		 
		 flf_p1_in => dmb_flf_p1_in,
		 flf_p2_in => dmb_flf_p2_in,
		 flf_e1_in => dmb_flf_e1_in,
		 flf_e2_in => dmb_flf_e2_in,
		 vlf_e1_in => dmb_vlf_e1_in,
		 vlf_e2_in => dmb_vlf_e2_in,
		 vlf_e3_in => dmb_vlf_e3_in,
		 vlf_ta1_in => dmb_vlf_ta1_in,
		 vlf_ta2_in => dmb_vlf_ta2_in,
		 vlf_ta3_in => dmb_vlf_ta3_in,
		 vlf_tb1_in => dmb_vlf_tb1_in,
		 vlf_tb2_in => dmb_vlf_tb2_in,
		 tx_tkn => test_tkn_tx,
		 tx_scl => '0',
		 tx_sda => '0',
		 
		 reg_init => reg_init,
		 ta_delay => ta_delay,
		 tb_delay => tb_delay,
		 
		 tx_dat => serial_dat_to_dcfeb,
		 rx_rec_clk => rx_rec_clk,
		 
		 flf_p1_out => dmb_flf_p1_out,
		 flf_p2_out => dmb_flf_p2_out,
		 flf_e1_out => dmb_flf_e1_out,
		 flf_e2_out => dmb_flf_e2_out,
		 vlf_e1_out => dmb_vlf_e1_out,
		 vlf_e2_out => dmb_vlf_e2_out,
		 vlf_e3_out => dmb_vlf_e3_out,
		 vlf_ta1_out => dmb_vlf_ta1_out,
		 vlf_ta2_out => dmb_vlf_ta2_out,
		 vlf_ta3_out => dmb_vlf_ta3_out,
		 vlf_tb1_out => dmb_vlf_tb1_out,
       vlf_tb2_out => dmb_vlf_tb2_out,
		 
       rx_tkn => dmb_rx_token,
		 rx_scl => ul_i2c_scl,
		 rx_sda => ul_i2c_sda,
       vlf_dv => vlf_dv,
       flf_dv => flf_dv,
		 rx_sync => rx_sync,
		 rx_resync => rx_resync);


PMAP_FF_EMU: ff_emu
  port map (
		flf_p1_in => ff_emu_flf_p1_in,
		flf_p2_in => ff_emu_flf_p2_in,
		flf_e1_in => ff_emu_flf_e1_in,
		flf_e2_in => ff_emu_flf_e2_in,
		vlf_e1_in => ff_emu_vlf_e1_in,
		vlf_e2_in => ff_emu_vlf_e2_in,
		vlf_e3_in => ff_emu_vlf_e3_in,
		vlf_ta1_in => ff_emu_vlf_ta1_in,
		vlf_ta2_in => ff_emu_vlf_ta2_in,
		vlf_ta3_in => ff_emu_vlf_ta3_in,
		vlf_tb1_in => ff_emu_vlf_tb1_in,
		vlf_tb2_in => ff_emu_vlf_tb2_in,
		
		flf_p1_out => ff_emu_flf_p1_out,
		flf_p2_out => ff_emu_flf_p2_out,
		flf_e1_out => ff_emu_flf_e1_out,
		flf_e2_out => ff_emu_flf_e2_out,
		vlf_e1_out => ff_emu_vlf_e1_out,
		vlf_e2_out => ff_emu_vlf_e2_out,
		vlf_e3_out => ff_emu_vlf_e3_out,
		vlf_ta1_out => ff_emu_vlf_ta1_out,
		vlf_ta2_out => ff_emu_vlf_ta2_out,
		vlf_ta3_out => ff_emu_vlf_ta3_out,
		vlf_tb1_out => ff_emu_vlf_tb1_out,
		vlf_tb2_out => ff_emu_vlf_tb2_out,
		clk_ref => clk40,
		rx_clk => clk320,
		rx_dat => serial_dat_to_dcfeb,
		tx_dat => serial_data_from_dcfeb,
		msel0 => msel0,
		msel1 => msel1,
		msel2 => msel2,
		reset => reset,
		token => ff_emu_rx_token,
		clk_cmos => clk_cmos
    );


END ff_emu_sim_arch;