LIBRARY ieee;
use IEEE.STD_LOGIC_UNSIGNED.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_1164.all;

--  Entity Declaration

ENTITY flf_mux IS
	PORT
	(

		flf_p1_tx_tm : IN STD_LOGIC;
		flf_p2_tx_tm : IN STD_LOGIC;
		flf_e1_tx_tm : IN STD_LOGIC;
		flf_e2_tx_tm : IN STD_LOGIC;
		flf_p1_tx_rm : IN STD_LOGIC;
		flf_p2_tx_rm : IN STD_LOGIC;
		flf_e1_tx_rm : IN STD_LOGIC;
		flf_e2_tx_rm : IN STD_LOGIC;
		flf_tm_en : IN STD_LOGIC;
		flf_p1_tx : OUT STD_LOGIC;
		flf_p2_tx : OUT STD_LOGIC;
		flf_e1_tx : OUT STD_LOGIC;
		flf_e2_tx : OUT STD_LOGIC
	);
	
END flf_mux;


--  Architecture Body

ARCHITECTURE flf_mux_architecture OF flf_mux IS


begin

flf_mux_proc : process(flf_p1_tx_tm,flf_p2_tx_tm,flf_e1_tx_tm,flf_e2_tx_tm,
							  flf_p1_tx_rm,flf_p2_tx_rm,flf_e1_tx_rm,flf_e2_tx_rm,flf_tm_en)

begin
      
	if (flf_tm_en = '1') then
		flf_p1_tx <= flf_p1_tx_tm;
		flf_p2_tx <= flf_p2_tx_tm;
		flf_e1_tx <= flf_e1_tx_tm;
		flf_e2_tx <= flf_e2_tx_tm;
	else
		flf_p1_tx <= flf_p1_tx_rm;
		flf_p2_tx <= flf_p2_tx_rm;
		flf_e1_tx <= flf_e1_tx_rm;
		flf_e2_tx <= flf_e2_tx_rm;
	end if;

end process;

END flf_mux_architecture;
